// @license magnet:?xt=urn:btih:87f119ba0b429ba17a44b4bffcab33165ebdacc0&dn=freebsd.txt BSD-2-Clause
(function(d) {
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function e(e) {
        return e.split("");
    }
    function be(e, n) {
        return n.indexOf(e) >= 0;
    }
    function te(e, n) {
        for (var t = n.length; --t >= 0; ) if (e(n[t])) return n[t];
    }
    function Q(e, n) {
        if (n <= 0) return "";
        if (n == 1) return e;
        var t = Q(e, n >> 1);
        t += t;
        return n & 1 ? t + e : t;
    }
    function n(e) {
        Object.defineProperty(e.prototype, "stack", {
            get: function() {
                var e = new Error(this.message);
                e.name = this.name;
                try {
                    throw e;
                } catch (e) {
                    return e.stack;
                }
            }
        });
    }
    function r(e, n) {
        this.message = e;
        this.defs = n;
    }
    r.prototype = Object.create(Error.prototype);
    r.prototype.constructor = r;
    r.prototype.name = "DefaultsError";
    n(r);
    function ie(e, n, t) {
        if (t) for (var i in e) {
            if (fe(e, i) && !fe(n, i)) throw new r("`" + i + "` is not a supported option", n);
        }
        for (var i in e) {
            if (fe(e, i)) n[i] = e[i];
        }
        return n;
    }
    function t(e, n) {
        var t = 0;
        for (var i in n) if (fe(n, i)) {
            e[i] = n[i];
            t++;
        }
        return t;
    }
    function re() {}
    function ye() {
        return false;
    }
    function oe() {
        return true;
    }
    function R() {
        return this;
    }
    function I() {
        return null;
    }
    var we = function() {
        function e(t, i, r) {
            var o = [], a = [], s;
            function e() {
                var e = i(t[s], s);
                var n = e instanceof l;
                if (n) e = e.v;
                if (e instanceof u) {
                    e = e.v;
                    if (e instanceof c) {
                        a.push.apply(a, r ? e.v.slice().reverse() : e.v);
                    } else {
                        a.push(e);
                    }
                } else if (e !== f) {
                    if (e instanceof c) {
                        o.push.apply(o, r ? e.v.slice().reverse() : e.v);
                    } else {
                        o.push(e);
                    }
                }
                return n;
            }
            if (Array.isArray(t)) {
                if (r) {
                    for (s = t.length; --s >= 0; ) if (e()) break;
                    o.reverse();
                    a.reverse();
                } else {
                    for (s = 0; s < t.length; ++s) if (e()) break;
                }
            } else {
                for (s in t) if (fe(t, s)) if (e()) break;
            }
            return a.concat(o);
        }
        e.is_op = function(e) {
            return e === f || e instanceof u || e instanceof l || e instanceof c;
        };
        e.at_top = function(e) {
            return new u(e);
        };
        e.splice = function(e) {
            return new c(e);
        };
        e.last = function(e) {
            return new l(e);
        };
        var f = e.skip = {};
        function u(e) {
            this.v = e;
        }
        function c(e) {
            this.v = e;
        }
        function l(e) {
            this.v = e;
        }
        return e;
    }();
    function v(e, n) {
        if (e.indexOf(n) < 0) return e.push(n);
    }
    function ae(e, t) {
        return e.replace(/\{(.+?)\}/g, function(e, n) {
            return t && t[n];
        });
    }
    function xe(e, n) {
        var t = e.indexOf(n);
        if (t >= 0) e.splice(t, 1);
    }
    function se(e) {
        if (!Array.isArray(e)) e = e.split(" ");
        var n = Object.create(null);
        e.forEach(function(e) {
            n[e] = true;
        });
        return n;
    }
    function Ee(e, n) {
        for (var t = e.length; --t >= 0; ) if (!n(e[t], t)) return false;
        return true;
    }
    function Ae() {
        this._values = Object.create(null);
        this._size = 0;
    }
    Ae.prototype = {
        set: function(e, n) {
            if (!this.has(e)) ++this._size;
            this._values["$" + e] = n;
            return this;
        },
        add: function(e, n) {
            if (this.has(e)) {
                this.get(e).push(n);
            } else {
                this.set(e, [ n ]);
            }
            return this;
        },
        get: function(e) {
            return this._values["$" + e];
        },
        del: function(e) {
            if (this.has(e)) {
                --this._size;
                delete this._values["$" + e];
            }
            return this;
        },
        has: function(e) {
            return "$" + e in this._values;
        },
        all: function(e) {
            for (var n in this._values) if (!e(this._values[n], n.substr(1))) return false;
            return true;
        },
        each: function(e) {
            for (var n in this._values) e(this._values[n], n.substr(1));
        },
        size: function() {
            return this._size;
        },
        map: function(e) {
            var n = [];
            for (var t in this._values) n.push(e(this._values[t], t.substr(1)));
            return n;
        },
        clone: function() {
            var e = new Ae();
            for (var n in this._values) e._values[n] = this._values[n];
            e._size = this._size;
            return e;
        },
        toObject: function() {
            return this._values;
        }
    };
    Ae.fromObject = function(e) {
        var n = new Ae();
        n._size = t(n._values, e);
        return n;
    };
    function fe(e, n) {
        return Object.prototype.hasOwnProperty.call(e, n);
    }
    function ke(e) {
        var n = e.parent(-1);
        for (var t = 0, i; i = e.parent(t++); n = i) {
            if (i.TYPE == "Call") {
                if (i.expression === n) continue;
            } else if (i instanceof En) {
                if (i.left === n) continue;
            } else if (i instanceof An) {
                if (i.condition === n) continue;
            } else if (i instanceof mn) {
                if (i.expression === n) continue;
            } else if (i instanceof _n) {
                if (i.expressions[0] === n) continue;
            } else if (i instanceof Fe) {
                return i.body === n;
            } else if (i instanceof xn) {
                if (i.expression === n) continue;
            }
            return false;
        }
    }
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function i(e, n, t, i) {
        if (typeof i === "undefined") i = De;
        n = n ? n.split(/\s+/) : [];
        var r = n;
        if (i && i.PROPS) n = n.concat(i.PROPS);
        var o = [ "return function AST_", e, "(props){", "if(props){" ];
        n.forEach(function(e) {
            o.push("this.", e, "=props.", e, ";");
        });
        var a = i && new i();
        if (a && a.initialize || t && t.initialize) o.push("this.initialize();");
        o.push("}}");
        var s = new Function(o.join(""))();
        if (a) {
            s.prototype = a;
            s.BASE = i;
        }
        if (i) i.SUBCLASSES.push(s);
        s.prototype.CTOR = s;
        s.PROPS = n || null;
        s.SELF_PROPS = r;
        s.SUBCLASSES = [];
        if (e) {
            s.prototype.TYPE = s.TYPE = e;
        }
        if (t) for (var f in t) if (fe(t, f)) {
            if (/^\$/.test(f)) {
                s[f.substr(1)] = t[f];
            } else {
                s.prototype[f] = t[f];
            }
        }
        s.DEFMETHOD = function(e, n) {
            this.prototype[e] = n;
        };
        if (typeof d !== "undefined") {
            d["AST_" + e] = s;
        }
        return s;
    }
    var Z = i("Token", "type value line col pos endline endcol endpos nlb comments_before comments_after file raw", {}, null);
    var De = i("Node", "start end", {
        _clone: function(e) {
            if (e) {
                var n = this.clone();
                return n.transform(new at(function(e) {
                    if (e !== n) {
                        return e.clone(true);
                    }
                }));
            }
            return new this.CTOR(this);
        },
        clone: function(e) {
            return this._clone(e);
        },
        $documentation: "Base class of all AST nodes",
        $propdoc: {
            start: "[AST_Token] The first token of this node",
            end: "[AST_Token] The last token of this node"
        },
        walk: function(e) {
            e.visit(this);
        },
        _validate: re,
        validate: function() {
            var e = this.CTOR;
            do {
                e.prototype._validate.call(this);
            } while (e = e.BASE);
        }
    }, null);
    (De.log_function = function(n, e) {
        var t = Object.create(null);
        if (n) {
            De.info = e ? function(e, n) {
                i("INFO: " + ae(e, n));
            } : re;
            De.warn = function(e, n) {
                i("WARN: " + ae(e, n));
            };
        } else {
            De.info = De.warn = re;
        }
        function i(e) {
            if (t[e]) return;
            t[e] = true;
            n(e);
        }
    })();
    var o = [];
    De.enable_validation = function() {
        De.disable_validation();
        (function e(n) {
            var i = n.prototype.transform;
            n.prototype.transform = function(e, n) {
                var t = i.call(this, e, n);
                if (t instanceof De) {
                    t.validate();
                } else if (!(t === null || n && we.is_op(t))) {
                    throw new Error("invalid transformed value: " + t);
                }
                return t;
            };
            o.push(function() {
                n.prototype.transform = i;
            });
            n.SUBCLASSES.forEach(e);
        })(this);
    };
    De.disable_validation = function() {
        var e;
        while (e = o.pop()) e();
    };
    var Fe = i("Statement", null, {
        $documentation: "Base class of all statements"
    });
    var Ce = i("Debugger", null, {
        $documentation: "Represents a debugger statement"
    }, Fe);
    var Be = i("Directive", "value quote", {
        $documentation: 'Represents a directive, like "use strict";',
        $propdoc: {
            value: "[string] The value of this directive as a plain string (it's not an AST_String!)",
            quote: "[string] the original quote character"
        },
        _validate: function() {
            if (typeof this.value != "string") throw new Error("value must be string");
        }
    }, Fe);
    function a(e, n) {
        if (!(e[n] instanceof De)) throw new Error(n + " must be AST_Node");
        if (e[n] instanceof Fe && !(e[n] instanceof We)) {
            throw new Error(n + " cannot be AST_Statement");
        }
    }
    var Se = i("SimpleStatement", "body", {
        $documentation: "A statement consisting of an expression, i.e. a = 1 + 2",
        $propdoc: {
            body: "[AST_Node] an expression node (should not be instanceof AST_Statement)"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.body.walk(e);
            });
        },
        _validate: function() {
            a(this, "body");
        }
    }, Fe);
    function Te(e, n) {
        e.body.forEach(function(e) {
            e.walk(n);
        });
    }
    var Oe = i("Block", "body", {
        $documentation: "A body of statements (usually braced)",
        $propdoc: {
            body: "[AST_Statement*] an array of statements"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                Te(n, e);
            });
        },
        _validate: function() {
            this.body.forEach(function(e) {
                if (!(e instanceof Fe)) throw new Error("body must be AST_Statement[]");
                if (e instanceof We) throw new Error("body cannot contain AST_Function");
            });
        }
    }, Fe);
    var ze = i("BlockStatement", null, {
        $documentation: "A block statement"
    }, Oe);
    var $e = i("EmptyStatement", null, {
        $documentation: "The empty statement (empty block or simply a semicolon)"
    }, Fe);
    var _ = i("StatementWithBody", "body", {
        $documentation: "Base class for all statements that contain one nested body: `For`, `ForIn`, `Do`, `While`, `With`",
        $propdoc: {
            body: "[AST_Statement] the body; this should always be present, even if it's an AST_EmptyStatement"
        },
        _validate: function() {
            if (!(this.body instanceof Fe)) throw new Error("body must be AST_Statement");
            if (this.body instanceof We) throw new Error("body cannot be AST_Function");
        }
    }, Fe);
    var Me = i("LabeledStatement", "label", {
        $documentation: "Statement with a label",
        $propdoc: {
            label: "[AST_Label] a label definition"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.label.walk(e);
                n.body.walk(e);
            });
        },
        clone: function(e) {
            var n = this._clone(e);
            if (e) {
                var t = n.label;
                var i = this.label;
                n.walk(new Kn(function(e) {
                    if (e instanceof Ze && e.label && e.label.thedef === i) {
                        e.label.thedef = t;
                        t.references.push(e);
                    }
                }));
            }
            return n;
        },
        _validate: function() {
            if (!(this.label instanceof pe)) throw new Error("label must be AST_Label");
        }
    }, _);
    var qe = i("IterationStatement", null, {
        $documentation: "Internal class.  All loops inherit from it."
    }, _);
    var je = i("DWLoop", "condition", {
        $documentation: "Base class for do/while statements",
        $propdoc: {
            condition: "[AST_Node] the loop condition.  Should not be instanceof AST_Statement"
        },
        _validate: function() {
            a(this, "condition");
        }
    }, qe);
    var He = i("Do", null, {
        $documentation: "A `do` statement",
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.body.walk(e);
                n.condition.walk(e);
            });
        }
    }, je);
    var Ne = i("While", null, {
        $documentation: "A `while` statement",
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.condition.walk(e);
                n.body.walk(e);
            });
        }
    }, je);
    var Pe = i("For", "init condition step", {
        $documentation: "A `for` statement",
        $propdoc: {
            init: "[AST_Node?] the `for` initialization code, or null if empty",
            condition: "[AST_Node?] the `for` termination clause, or null if empty",
            step: "[AST_Node?] the `for` update clause, or null if empty"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.init) n.init.walk(e);
                if (n.condition) n.condition.walk(e);
                if (n.step) n.step.walk(e);
                n.body.walk(e);
            });
        },
        _validate: function() {
            if (this.init != null) {
                if (!(this.init instanceof De)) throw new Error("init must be AST_Node");
                if (this.init instanceof Fe && !(this.init instanceof ln || this.init instanceof We)) {
                    throw new Error("init cannot be AST_Statement");
                }
            }
            if (this.condition != null) a(this, "condition");
            if (this.step != null) a(this, "step");
        }
    }, qe);
    var Re = i("ForIn", "init object", {
        $documentation: "A `for ... in` statement",
        $propdoc: {
            init: "[AST_Node] the `for/in` initialization code",
            object: "[AST_Node] the object that we're looping through"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.init.walk(e);
                n.object.walk(e);
                n.body.walk(e);
            });
        },
        _validate: function() {
            if (this.init instanceof ln) {
                if (this.init.definitions.length != 1) throw new Error("init must have single declaration");
            } else if (!(this.init instanceof mn || this.init instanceof jn)) {
                throw new Error("init must be assignable");
            }
            a(this, "object");
        }
    }, qe);
    var Ie = i("With", "expression", {
        $documentation: "A `with` statement",
        $propdoc: {
            expression: "[AST_Node] the `with` expression"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                n.body.walk(e);
            });
        },
        _validate: function() {
            a(this, "expression");
        }
    }, _);
    var Ue = i("Scope", "variables functions uses_with uses_eval parent_scope enclosed cname", {
        $documentation: "Base class for all statements introducing a lexical scope",
        $propdoc: {
            variables: "[Object/S] a map of name -> SymbolDef for all variables/functions defined in this scope",
            functions: "[Object/S] like `variables`, but only lists function declarations",
            uses_with: "[boolean/S] tells whether this scope uses the `with` statement",
            uses_eval: "[boolean/S] tells whether this scope contains a direct call to the global `eval`",
            parent_scope: "[AST_Scope?/S] link to the parent scope",
            enclosed: "[SymbolDef*/S] a list of all symbol definitions that are accessed from this scope or any subscopes",
            cname: "[integer/S] current index for mangling variables (used internally by the mangler)"
        },
        clone: function(e) {
            var n = this._clone(e);
            if (this.variables) n.variables = this.variables.clone();
            if (this.functions) n.functions = this.functions.clone();
            if (this.enclosed) n.enclosed = this.enclosed.slice();
            return n;
        },
        pinned: function() {
            return this.uses_eval || this.uses_with;
        },
        _validate: function() {
            if (this.parent_scope != null) {
                if (!(this.parent_scope instanceof Ue)) throw new Error("parent_scope must be AST_Scope");
            }
        }
    }, Oe);
    var Ye = i("Toplevel", "globals", {
        $documentation: "The toplevel scope",
        $propdoc: {
            globals: "[Object/S] a map of name -> SymbolDef for all undeclared names"
        },
        wrap: function(e) {
            var n = this.body;
            return ot([ "(function(exports){'$ORIG';})(typeof ", e, "=='undefined'?(", e, "={}):", e, ");" ].join(""), {
                filename: "wrap=" + JSON.stringify(e)
            }).transform(new at(function(e) {
                if (e instanceof Be && e.value == "$ORIG") {
                    return we.splice(n);
                }
            }));
        },
        enclose: function(e) {
            if (typeof e != "string") e = "";
            var n = e.indexOf(":");
            if (n < 0) n = e.length;
            var t = this.body;
            return ot([ "(function(", e.slice(0, n), '){"$ORIG"})(', e.slice(n + 1), ")" ].join(""), {
                filename: "enclose=" + JSON.stringify(e)
            }).transform(new at(function(e) {
                if (e instanceof Be && e.value == "$ORIG") {
                    return we.splice(t);
                }
            }));
        }
    }, Ue);
    var Le = i("Lambda", "name argnames uses_arguments length_read", {
        $documentation: "Base class for functions",
        $propdoc: {
            name: "[AST_SymbolDeclaration?] the name of this function",
            argnames: "[AST_SymbolFunarg*] array of function arguments",
            uses_arguments: "[boolean/S] tells whether this function accesses the arguments array"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                if (e.name) e.name.walk(n);
                e.argnames.forEach(function(e) {
                    e.walk(n);
                });
                Te(e, n);
            });
        },
        _validate: function() {
            this.argnames.forEach(function(e) {
                if (!(e instanceof zn)) throw new Error("argnames must be AST_SymbolFunarg[]");
            });
        }
    }, Ue);
    var Ve = i("Accessor", null, {
        $documentation: "A setter/getter function.  The `name` property is always null.",
        _validate: function() {
            if (this.name != null) throw new Error("name must be null");
        }
    }, Le);
    var We = i("Function", "inlined", {
        $documentation: "A function expression",
        _validate: function() {
            if (this.name != null) {
                if (!(this.name instanceof Mn)) throw new Error("name must be AST_SymbolLambda");
            }
        }
    }, Le);
    var Je = i("Defun", "inlined", {
        $documentation: "A function definition",
        _validate: function() {
            if (!(this.name instanceof $n)) throw new Error("name must be AST_SymbolDefun");
        }
    }, Le);
    var Ge = i("Jump", null, {
        $documentation: "Base class for “jumps” (for now that's `return`, `throw`, `break` and `continue`)"
    }, Fe);
    var Xe = i("Exit", "value", {
        $documentation: "Base class for “exits” (`return` and `throw`)",
        $propdoc: {
            value: "[AST_Node?] the value returned or thrown by this statement; could be null for AST_Return"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.value) n.value.walk(e);
            });
        }
    }, Ge);
    var Ke = i("Return", null, {
        $documentation: "A `return` statement",
        _validate: function() {
            if (this.value != null) a(this, "value");
        }
    }, Xe);
    var Qe = i("Throw", null, {
        $documentation: "A `throw` statement",
        _validate: function() {
            a(this, "value");
        }
    }, Xe);
    var Ze = i("LoopControl", "label", {
        $documentation: "Base class for loop control statements (`break` and `continue`)",
        $propdoc: {
            label: "[AST_LabelRef?] the label, or null if none"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.label) n.label.walk(e);
            });
        },
        _validate: function() {
            if (this.label != null) {
                if (!(this.label instanceof he)) throw new Error("label must be AST_LabelRef");
            }
        }
    }, Ge);
    var en = i("Break", null, {
        $documentation: "A `break` statement"
    }, Ze);
    var nn = i("Continue", null, {
        $documentation: "A `continue` statement"
    }, Ze);
    var tn = i("If", "condition alternative", {
        $documentation: "A `if` statement",
        $propdoc: {
            condition: "[AST_Node] the `if` condition",
            alternative: "[AST_Statement?] the `else` part, or null if not present"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.condition.walk(e);
                n.body.walk(e);
                if (n.alternative) n.alternative.walk(e);
            });
        },
        _validate: function() {
            a(this, "condition");
            if (this.alternative != null) {
                if (!(this.alternative instanceof Fe)) throw new Error("alternative must be AST_Statement");
                if (this.alternative instanceof We) throw new error("alternative cannot be AST_Function");
            }
        }
    }, _);
    var rn = i("Switch", "expression", {
        $documentation: "A `switch` statement",
        $propdoc: {
            expression: "[AST_Node] the `switch` “discriminant”"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                Te(n, e);
            });
        },
        _validate: function() {
            a(this, "expression");
        }
    }, Oe);
    var on = i("SwitchBranch", null, {
        $documentation: "Base class for `switch` branches"
    }, Oe);
    var an = i("Default", null, {
        $documentation: "A `default` switch branch"
    }, on);
    var sn = i("Case", "expression", {
        $documentation: "A `case` switch branch",
        $propdoc: {
            expression: "[AST_Node] the `case` expression"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                Te(n, e);
            });
        },
        _validate: function() {
            a(this, "expression");
        }
    }, on);
    var fn = i("Try", "bcatch bfinally", {
        $documentation: "A `try` statement",
        $propdoc: {
            bcatch: "[AST_Catch?] the catch block, or null if not present",
            bfinally: "[AST_Finally?] the finally block, or null if not present"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                Te(n, e);
                if (n.bcatch) n.bcatch.walk(e);
                if (n.bfinally) n.bfinally.walk(e);
            });
        },
        _validate: function() {
            if (this.bcatch != null) {
                if (!(this.bcatch instanceof un)) throw new Error("bcatch must be AST_Catch");
            }
            if (this.bfinally != null) {
                if (!(this.bfinally instanceof cn)) throw new Error("bfinally must be AST_Finally");
            }
        }
    }, Oe);
    var un = i("Catch", "argname", {
        $documentation: "A `catch` node; only makes sense as part of a `try` statement",
        $propdoc: {
            argname: "[AST_SymbolCatch] symbol for the exception"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.argname.walk(e);
                Te(n, e);
            });
        },
        _validate: function() {
            if (!(this.argname instanceof qn)) throw new Error("argname must be AST_SymbolCatch");
        }
    }, Oe);
    var cn = i("Finally", null, {
        $documentation: "A `finally` node; only makes sense as part of a `try` statement"
    }, Oe);
    var ln = i("Definitions", "definitions", {
        $documentation: "Base class for `var` nodes (variable declarations/initializations)",
        $propdoc: {
            definitions: "[AST_VarDef*] array of variable definitions"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.definitions.forEach(function(e) {
                    e.walk(n);
                });
            });
        }
    }, Fe);
    var pn = i("Var", null, {
        $documentation: "A `var` statement",
        _validate: function() {
            this.definitions.forEach(function(e) {
                if (!(e instanceof hn)) throw new Error("definitions must be AST_VarDef[]");
            });
        }
    }, ln);
    var hn = i("VarDef", "name value", {
        $documentation: "A variable declaration; only appears in a AST_Definitions node",
        $propdoc: {
            name: "[AST_SymbolVar] name of the variable",
            value: "[AST_Node?] initializer, or null of there's no initializer"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.name.walk(e);
                if (n.value) n.value.walk(e);
            });
        },
        _validate: function() {
            if (!(this.name instanceof On)) throw new Error("name must be AST_SymbolVar");
            if (this.value != null) a(this, "value");
        }
    });
    function s(e, n) {
        e[n].forEach(function(e) {
            if (!(e instanceof De)) throw new Error(n + " must be AST_Node[]");
            if (e instanceof Fe && !(e instanceof We)) {
                throw new Error(n + " cannot contain AST_Statement");
            }
        });
    }
    var dn = i("Call", "expression args pure", {
        $documentation: "A function call expression",
        $propdoc: {
            expression: "[AST_Node] expression to invoke as function",
            args: "[AST_Node*] array of arguments"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.expression.walk(n);
                e.args.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            a(this, "expression");
            s(this, "args");
        }
    });
    var vn = i("New", null, {
        $documentation: "An object instantiation.  Derives from a function call since it has exactly the same properties"
    }, dn);
    var _n = i("Sequence", "expressions", {
        $documentation: "A sequence expression (comma-separated expressions)",
        $propdoc: {
            expressions: "[AST_Node*] array of expressions (at least two)"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.expressions.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            if (this.expressions.length < 2) throw new Error("expressions must contain multiple elements");
            s(this, "expressions");
        }
    });
    var mn = i("PropAccess", "expression property", {
        $documentation: 'Base class for property access expressions, i.e. `a.foo` or `a["foo"]`',
        $propdoc: {
            expression: "[AST_Node] the “container” expression",
            property: "[AST_Node|string] the property to access.  For AST_Dot this is always a plain string, while for AST_Sub it's an arbitrary AST_Node"
        },
        getProperty: function() {
            var e = this.property;
            if (e instanceof Nn) {
                return e.value;
            }
            if (e instanceof wn && e.operator == "void" && e.expression instanceof Nn) {
                return;
            }
            return e;
        },
        _validate: function() {
            a(this, "expression");
        }
    });
    var gn = i("Dot", null, {
        $documentation: "A dotted property access expression",
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
            });
        },
        _validate: function() {
            if (typeof this.property != "string") throw new Error("property must be string");
        }
    }, mn);
    var bn = i("Sub", null, {
        $documentation: 'Index-style property access, i.e. `a["foo"]`',
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                n.property.walk(e);
            });
        },
        _validate: function() {
            a(this, "property");
        }
    }, mn);
    var yn = i("Unary", "operator expression", {
        $documentation: "Base class for unary expressions",
        $propdoc: {
            operator: "[string] the operator",
            expression: "[AST_Node] expression that this unary operator applies to"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
            });
        },
        _validate: function() {
            if (typeof this.operator != "string") throw new Error("operator must be string");
            a(this, "expression");
        }
    });
    var wn = i("UnaryPrefix", null, {
        $documentation: "Unary prefix expression, i.e. `typeof i` or `++i`"
    }, yn);
    var xn = i("UnaryPostfix", null, {
        $documentation: "Unary postfix expression, i.e. `i++`"
    }, yn);
    var En = i("Binary", "operator left right", {
        $documentation: "Binary expression, i.e. `a + b`",
        $propdoc: {
            left: "[AST_Node] left-hand side expression",
            operator: "[string] the operator",
            right: "[AST_Node] right-hand side expression"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.left.walk(e);
                n.right.walk(e);
            });
        },
        _validate: function() {
            a(this, "left");
            if (typeof this.operator != "string") throw new Error("operator must be string");
            a(this, "right");
        }
    });
    var An = i("Conditional", "condition consequent alternative", {
        $documentation: "Conditional expression using the ternary operator, i.e. `a ? b : c`",
        $propdoc: {
            condition: "[AST_Node]",
            consequent: "[AST_Node]",
            alternative: "[AST_Node]"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.condition.walk(e);
                n.consequent.walk(e);
                n.alternative.walk(e);
            });
        },
        _validate: function() {
            a(this, "condition");
            a(this, "consequent");
            a(this, "alternative");
        }
    });
    var kn = i("Assign", null, {
        $documentation: "An assignment expression — `a = b + 5`",
        _validate: function() {
            if (this.operator.indexOf("=") < 0) throw new Error('operator must contain "="');
        }
    }, En);
    var Dn = i("Array", "elements", {
        $documentation: "An array literal",
        $propdoc: {
            elements: "[AST_Node*] array of elements"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.elements.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            s(this, "elements");
        }
    });
    var Fn = i("Object", "properties", {
        $documentation: "An object literal",
        $propdoc: {
            properties: "[AST_ObjectProperty*] array of properties"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.properties.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            this.properties.forEach(function(e) {
                if (!(e instanceof Cn)) throw new Error("properties must be AST_ObjectProperty[]");
            });
        }
    });
    var Cn = i("ObjectProperty", "key value", {
        $documentation: "Base class for literal object properties",
        $propdoc: {
            key: "[string|AST_SymbolAccessor] property name. For ObjectKeyVal this is a string. For getters and setters this is an AST_SymbolAccessor.",
            value: "[AST_Node] property value.  For getters and setters this is an AST_Accessor."
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.value.walk(e);
            });
        }
    });
    var Bn = i("ObjectKeyVal", "quote", {
        $documentation: "A key: value object property",
        $propdoc: {
            quote: "[string] the original quote character"
        },
        _validate: function() {
            if (typeof this.key != "string") throw new Error("key must be string");
            a(this, "value");
        }
    }, Cn);
    var ue = i("ObjectSetter", null, {
        $documentation: "An object setter property",
        _validate: function() {
            if (!(this.key instanceof le)) throw new Error("key must be AST_SymbolAccessor");
            if (!(this.value instanceof Ve)) throw new Error("value must be AST_Accessor");
        }
    }, Cn);
    var ce = i("ObjectGetter", null, {
        $documentation: "An object getter property",
        _validate: function() {
            if (!(this.key instanceof le)) throw new Error("key must be AST_SymbolAccessor");
            if (!(this.value instanceof Ve)) throw new Error("value must be AST_Accessor");
        }
    }, Cn);
    var Sn = i("Symbol", "scope name thedef", {
        $propdoc: {
            name: "[string] name of this symbol",
            scope: "[AST_Scope/S] the current scope (not necessarily the definition scope)",
            thedef: "[SymbolDef/S] the definition of this symbol"
        },
        $documentation: "Base class for all symbols",
        _validate: function() {
            if (typeof this.name != "string") throw new Error("name must be string");
        }
    });
    var le = i("SymbolAccessor", null, {
        $documentation: "The name of a property accessor (setter/getter function)"
    }, Sn);
    var Tn = i("SymbolDeclaration", "init", {
        $documentation: "A declaration symbol (symbol in var, function name or argument, symbol in catch)"
    }, Sn);
    var On = i("SymbolVar", null, {
        $documentation: "Symbol defining a variable"
    }, Tn);
    var zn = i("SymbolFunarg", null, {
        $documentation: "Symbol naming a function argument"
    }, On);
    var $n = i("SymbolDefun", null, {
        $documentation: "Symbol defining a function"
    }, Tn);
    var Mn = i("SymbolLambda", null, {
        $documentation: "Symbol naming a function expression"
    }, Tn);
    var qn = i("SymbolCatch", null, {
        $documentation: "Symbol naming the exception in catch"
    }, Tn);
    var pe = i("Label", "references", {
        $documentation: "Symbol naming a label (declaration)",
        $propdoc: {
            references: "[AST_LoopControl*] a list of nodes referring to this label"
        },
        initialize: function() {
            this.references = [];
            this.thedef = this;
        }
    }, Sn);
    var jn = i("SymbolRef", "fixed", {
        $documentation: "Reference to some symbol (not definition/declaration)"
    }, Sn);
    var he = i("LabelRef", null, {
        $documentation: "Reference to a label symbol"
    }, Sn);
    var Hn = i("This", null, {
        $documentation: "The `this` symbol",
        _validate: function() {
            if (this.name !== "this") throw new Error('name must be "this"');
        }
    }, Sn);
    var Nn = i("Constant", null, {
        $documentation: "Base class for all constants"
    });
    var Pn = i("String", "value quote", {
        $documentation: "A string literal",
        $propdoc: {
            value: "[string] the contents of this string",
            quote: "[string] the original quote character"
        },
        _validate: function() {
            if (typeof this.value != "string") throw new Error("value must be string");
        }
    }, Nn);
    var Rn = i("Number", "value", {
        $documentation: "A number literal",
        $propdoc: {
            value: "[number] the numeric value"
        },
        _validate: function() {
            if (typeof this.value != "number") throw new Error("value must be number");
        }
    }, Nn);
    var In = i("RegExp", "value", {
        $documentation: "A regexp literal",
        $propdoc: {
            value: "[RegExp] the actual regexp"
        },
        _validate: function() {
            if (!(this.value instanceof RegExp)) throw new Error("value must be RegExp");
        }
    }, Nn);
    var m = i("Atom", null, {
        $documentation: "Base class for atoms"
    }, Nn);
    var Un = i("Null", null, {
        $documentation: "The `null` atom",
        value: null
    }, m);
    var Yn = i("NaN", null, {
        $documentation: "The impossible value",
        value: 0 / 0
    }, m);
    var Ln = i("Undefined", null, {
        $documentation: "The `undefined` value",
        value: function() {}()
    }, m);
    var Vn = i("Hole", null, {
        $documentation: "A hole in an array",
        value: function() {}()
    }, m);
    var Wn = i("Infinity", null, {
        $documentation: "The `Infinity` value",
        value: 1 / 0
    }, m);
    var Jn = i("Boolean", null, {
        $documentation: "Base class for booleans"
    }, m);
    var Gn = i("False", null, {
        $documentation: "The `false` atom",
        value: false
    }, Jn);
    var Xn = i("True", null, {
        $documentation: "The `true` atom",
        value: true
    }, Jn);
    function Kn(e) {
        this.callback = e;
        this.directives = Object.create(null);
        this.stack = [];
    }
    Kn.prototype = {
        visit: function(e, n) {
            this.push(e);
            var t = this.callback(e, n || re);
            if (!t && n) n();
            this.pop();
        },
        parent: function(e) {
            return this.stack[this.stack.length - 2 - (e || 0)];
        },
        push: function(e) {
            if (e instanceof Le) {
                this.directives = Object.create(this.directives);
            } else if (e instanceof Be && !this.directives[e.value]) {
                this.directives[e.value] = e;
            }
            this.stack.push(e);
        },
        pop: function() {
            if (this.stack.pop() instanceof Le) {
                this.directives = Object.getPrototypeOf(this.directives);
            }
        },
        self: function() {
            return this.stack[this.stack.length - 1];
        },
        find_parent: function(e) {
            var n = this.stack;
            for (var t = n.length; --t >= 0; ) {
                var i = n[t];
                if (i instanceof e) return i;
            }
        },
        has_directive: function(e) {
            var n = this.directives[e];
            if (n) return n;
            var t = this.stack[this.stack.length - 1];
            if (t instanceof Ue) {
                for (var i = 0; i < t.body.length; ++i) {
                    var r = t.body[i];
                    if (!(r instanceof Be)) break;
                    if (r.value == e) return r;
                }
            }
        },
        loopcontrol_target: function(e) {
            var n = this.stack;
            if (e.label) for (var t = n.length; --t >= 0; ) {
                var i = n[t];
                if (i instanceof Me && i.label.name == e.label.name) return i.body;
            } else for (var t = n.length; --t >= 0; ) {
                var i = n[t];
                if (i instanceof qe || e instanceof en && i instanceof rn) return i;
            }
        },
        in_boolean_context: function() {
            var e = this.self();
            for (var n = 0, t; t = this.parent(n); n++) {
                if (t instanceof An && t.condition === e || t instanceof je && t.condition === e || t instanceof Pe && t.condition === e || t instanceof tn && t.condition === e || t instanceof Ke && t.in_bool || t instanceof _n && t.tail_node() !== e || t instanceof Se || t instanceof wn && t.operator == "!" && t.expression === e) {
                    return true;
                }
                if (t instanceof En && (t.operator == "&&" || t.operator == "||") || t instanceof An || t.tail_node() === e) {
                    e = t;
                } else if (t instanceof Ke) {
                    var i;
                    do {
                        i = this.parent(++n);
                        if (!i) return false;
                    } while (!(i instanceof Le));
                    if (i.name) return false;
                    e = this.parent(++n);
                    if (!e || e.TYPE != "Call" || e.expression !== i) return false;
                } else {
                    return false;
                }
            }
        }
    };
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>
    Parser based on parse-js (http://marijn.haverbeke.nl/parse-js/).

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    var de = "break case catch const continue debugger default delete do else finally for function if in instanceof new return switch throw try typeof var void while with";
    var O = "false null true";
    var g = "abstract boolean byte char class double enum export extends final float goto implements import int interface let long native package private protected public short static super synchronized this throws transient volatile yield" + " " + O + " " + de;
    var z = "return new delete throw else case";
    de = se(de);
    g = se(g);
    z = se(z);
    O = se(O);
    var $ = se(e("+-*&%=<>!?|~^"));
    var f = /^0x[0-9a-f]+$/i;
    var M = /^0[0-7]+$/;
    var q = se([ "in", "instanceof", "typeof", "new", "void", "delete", "++", "--", "+", "-", "!", "~", "&", "|", "^", "*", "/", "%", ">>", "<<", ">>>", "<", ">", "<=", ">=", "==", "===", "!=", "!==", "?", "=", "+=", "-=", "/=", "*=", "%=", ">>=", "<<=", ">>>=", "|=", "^=", "&=", "&&", "||" ]);
    var j = se(e("  \n\r\t\f\v​           \u2028\u2029  　\ufeff"));
    var H = se(e("\n\r\u2028\u2029"));
    var N = se(e("[{(,;:"));
    var P = se(e("[]{}(),;:"));
    var u = {
        letter: new RegExp("[\\u0041-\\u005A\\u0061-\\u007A\\u00AA\\u00B5\\u00BA\\u00C0-\\u00D6\\u00D8-\\u00F6\\u00F8-\\u02C1\\u02C6-\\u02D1\\u02E0-\\u02E4\\u02EC\\u02EE\\u0370-\\u0374\\u0376\\u0377\\u037A-\\u037D\\u037F\\u0386\\u0388-\\u038A\\u038C\\u038E-\\u03A1\\u03A3-\\u03F5\\u03F7-\\u0481\\u048A-\\u052F\\u0531-\\u0556\\u0559\\u0561-\\u0587\\u05D0-\\u05EA\\u05F0-\\u05F2\\u0620-\\u064A\\u066E\\u066F\\u0671-\\u06D3\\u06D5\\u06E5\\u06E6\\u06EE\\u06EF\\u06FA-\\u06FC\\u06FF\\u0710\\u0712-\\u072F\\u074D-\\u07A5\\u07B1\\u07CA-\\u07EA\\u07F4\\u07F5\\u07FA\\u0800-\\u0815\\u081A\\u0824\\u0828\\u0840-\\u0858\\u08A0-\\u08B2\\u0904-\\u0939\\u093D\\u0950\\u0958-\\u0961\\u0971-\\u0980\\u0985-\\u098C\\u098F\\u0990\\u0993-\\u09A8\\u09AA-\\u09B0\\u09B2\\u09B6-\\u09B9\\u09BD\\u09CE\\u09DC\\u09DD\\u09DF-\\u09E1\\u09F0\\u09F1\\u0A05-\\u0A0A\\u0A0F\\u0A10\\u0A13-\\u0A28\\u0A2A-\\u0A30\\u0A32\\u0A33\\u0A35\\u0A36\\u0A38\\u0A39\\u0A59-\\u0A5C\\u0A5E\\u0A72-\\u0A74\\u0A85-\\u0A8D\\u0A8F-\\u0A91\\u0A93-\\u0AA8\\u0AAA-\\u0AB0\\u0AB2\\u0AB3\\u0AB5-\\u0AB9\\u0ABD\\u0AD0\\u0AE0\\u0AE1\\u0B05-\\u0B0C\\u0B0F\\u0B10\\u0B13-\\u0B28\\u0B2A-\\u0B30\\u0B32\\u0B33\\u0B35-\\u0B39\\u0B3D\\u0B5C\\u0B5D\\u0B5F-\\u0B61\\u0B71\\u0B83\\u0B85-\\u0B8A\\u0B8E-\\u0B90\\u0B92-\\u0B95\\u0B99\\u0B9A\\u0B9C\\u0B9E\\u0B9F\\u0BA3\\u0BA4\\u0BA8-\\u0BAA\\u0BAE-\\u0BB9\\u0BD0\\u0C05-\\u0C0C\\u0C0E-\\u0C10\\u0C12-\\u0C28\\u0C2A-\\u0C39\\u0C3D\\u0C58\\u0C59\\u0C60\\u0C61\\u0C85-\\u0C8C\\u0C8E-\\u0C90\\u0C92-\\u0CA8\\u0CAA-\\u0CB3\\u0CB5-\\u0CB9\\u0CBD\\u0CDE\\u0CE0\\u0CE1\\u0CF1\\u0CF2\\u0D05-\\u0D0C\\u0D0E-\\u0D10\\u0D12-\\u0D3A\\u0D3D\\u0D4E\\u0D60\\u0D61\\u0D7A-\\u0D7F\\u0D85-\\u0D96\\u0D9A-\\u0DB1\\u0DB3-\\u0DBB\\u0DBD\\u0DC0-\\u0DC6\\u0E01-\\u0E30\\u0E32\\u0E33\\u0E40-\\u0E46\\u0E81\\u0E82\\u0E84\\u0E87\\u0E88\\u0E8A\\u0E8D\\u0E94-\\u0E97\\u0E99-\\u0E9F\\u0EA1-\\u0EA3\\u0EA5\\u0EA7\\u0EAA\\u0EAB\\u0EAD-\\u0EB0\\u0EB2\\u0EB3\\u0EBD\\u0EC0-\\u0EC4\\u0EC6\\u0EDC-\\u0EDF\\u0F00\\u0F40-\\u0F47\\u0F49-\\u0F6C\\u0F88-\\u0F8C\\u1000-\\u102A\\u103F\\u1050-\\u1055\\u105A-\\u105D\\u1061\\u1065\\u1066\\u106E-\\u1070\\u1075-\\u1081\\u108E\\u10A0-\\u10C5\\u10C7\\u10CD\\u10D0-\\u10FA\\u10FC-\\u1248\\u124A-\\u124D\\u1250-\\u1256\\u1258\\u125A-\\u125D\\u1260-\\u1288\\u128A-\\u128D\\u1290-\\u12B0\\u12B2-\\u12B5\\u12B8-\\u12BE\\u12C0\\u12C2-\\u12C5\\u12C8-\\u12D6\\u12D8-\\u1310\\u1312-\\u1315\\u1318-\\u135A\\u1380-\\u138F\\u13A0-\\u13F4\\u1401-\\u166C\\u166F-\\u167F\\u1681-\\u169A\\u16A0-\\u16EA\\u16EE-\\u16F8\\u1700-\\u170C\\u170E-\\u1711\\u1720-\\u1731\\u1740-\\u1751\\u1760-\\u176C\\u176E-\\u1770\\u1780-\\u17B3\\u17D7\\u17DC\\u1820-\\u1877\\u1880-\\u18A8\\u18AA\\u18B0-\\u18F5\\u1900-\\u191E\\u1950-\\u196D\\u1970-\\u1974\\u1980-\\u19AB\\u19C1-\\u19C7\\u1A00-\\u1A16\\u1A20-\\u1A54\\u1AA7\\u1B05-\\u1B33\\u1B45-\\u1B4B\\u1B83-\\u1BA0\\u1BAE\\u1BAF\\u1BBA-\\u1BE5\\u1C00-\\u1C23\\u1C4D-\\u1C4F\\u1C5A-\\u1C7D\\u1CE9-\\u1CEC\\u1CEE-\\u1CF1\\u1CF5\\u1CF6\\u1D00-\\u1DBF\\u1E00-\\u1F15\\u1F18-\\u1F1D\\u1F20-\\u1F45\\u1F48-\\u1F4D\\u1F50-\\u1F57\\u1F59\\u1F5B\\u1F5D\\u1F5F-\\u1F7D\\u1F80-\\u1FB4\\u1FB6-\\u1FBC\\u1FBE\\u1FC2-\\u1FC4\\u1FC6-\\u1FCC\\u1FD0-\\u1FD3\\u1FD6-\\u1FDB\\u1FE0-\\u1FEC\\u1FF2-\\u1FF4\\u1FF6-\\u1FFC\\u2071\\u207F\\u2090-\\u209C\\u2102\\u2107\\u210A-\\u2113\\u2115\\u2119-\\u211D\\u2124\\u2126\\u2128\\u212A-\\u212D\\u212F-\\u2139\\u213C-\\u213F\\u2145-\\u2149\\u214E\\u2160-\\u2188\\u2C00-\\u2C2E\\u2C30-\\u2C5E\\u2C60-\\u2CE4\\u2CEB-\\u2CEE\\u2CF2\\u2CF3\\u2D00-\\u2D25\\u2D27\\u2D2D\\u2D30-\\u2D67\\u2D6F\\u2D80-\\u2D96\\u2DA0-\\u2DA6\\u2DA8-\\u2DAE\\u2DB0-\\u2DB6\\u2DB8-\\u2DBE\\u2DC0-\\u2DC6\\u2DC8-\\u2DCE\\u2DD0-\\u2DD6\\u2DD8-\\u2DDE\\u2E2F\\u3005-\\u3007\\u3021-\\u3029\\u3031-\\u3035\\u3038-\\u303C\\u3041-\\u3096\\u309D-\\u309F\\u30A1-\\u30FA\\u30FC-\\u30FF\\u3105-\\u312D\\u3131-\\u318E\\u31A0-\\u31BA\\u31F0-\\u31FF\\u3400-\\u4DB5\\u4E00-\\u9FCC\\uA000-\\uA48C\\uA4D0-\\uA4FD\\uA500-\\uA60C\\uA610-\\uA61F\\uA62A\\uA62B\\uA640-\\uA66E\\uA67F-\\uA69D\\uA6A0-\\uA6EF\\uA717-\\uA71F\\uA722-\\uA788\\uA78B-\\uA78E\\uA790-\\uA7AD\\uA7B0\\uA7B1\\uA7F7-\\uA801\\uA803-\\uA805\\uA807-\\uA80A\\uA80C-\\uA822\\uA840-\\uA873\\uA882-\\uA8B3\\uA8F2-\\uA8F7\\uA8FB\\uA90A-\\uA925\\uA930-\\uA946\\uA960-\\uA97C\\uA984-\\uA9B2\\uA9CF\\uA9E0-\\uA9E4\\uA9E6-\\uA9EF\\uA9FA-\\uA9FE\\uAA00-\\uAA28\\uAA40-\\uAA42\\uAA44-\\uAA4B\\uAA60-\\uAA76\\uAA7A\\uAA7E-\\uAAAF\\uAAB1\\uAAB5\\uAAB6\\uAAB9-\\uAABD\\uAAC0\\uAAC2\\uAADB-\\uAADD\\uAAE0-\\uAAEA\\uAAF2-\\uAAF4\\uAB01-\\uAB06\\uAB09-\\uAB0E\\uAB11-\\uAB16\\uAB20-\\uAB26\\uAB28-\\uAB2E\\uAB30-\\uAB5A\\uAB5C-\\uAB5F\\uAB64\\uAB65\\uABC0-\\uABE2\\uAC00-\\uD7A3\\uD7B0-\\uD7C6\\uD7CB-\\uD7FB\\uF900-\\uFA6D\\uFA70-\\uFAD9\\uFB00-\\uFB06\\uFB13-\\uFB17\\uFB1D\\uFB1F-\\uFB28\\uFB2A-\\uFB36\\uFB38-\\uFB3C\\uFB3E\\uFB40\\uFB41\\uFB43\\uFB44\\uFB46-\\uFBB1\\uFBD3-\\uFD3D\\uFD50-\\uFD8F\\uFD92-\\uFDC7\\uFDF0-\\uFDFB\\uFE70-\\uFE74\\uFE76-\\uFEFC\\uFF21-\\uFF3A\\uFF41-\\uFF5A\\uFF66-\\uFFBE\\uFFC2-\\uFFC7\\uFFCA-\\uFFCF\\uFFD2-\\uFFD7\\uFFDA-\\uFFDC]"),
        digit: new RegExp("[\\u0030-\\u0039\\u0660-\\u0669\\u06F0-\\u06F9\\u07C0-\\u07C9\\u0966-\\u096F\\u09E6-\\u09EF\\u0A66-\\u0A6F\\u0AE6-\\u0AEF\\u0B66-\\u0B6F\\u0BE6-\\u0BEF\\u0C66-\\u0C6F\\u0CE6-\\u0CEF\\u0D66-\\u0D6F\\u0DE6-\\u0DEF\\u0E50-\\u0E59\\u0ED0-\\u0ED9\\u0F20-\\u0F29\\u1040-\\u1049\\u1090-\\u1099\\u17E0-\\u17E9\\u1810-\\u1819\\u1946-\\u194F\\u19D0-\\u19D9\\u1A80-\\u1A89\\u1A90-\\u1A99\\u1B50-\\u1B59\\u1BB0-\\u1BB9\\u1C40-\\u1C49\\u1C50-\\u1C59\\uA620-\\uA629\\uA8D0-\\uA8D9\\uA900-\\uA909\\uA9D0-\\uA9D9\\uA9F0-\\uA9F9\\uAA50-\\uAA59\\uABF0-\\uABF9\\uFF10-\\uFF19]"),
        non_spacing_mark: new RegExp("[\\u0300-\\u036F\\u0483-\\u0487\\u0591-\\u05BD\\u05BF\\u05C1\\u05C2\\u05C4\\u05C5\\u05C7\\u0610-\\u061A\\u064B-\\u065E\\u0670\\u06D6-\\u06DC\\u06DF-\\u06E4\\u06E7\\u06E8\\u06EA-\\u06ED\\u0711\\u0730-\\u074A\\u07A6-\\u07B0\\u07EB-\\u07F3\\u0816-\\u0819\\u081B-\\u0823\\u0825-\\u0827\\u0829-\\u082D\\u0900-\\u0902\\u093C\\u0941-\\u0948\\u094D\\u0951-\\u0955\\u0962\\u0963\\u0981\\u09BC\\u09C1-\\u09C4\\u09CD\\u09E2\\u09E3\\u0A01\\u0A02\\u0A3C\\u0A41\\u0A42\\u0A47\\u0A48\\u0A4B-\\u0A4D\\u0A51\\u0A70\\u0A71\\u0A75\\u0A81\\u0A82\\u0ABC\\u0AC1-\\u0AC5\\u0AC7\\u0AC8\\u0ACD\\u0AE2\\u0AE3\\u0B01\\u0B3C\\u0B3F\\u0B41-\\u0B44\\u0B4D\\u0B56\\u0B62\\u0B63\\u0B82\\u0BC0\\u0BCD\\u0C3E-\\u0C40\\u0C46-\\u0C48\\u0C4A-\\u0C4D\\u0C55\\u0C56\\u0C62\\u0C63\\u0CBC\\u0CBF\\u0CC6\\u0CCC\\u0CCD\\u0CE2\\u0CE3\\u0D41-\\u0D44\\u0D4D\\u0D62\\u0D63\\u0DCA\\u0DD2-\\u0DD4\\u0DD6\\u0E31\\u0E34-\\u0E3A\\u0E47-\\u0E4E\\u0EB1\\u0EB4-\\u0EB9\\u0EBB\\u0EBC\\u0EC8-\\u0ECD\\u0F18\\u0F19\\u0F35\\u0F37\\u0F39\\u0F71-\\u0F7E\\u0F80-\\u0F84\\u0F86\\u0F87\\u0F90-\\u0F97\\u0F99-\\u0FBC\\u0FC6\\u102D-\\u1030\\u1032-\\u1037\\u1039\\u103A\\u103D\\u103E\\u1058\\u1059\\u105E-\\u1060\\u1071-\\u1074\\u1082\\u1085\\u1086\\u108D\\u109D\\u135F\\u1712-\\u1714\\u1732-\\u1734\\u1752\\u1753\\u1772\\u1773\\u17B7-\\u17BD\\u17C6\\u17C9-\\u17D3\\u17DD\\u180B-\\u180D\\u18A9\\u1920-\\u1922\\u1927\\u1928\\u1932\\u1939-\\u193B\\u1A17\\u1A18\\u1A56\\u1A58-\\u1A5E\\u1A60\\u1A62\\u1A65-\\u1A6C\\u1A73-\\u1A7C\\u1A7F\\u1B00-\\u1B03\\u1B34\\u1B36-\\u1B3A\\u1B3C\\u1B42\\u1B6B-\\u1B73\\u1B80\\u1B81\\u1BA2-\\u1BA5\\u1BA8\\u1BA9\\u1C2C-\\u1C33\\u1C36\\u1C37\\u1CD0-\\u1CD2\\u1CD4-\\u1CE0\\u1CE2-\\u1CE8\\u1CED\\u1DC0-\\u1DE6\\u1DFD-\\u1DFF\\u20D0-\\u20DC\\u20E1\\u20E5-\\u20F0\\u2CEF-\\u2CF1\\u2DE0-\\u2DFF\\u302A-\\u302F\\u3099\\u309A\\uA66F\\uA67C\\uA67D\\uA6F0\\uA6F1\\uA802\\uA806\\uA80B\\uA825\\uA826\\uA8C4\\uA8E0-\\uA8F1\\uA926-\\uA92D\\uA947-\\uA951\\uA980-\\uA982\\uA9B3\\uA9B6-\\uA9B9\\uA9BC\\uAA29-\\uAA2E\\uAA31\\uAA32\\uAA35\\uAA36\\uAA43\\uAA4C\\uAAB0\\uAAB2-\\uAAB4\\uAAB7\\uAAB8\\uAABE\\uAABF\\uAAC1\\uABE5\\uABE8\\uABED\\uFB1E\\uFE00-\\uFE0F\\uFE20-\\uFE26]"),
        space_combining_mark: new RegExp("[\\u0903\\u093E-\\u0940\\u0949-\\u094C\\u094E\\u0982\\u0983\\u09BE-\\u09C0\\u09C7\\u09C8\\u09CB\\u09CC\\u09D7\\u0A03\\u0A3E-\\u0A40\\u0A83\\u0ABE-\\u0AC0\\u0AC9\\u0ACB\\u0ACC\\u0B02\\u0B03\\u0B3E\\u0B40\\u0B47\\u0B48\\u0B4B\\u0B4C\\u0B57\\u0BBE\\u0BBF\\u0BC1\\u0BC2\\u0BC6-\\u0BC8\\u0BCA-\\u0BCC\\u0BD7\\u0C01-\\u0C03\\u0C41-\\u0C44\\u0C82\\u0C83\\u0CBE\\u0CC0-\\u0CC4\\u0CC7\\u0CC8\\u0CCA\\u0CCB\\u0CD5\\u0CD6\\u0D02\\u0D03\\u0D3E-\\u0D40\\u0D46-\\u0D48\\u0D4A-\\u0D4C\\u0D57\\u0D82\\u0D83\\u0DCF-\\u0DD1\\u0DD8-\\u0DDF\\u0DF2\\u0DF3\\u0F3E\\u0F3F\\u0F7F\\u102B\\u102C\\u1031\\u1038\\u103B\\u103C\\u1056\\u1057\\u1062-\\u1064\\u1067-\\u106D\\u1083\\u1084\\u1087-\\u108C\\u108F\\u109A-\\u109C\\u17B6\\u17BE-\\u17C5\\u17C7\\u17C8\\u1923-\\u1926\\u1929-\\u192B\\u1930\\u1931\\u1933-\\u1938\\u19B0-\\u19C0\\u19C8\\u19C9\\u1A19-\\u1A1B\\u1A55\\u1A57\\u1A61\\u1A63\\u1A64\\u1A6D-\\u1A72\\u1B04\\u1B35\\u1B3B\\u1B3D-\\u1B41\\u1B43\\u1B44\\u1B82\\u1BA1\\u1BA6\\u1BA7\\u1BAA\\u1C24-\\u1C2B\\u1C34\\u1C35\\u1CE1\\u1CF2\\uA823\\uA824\\uA827\\uA880\\uA881\\uA8B4-\\uA8C3\\uA952\\uA953\\uA983\\uA9B4\\uA9B5\\uA9BA\\uA9BB\\uA9BD-\\uA9C0\\uAA2F\\uAA30\\uAA33\\uAA34\\uAA4D\\uAA7B\\uABE3\\uABE4\\uABE6\\uABE7\\uABE9\\uABEA\\uABEC]"),
        connector_punctuation: new RegExp("[\\u005F\\u203F\\u2040\\u2054\\uFE33\\uFE34\\uFE4D-\\uFE4F\\uFF3F]")
    };
    function c(e) {
        return e >= 97 && e <= 122 || e >= 65 && e <= 90 || e >= 170 && u.letter.test(String.fromCharCode(e));
    }
    function ee(e) {
        return e >= 55296 && e <= 56319;
    }
    function ne(e) {
        return e >= 56320 && e <= 57343;
    }
    function U(e) {
        return e >= 48 && e <= 57;
    }
    function Y(e) {
        return U(e) || c(e);
    }
    function l(e) {
        return u.digit.test(String.fromCharCode(e));
    }
    function p(e) {
        return u.non_spacing_mark.test(e) || u.space_combining_mark.test(e);
    }
    function h(e) {
        return u.connector_punctuation.test(e);
    }
    function L(e) {
        return e == 36 || e == 95 || c(e);
    }
    function ve(e) {
        var n = e.charCodeAt(0);
        return L(n) || U(n) || n == 8204 || n == 8205 || p(e) || h(e) || l(n);
    }
    function Qn(e) {
        return /^[a-z_$][a-z0-9_$]*$/i.test(e);
    }
    function V(e) {
        if (f.test(e)) {
            return parseInt(e.substr(2), 16);
        } else if (M.test(e)) {
            return parseInt(e.substr(1), 8);
        } else {
            var n = parseFloat(e);
            if (n == e) return n;
        }
    }
    function Zn(e, n, t, i, r) {
        this.message = e;
        this.filename = n;
        this.line = t;
        this.col = i;
        this.pos = r;
    }
    Zn.prototype = Object.create(Error.prototype);
    Zn.prototype.constructor = Zn;
    Zn.prototype.name = "SyntaxError";
    n(Zn);
    function _e(e, n, t, i, r) {
        throw new Zn(e, n, t, i, r);
    }
    function me(e, n, t) {
        return e.type == n && (t == null || e.value == t);
    }
    var W = {};
    function ge(r, o, a, s) {
        var f = {
            text: r,
            filename: o,
            pos: 0,
            tokpos: 0,
            line: 1,
            tokline: 0,
            col: 0,
            tokcol: 0,
            newline_before: false,
            regex_allowed: false,
            comments_before: [],
            directives: {},
            directive_stack: []
        };
        var u = false;
        function c() {
            return f.text.charAt(f.pos);
        }
        function l(e, n) {
            var t = f.text.charAt(f.pos++);
            if (e && !t) throw W;
            if (H[t]) {
                f.col = 0;
                f.line++;
                if (!n) f.newline_before = true;
                if (t == "\r" && c() == "\n") {
                    f.pos++;
                    t = "\n";
                }
            } else {
                f.col++;
            }
            return t;
        }
        function p(e) {
            while (e-- > 0) l();
        }
        function h(e) {
            return f.text.substr(f.pos, e.length) == e;
        }
        function d() {
            var e = f.text;
            for (var n = f.pos; n < f.text.length; ++n) {
                if (H[e[n]]) return n;
            }
            return -1;
        }
        function i(e, n) {
            var t = f.text.indexOf(e, f.pos);
            if (n && t == -1) throw W;
            return t;
        }
        function v() {
            f.tokline = f.line;
            f.tokcol = f.col;
            f.tokpos = f.pos;
        }
        function _(e, n, t) {
            f.regex_allowed = e == "operator" && !nt[n] || e == "keyword" && z[n] || e == "punc" && N[n];
            if (e == "punc" && n == ".") u = true; else if (!t) u = false;
            var i = {
                type: e,
                value: n,
                line: f.tokline,
                col: f.tokcol,
                pos: f.tokpos,
                endline: f.line,
                endcol: f.col,
                endpos: f.pos,
                nlb: f.newline_before,
                file: o
            };
            if (/^(?:num|string|regexp)$/i.test(e)) {
                i.raw = r.substring(i.pos, i.endpos);
            }
            if (!t) {
                i.comments_before = f.comments_before;
                i.comments_after = f.comments_before = [];
            }
            f.newline_before = false;
            return new Z(i);
        }
        function m() {
            while (j[c()]) l();
        }
        function t(e) {
            var n = "", t, i = 0;
            while ((t = c()) && e(t, i++)) n += l();
            return n;
        }
        function g(e) {
            _e(e, o, f.tokline, f.tokcol, f.tokpos);
        }
        function b(i) {
            var r = false, o = false, a = false, s = i == ".";
            var e = t(function(e, n) {
                var t = e.charCodeAt(0);
                switch (t) {
                  case 120:
                  case 88:
                    return a ? false : a = true;

                  case 101:
                  case 69:
                    return a ? true : r ? false : r = o = true;

                  case 45:
                    return o || n == 0 && !i;

                  case 43:
                    return o;

                  case o = false, 46:
                    return !s && !a && !r ? s = true : false;
                }
                return Y(t);
            });
            if (i) e = i + e;
            if (M.test(e) && T.has_directive("use strict")) {
                g("Legacy octal literals are not allowed in strict mode");
            }
            var n = V(e);
            if (!isNaN(n)) return _("num", n);
            g("Invalid syntax: " + e);
        }
        function y(e) {
            var n = l(true, e);
            switch (n.charCodeAt(0)) {
              case 110:
                return "\n";

              case 114:
                return "\r";

              case 116:
                return "\t";

              case 98:
                return "\b";

              case 118:
                return "\v";

              case 102:
                return "\f";

              case 120:
                return String.fromCharCode(x(2));

              case 117:
                return String.fromCharCode(x(4));

              case 10:
                return "";

              case 13:
                if (c() == "\n") {
                    l(true, e);
                    return "";
                }
            }
            if (n >= "0" && n <= "7") return w(n);
            return n;
        }
        function w(e) {
            var n = c();
            if (n >= "0" && n <= "7") {
                e += l(true);
                if (e[0] <= "3" && (n = c()) >= "0" && n <= "7") e += l(true);
            }
            if (e === "0") return "\0";
            if (e.length > 0 && T.has_directive("use strict")) g("Legacy octal escape sequences are not allowed in strict mode");
            return String.fromCharCode(parseInt(e, 8));
        }
        function x(e) {
            var n = 0;
            for (;e > 0; --e) {
                var t = parseInt(l(true), 16);
                if (isNaN(t)) g("Invalid hex-character pattern in string");
                n = n << 4 | t;
            }
            return n;
        }
        var E = n("Unterminated string constant", function(e) {
            var n = l(), t = "";
            for (;;) {
                var i = l(true, true);
                if (i == "\\") i = y(true); else if (H[i]) g("Unterminated string constant"); else if (i == n) break;
                t += i;
            }
            var r = _("string", t);
            r.quote = e;
            return r;
        });
        function A(e) {
            var n = f.regex_allowed;
            var t = d(), i;
            if (t == -1) {
                i = f.text.substr(f.pos);
                f.pos = f.text.length;
            } else {
                i = f.text.substring(f.pos, t);
                f.pos = t;
            }
            f.col = f.tokcol + (f.pos - f.tokpos);
            f.comments_before.push(_(e, i, true));
            f.regex_allowed = n;
            return T;
        }
        var e = n("Unterminated multiline comment", function() {
            var e = f.regex_allowed;
            var n = i("*/", true);
            var t = f.text.substring(f.pos, n).replace(/\r\n|\r|\u2028|\u2029/g, "\n");
            p(t.length + 2);
            f.comments_before.push(_("comment2", t, true));
            f.regex_allowed = e;
            return T;
        });
        function k() {
            var e = false, n = "", t, i = false, r;
            while ((t = c()) != null) {
                if (!e) {
                    if (t == "\\") i = e = true, l(); else if (ve(t)) n += l(); else break;
                } else {
                    if (t != "u") g("Expecting UnicodeEscapeSequence -- uXXXX");
                    t = y();
                    if (!ve(t)) g("Unicode char: " + t.charCodeAt(0) + " is not valid in identifier");
                    n += t;
                    e = false;
                }
            }
            if (de[n] && i) {
                r = n.charCodeAt(0).toString(16).toUpperCase();
                n = "\\u" + "0000".substr(r.length) + r + n.slice(1);
            }
            return n;
        }
        var D = n("Unterminated regular expression", function(e) {
            var n = false, t, i = false;
            while (t = l(true)) if (H[t]) {
                g("Unexpected line terminator");
            } else if (n) {
                e += "\\" + t;
                n = false;
            } else if (t == "[") {
                i = true;
                e += t;
            } else if (t == "]" && i) {
                i = false;
                e += t;
            } else if (t == "/" && !i) {
                break;
            } else if (t == "\\") {
                n = true;
            } else {
                e += t;
            }
            var r = k();
            try {
                var o = new RegExp(e, r);
                o.raw_source = e;
                return _("regexp", o);
            } catch (e) {
                g(e.message);
            }
        });
        function F(e) {
            function t(e) {
                if (!c()) return e;
                var n = e + c();
                if (q[n]) {
                    l();
                    return t(n);
                } else {
                    return e;
                }
            }
            return _("operator", t(e || l()));
        }
        function C() {
            l();
            switch (c()) {
              case "/":
                l();
                return A("comment1");

              case "*":
                l();
                return e();
            }
            return f.regex_allowed ? D("") : F("/");
        }
        function B() {
            l();
            return U(c().charCodeAt(0)) ? b(".") : _("punc", ".");
        }
        function S() {
            var e = k();
            if (u) return _("name", e);
            return O[e] ? _("atom", e) : !de[e] ? _("name", e) : q[e] ? _("operator", e) : _("keyword", e);
        }
        function n(n, t) {
            return function(e) {
                try {
                    return t(e);
                } catch (e) {
                    if (e === W) g(n); else throw e;
                }
            };
        }
        function T(e) {
            if (e != null) return D(e);
            if (s && f.pos == 0 && h("#!")) {
                v();
                p(2);
                A("comment5");
            }
            for (;;) {
                m();
                v();
                if (a) {
                    if (h("\x3c!--")) {
                        p(4);
                        A("comment3");
                        continue;
                    }
                    if (h("--\x3e") && f.newline_before) {
                        p(3);
                        A("comment4");
                        continue;
                    }
                }
                var n = c();
                if (!n) return _("eof");
                var t = n.charCodeAt(0);
                switch (t) {
                  case 34:
                  case 39:
                    return E(n);

                  case 46:
                    return B();

                  case 47:
                    var i = C();
                    if (i === T) continue;
                    return i;
                }
                if (U(t)) return b();
                if (P[n]) return _("punc", l());
                if ($[n]) return F();
                if (t == 92 || L(t)) return S();
                break;
            }
            g("Unexpected character '" + n + "'");
        }
        T.context = function(e) {
            if (e) f = e;
            return f;
        };
        T.add_directive = function(e) {
            f.directive_stack[f.directive_stack.length - 1].push(e);
            if (f.directives[e]) f.directives[e]++; else f.directives[e] = 1;
        };
        T.push_directives_stack = function() {
            f.directive_stack.push([]);
        };
        T.pop_directives_stack = function() {
            var e = f.directive_stack.pop();
            for (var n = e.length; --n >= 0; ) {
                f.directives[e[n]]--;
            }
        };
        T.has_directive = function(e) {
            return f.directives[e] > 0;
        };
        return T;
    }
    var et = se("typeof void delete -- ++ ! ~ - +");
    var nt = se("-- ++");
    var tt = se("= += -= /= *= %= >>= <<= >>>= |= ^= &=");
    var it = function(e, n) {
        for (var t = 0; t < e.length; ) {
            var i = e[t++];
            for (var r = 0; r < i.length; r++) {
                n[i[r]] = t;
            }
        }
        return n;
    }([ [ "||" ], [ "&&" ], [ "|" ], [ "^" ], [ "&" ], [ "==", "===", "!=", "!==" ], [ "<", ">", "<=", ">=", "in", "instanceof" ], [ ">>", "<<", ">>>" ], [ "+", "-" ], [ "*", "/", "%" ] ], {});
    var rt = se("atom num string regexp name");
    function ot(e, a) {
        a = ie(a, {
            bare_returns: false,
            expression: false,
            filename: null,
            html5_comments: true,
            shebang: true,
            strict: false,
            toplevel: null
        }, true);
        var f = {
            input: typeof e == "string" ? ge(e, a.filename, a.html5_comments, a.shebang) : e,
            token: null,
            prev: null,
            peeked: null,
            in_function: 0,
            in_directives: true,
            in_loop: 0,
            labels: []
        };
        f.token = c();
        function u(e, n) {
            return me(f.token, e, n);
        }
        function s() {
            return f.peeked || (f.peeked = f.input());
        }
        function c() {
            f.prev = f.token;
            if (f.peeked) {
                f.token = f.peeked;
                f.peeked = null;
            } else {
                f.token = f.input();
            }
            f.in_directives = f.in_directives && (f.token.type == "string" || u("punc", ";"));
            return f.token;
        }
        function l() {
            return f.prev;
        }
        function p(e, n, t, i) {
            var r = f.input.context();
            _e(e, r.filename, n != null ? n : r.tokline, t != null ? t : r.tokcol, i != null ? i : r.tokpos);
        }
        function t(e, n) {
            p(n, e.line, e.col);
        }
        function i(e, n) {
            return e + (n === undefined ? "" : " «" + n + "»");
        }
        function h(e) {
            if (e == null) e = f.token;
            t(e, "Unexpected token: " + i(e.type, e.value));
        }
        function d(e, n) {
            if (u(e, n)) return c();
            t(f.token, "Unexpected token: " + i(f.token.type, f.token.value) + ", expected: " + i(e, n));
        }
        function v(e) {
            return d("punc", e);
        }
        function _(e) {
            return e.nlb || !Ee(e.comments_before, function(e) {
                return !e.nlb;
            });
        }
        function m() {
            return !a.strict && (u("eof") || u("punc", "}") || _(f.token));
        }
        function g(e) {
            if (u("punc", ";")) c(); else if (!e && !m()) d("punc", ";");
        }
        function b() {
            v("(");
            var e = ee(true);
            v(")");
            return e;
        }
        function n(i) {
            return function() {
                var e = f.token;
                var n = i.apply(null, arguments);
                var t = l();
                n.start = e;
                n.end = t;
                return n;
            };
        }
        function y() {
            if (u("operator", "/") || u("operator", "/=")) {
                f.peeked = null;
                f.token = f.input(f.token.value.substr(1));
            }
        }
        var w = n(function(e) {
            y();
            switch (f.token.type) {
              case "string":
                var n = f.in_directives;
                var t = ee(true);
                if (n) {
                    if (t instanceof Pn) {
                        var i = t.start.raw.slice(1, -1);
                        f.input.add_directive(i);
                        t.value = i;
                    } else {
                        f.in_directives = n = false;
                    }
                }
                g();
                return n ? new Be(t) : new Se({
                    body: t
                });

              case "num":
              case "regexp":
              case "operator":
              case "atom":
                return E();

              case "name":
                return me(s(), "punc", ":") ? x() : E();

              case "punc":
                switch (f.token.value) {
                  case "{":
                    return new ze({
                        start: f.token,
                        body: C(),
                        end: l()
                    });

                  case "[":
                  case "(":
                    return E();

                  case ";":
                    f.in_directives = false;
                    c();
                    return new $e();

                  default:
                    h();
                }

              case "keyword":
                switch (f.token.value) {
                  case "break":
                    c();
                    return A(en);

                  case "continue":
                    c();
                    return A(nn);

                  case "debugger":
                    c();
                    g();
                    return new Ce();

                  case "do":
                    c();
                    var t = ne(w);
                    d("keyword", "while");
                    var r = b();
                    g(true);
                    return new He({
                        body: t,
                        condition: r
                    });

                  case "while":
                    c();
                    return new Ne({
                        condition: b(),
                        body: ne(w)
                    });

                  case "for":
                    c();
                    return k();

                  case "function":
                    if (!e && f.input.has_directive("use strict")) {
                        p("In strict mode code, functions can only be declared at top level or immediately within another function.");
                    }
                    c();
                    return D(Je);

                  case "if":
                    c();
                    return F();

                  case "return":
                    if (f.in_function == 0 && !a.bare_returns) p("'return' outside of function");
                    c();
                    var i = null;
                    if (u("punc", ";")) {
                        c();
                    } else if (!m()) {
                        i = ee(true);
                        g();
                    }
                    return new Ke({
                        value: i
                    });

                  case "switch":
                    c();
                    return new rn({
                        expression: b(),
                        body: ne(B)
                    });

                  case "throw":
                    c();
                    if (_(f.token)) p("Illegal newline after 'throw'");
                    var i = ee(true);
                    g();
                    return new Qe({
                        value: i
                    });

                  case "try":
                    c();
                    return S();

                  case "var":
                    c();
                    var o = O();
                    g();
                    return o;

                  case "with":
                    if (f.input.has_directive("use strict")) {
                        p("Strict mode may not include a with statement");
                    }
                    c();
                    return new Ie({
                        expression: b(),
                        body: w()
                    });
                }
            }
            h();
        });
        function x() {
            var n = Y(pe);
            if (!Ee(f.labels, function(e) {
                return e.name != n.name;
            })) {
                p("Label " + n.name + " defined twice");
            }
            v(":");
            f.labels.push(n);
            var e = w();
            f.labels.pop();
            if (!(e instanceof qe)) {
                n.references.forEach(function(e) {
                    if (e instanceof nn) {
                        e = e.label.start;
                        p("Continue label `" + n.name + "` refers to non-IterationStatement.", e.line, e.col, e.pos);
                    }
                });
            }
            return new Me({
                body: e,
                label: n
            });
        }
        function E() {
            var e = ee(true);
            g();
            return new Se({
                body: e
            });
        }
        function A(e) {
            var n = null, t;
            if (!m()) {
                n = Y(he, true);
            }
            if (n != null) {
                t = te(function(e) {
                    return e.name == n.name;
                }, f.labels);
                if (!t) p("Undefined label " + n.name);
                n.thedef = t;
            } else if (f.in_loop == 0) p(e.TYPE + " not inside a loop or switch");
            g();
            var i = new e({
                label: n
            });
            if (t) t.references.push(i);
            return i;
        }
        function k() {
            v("(");
            var e = null;
            if (!u("punc", ";")) {
                e = u("keyword", "var") ? (c(), O(true)) : ee(true, true);
                if (u("operator", "in")) {
                    if (e instanceof pn) {
                        if (e.definitions.length > 1) p("Only one variable declaration allowed in for..in loop", e.start.line, e.start.col, e.start.pos);
                    } else if (!Q(e)) {
                        p("Invalid left-hand side in for..in loop", e.start.line, e.start.col, e.start.pos);
                    }
                    c();
                    return o(e);
                }
            }
            return r(e);
        }
        function r(e) {
            v(";");
            var n = u("punc", ";") ? null : ee(true);
            v(";");
            var t = u("punc", ")") ? null : ee(true);
            v(")");
            return new Pe({
                init: e,
                condition: n,
                step: t,
                body: ne(w)
            });
        }
        function o(e) {
            var n = ee(true);
            v(")");
            return new Re({
                init: e,
                object: n,
                body: ne(w)
            });
        }
        var D = function(e) {
            var n = e === Je;
            var t = u("name") ? Y(n ? $n : Mn) : null;
            if (n && !t) d("name");
            if (t && e !== Ve && !(t instanceof Tn)) h(l());
            v("(");
            var i = [];
            for (var r = true; !u("punc", ")"); ) {
                if (r) r = false; else v(",");
                i.push(Y(zn));
            }
            c();
            var o = f.in_loop;
            var a = f.labels;
            ++f.in_function;
            f.in_directives = true;
            f.input.push_directives_stack();
            f.in_loop = 0;
            f.labels = [];
            var s = C(true);
            if (f.input.has_directive("use strict")) {
                if (t) U(t);
                i.forEach(U);
            }
            f.input.pop_directives_stack();
            --f.in_function;
            f.in_loop = o;
            f.labels = a;
            return new e({
                name: t,
                argnames: i,
                body: s
            });
        };
        function F() {
            var e = b(), n = w(), t = null;
            if (u("keyword", "else")) {
                c();
                t = w();
            }
            return new tn({
                condition: e,
                body: n,
                alternative: t
            });
        }
        function C(e) {
            v("{");
            var n = [];
            while (!u("punc", "}")) {
                if (u("eof")) d("punc", "}");
                n.push(w(e));
            }
            c();
            return n;
        }
        function B() {
            v("{");
            var e = [], n = null, t = null, i;
            while (!u("punc", "}")) {
                if (u("eof")) d("punc", "}");
                if (u("keyword", "case")) {
                    if (t) t.end = l();
                    n = [];
                    t = new sn({
                        start: (i = f.token, c(), i),
                        expression: ee(true),
                        body: n
                    });
                    e.push(t);
                    v(":");
                } else if (u("keyword", "default")) {
                    if (t) t.end = l();
                    n = [];
                    t = new an({
                        start: (i = f.token, c(), v(":"), i),
                        body: n
                    });
                    e.push(t);
                } else {
                    if (!n) h();
                    n.push(w());
                }
            }
            if (t) t.end = l();
            c();
            return e;
        }
        function S() {
            var e = C(), n = null, t = null;
            if (u("keyword", "catch")) {
                var i = f.token;
                c();
                v("(");
                var r = Y(qn);
                v(")");
                n = new un({
                    start: i,
                    argname: r,
                    body: C(),
                    end: l()
                });
            }
            if (u("keyword", "finally")) {
                var i = f.token;
                c();
                t = new cn({
                    start: i,
                    body: C(),
                    end: l()
                });
            }
            if (!n && !t) p("Missing catch/finally blocks");
            return new fn({
                body: e,
                bcatch: n,
                bfinally: t
            });
        }
        function T(e) {
            var n = [];
            for (;;) {
                n.push(new hn({
                    start: f.token,
                    name: Y(On),
                    value: u("operator", "=") ? (c(), ee(false, e)) : null,
                    end: l()
                }));
                if (!u("punc", ",")) break;
                c();
            }
            return n;
        }
        var O = function(e) {
            return new pn({
                start: l(),
                definitions: T(e),
                end: l()
            });
        };
        var z = function(e) {
            var n = f.token;
            d("operator", "new");
            var t = M(false), i;
            if (u("punc", "(")) {
                c();
                i = q(")");
            } else {
                i = [];
            }
            var r = new vn({
                start: n,
                expression: t,
                args: i,
                end: l()
            });
            L(r);
            return V(r, e);
        };
        function $() {
            var e = f.token, n;
            switch (e.type) {
              case "name":
                n = I(jn);
                break;

              case "num":
                n = new Rn({
                    start: e,
                    end: e,
                    value: e.value
                });
                break;

              case "string":
                n = new Pn({
                    start: e,
                    end: e,
                    value: e.value,
                    quote: e.quote
                });
                break;

              case "regexp":
                n = new In({
                    start: e,
                    end: e,
                    value: e.value
                });
                break;

              case "atom":
                switch (e.value) {
                  case "false":
                    n = new Gn({
                        start: e,
                        end: e
                    });
                    break;

                  case "true":
                    n = new Xn({
                        start: e,
                        end: e
                    });
                    break;

                  case "null":
                    n = new Un({
                        start: e,
                        end: e
                    });
                    break;
                }
                break;
            }
            c();
            return n;
        }
        var M = function(e) {
            if (u("operator", "new")) {
                return z(e);
            }
            var n = f.token;
            if (u("punc")) {
                switch (n.value) {
                  case "(":
                    c();
                    var t = ee(true);
                    var i = n.comments_before.length;
                    [].unshift.apply(t.start.comments_before, n.comments_before);
                    n.comments_before.length = 0;
                    n.comments_before = t.start.comments_before;
                    n.comments_before_length = i;
                    if (i == 0 && n.comments_before.length > 0) {
                        var r = n.comments_before[0];
                        if (!r.nlb) {
                            r.nlb = n.nlb;
                            n.nlb = false;
                        }
                    }
                    n.comments_after = t.start.comments_after;
                    t.start = n;
                    v(")");
                    var o = l();
                    o.comments_before = t.end.comments_before;
                    [].push.apply(t.end.comments_after, o.comments_after);
                    o.comments_after.length = 0;
                    o.comments_after = t.end.comments_after;
                    t.end = o;
                    if (t instanceof dn) L(t);
                    return V(t, e);

                  case "[":
                    return V(j(), e);

                  case "{":
                    return V(N(), e);
                }
                h();
            }
            if (u("keyword", "function")) {
                c();
                var a = D(We);
                a.start = n;
                a.end = l();
                return V(a, e);
            }
            if (rt[f.token.type]) {
                return V($(), e);
            }
            h();
        };
        function q(e, n, t) {
            var i = true, r = [];
            while (!u("punc", e)) {
                if (i) i = false; else v(",");
                if (n && u("punc", e)) break;
                if (u("punc", ",") && t) {
                    r.push(new Vn({
                        start: f.token,
                        end: f.token
                    }));
                } else {
                    r.push(ee(false));
                }
            }
            c();
            return r;
        }
        var j = n(function() {
            v("[");
            return new Dn({
                elements: q("]", !a.strict, true)
            });
        });
        var H = n(function() {
            return D(Ve);
        });
        var N = n(function() {
            v("{");
            var e = true, n = [];
            while (!u("punc", "}")) {
                if (e) e = false; else v(",");
                if (!a.strict && u("punc", "}")) break;
                var t = f.token;
                var i = t.type;
                var r = P();
                if (i == "name" && !u("punc", ":")) {
                    var o = new le({
                        start: f.token,
                        name: "" + P(),
                        end: l()
                    });
                    if (r == "get") {
                        n.push(new ce({
                            start: t,
                            key: o,
                            value: H(),
                            end: l()
                        }));
                        continue;
                    }
                    if (r == "set") {
                        n.push(new ue({
                            start: t,
                            key: o,
                            value: H(),
                            end: l()
                        }));
                        continue;
                    }
                }
                v(":");
                n.push(new Bn({
                    start: t,
                    quote: t.quote,
                    key: "" + r,
                    value: ee(false),
                    end: l()
                }));
            }
            c();
            return new Fn({
                properties: n
            });
        });
        function P() {
            var e = f.token;
            switch (e.type) {
              case "operator":
                if (!de[e.value]) h();

              case "num":
              case "string":
              case "name":
              case "keyword":
              case "atom":
                c();
                return e.value;

              default:
                h();
            }
        }
        function R() {
            if (!u("name")) d("name");
            var e = f.token.value;
            c();
            return e;
        }
        function I(e) {
            var n = f.token.value;
            return new (n == "this" ? Hn : e)({
                name: String(n),
                start: f.token,
                end: f.token
            });
        }
        function U(e) {
            if (e.name == "arguments" || e.name == "eval") p("Unexpected " + e.name + " in strict mode", e.start.line, e.start.col, e.start.pos);
        }
        function Y(e, n) {
            if (!u("name")) {
                if (!n) p("Name expected");
                return null;
            }
            var t = I(e);
            if (f.input.has_directive("use strict") && t instanceof Tn) {
                U(t);
            }
            c();
            return t;
        }
        function L(e) {
            var n = e.start;
            var t = n.comments_before;
            var i = fe(n, "comments_before_length") ? n.comments_before_length : t.length;
            while (--i >= 0) {
                var r = t[i];
                if (/[@#]__PURE__/.test(r.value)) {
                    e.pure = r;
                    break;
                }
            }
        }
        var V = function(e, n) {
            var t = e.start;
            if (u("punc", ".")) {
                c();
                return V(new gn({
                    start: t,
                    expression: e,
                    property: R(),
                    end: l()
                }), n);
            }
            if (u("punc", "[")) {
                c();
                var i = ee(true);
                v("]");
                return V(new bn({
                    start: t,
                    expression: e,
                    property: i,
                    end: l()
                }), n);
            }
            if (n && u("punc", "(")) {
                c();
                var r = new dn({
                    start: t,
                    expression: e,
                    args: q(")"),
                    end: l()
                });
                L(r);
                return V(r, true);
            }
            return e;
        };
        var W = function(e) {
            var n = f.token;
            if (u("operator") && et[n.value]) {
                c();
                y();
                var t = J(wn, n, W(e));
                t.start = n;
                t.end = l();
                return t;
            }
            var i = M(e);
            while (u("operator") && nt[f.token.value] && !_(f.token)) {
                i = J(xn, f.token, i);
                i.start = n;
                i.end = f.token;
                c();
            }
            return i;
        };
        function J(e, n, t) {
            var i = n.value;
            switch (i) {
              case "++":
              case "--":
                if (!Q(t)) p("Invalid use of " + i + " operator", n.line, n.col, n.pos);
                break;

              case "delete":
                if (t instanceof jn && f.input.has_directive("use strict")) p("Calling delete on expression not allowed in strict mode", t.start.line, t.start.col, t.start.pos);
                break;
            }
            return new e({
                operator: i,
                expression: t
            });
        }
        var G = function(e, n, t) {
            var i = u("operator") ? f.token.value : null;
            if (i == "in" && t) i = null;
            var r = i != null ? it[i] : null;
            if (r != null && r > n) {
                c();
                var o = G(W(true), r, t);
                return G(new En({
                    start: e.start,
                    left: e,
                    operator: i,
                    right: o,
                    end: o.end
                }), n, t);
            }
            return e;
        };
        function X(e) {
            return G(W(true), 0, e);
        }
        var K = function(e) {
            var n = f.token;
            var t = X(e);
            if (u("operator", "?")) {
                c();
                var i = ee(false);
                v(":");
                return new An({
                    start: n,
                    condition: t,
                    consequent: i,
                    alternative: ee(false, e),
                    end: l()
                });
            }
            return t;
        };
        function Q(e) {
            return e instanceof mn || e instanceof jn;
        }
        var Z = function(e) {
            var n = f.token;
            var t = K(e), i = f.token.value;
            if (u("operator") && tt[i]) {
                if (Q(t)) {
                    c();
                    return new kn({
                        start: n,
                        left: t,
                        operator: i,
                        right: Z(e),
                        end: l()
                    });
                }
                p("Invalid assignment");
            }
            return t;
        };
        var ee = function(e, n) {
            var t = f.token;
            var i = [];
            while (true) {
                i.push(Z(n));
                if (!e || !u("punc", ",")) break;
                c();
                e = true;
            }
            return i.length == 1 ? i[0] : new _n({
                start: t,
                expressions: i,
                end: s()
            });
        };
        function ne(e) {
            ++f.in_loop;
            var n = e();
            --f.in_loop;
            return n;
        }
        if (a.expression) {
            y();
            return ee(true);
        }
        return function() {
            var e = f.token;
            var n = [];
            f.input.push_directives_stack();
            while (!u("eof")) n.push(w(true));
            f.input.pop_directives_stack();
            var t = l();
            var i = a.toplevel;
            if (i) {
                i.body = i.body.concat(n);
                i.end = t;
            } else {
                i = new Ye({
                    start: e,
                    body: n,
                    end: t
                });
            }
            return i;
        }();
    }
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function at(e, n) {
        Kn.call(this);
        this.before = e;
        this.after = n;
    }
    at.prototype = new Kn();
    (function(e) {
        function t(e, n) {
            return we(e, function(e) {
                return e.transform(n, true);
            });
        }
        e(De, re);
        e(Me, function(e, n) {
            e.label = e.label.transform(n);
            e.body = e.body.transform(n);
        });
        e(Se, function(e, n) {
            e.body = e.body.transform(n);
        });
        e(Oe, function(e, n) {
            e.body = t(e.body, n);
        });
        e(He, function(e, n) {
            e.body = e.body.transform(n);
            e.condition = e.condition.transform(n);
        });
        e(Ne, function(e, n) {
            e.condition = e.condition.transform(n);
            e.body = e.body.transform(n);
        });
        e(Pe, function(e, n) {
            if (e.init) e.init = e.init.transform(n);
            if (e.condition) e.condition = e.condition.transform(n);
            if (e.step) e.step = e.step.transform(n);
            e.body = e.body.transform(n);
        });
        e(Re, function(e, n) {
            e.init = e.init.transform(n);
            e.object = e.object.transform(n);
            e.body = e.body.transform(n);
        });
        e(Ie, function(e, n) {
            e.expression = e.expression.transform(n);
            e.body = e.body.transform(n);
        });
        e(Xe, function(e, n) {
            if (e.value) e.value = e.value.transform(n);
        });
        e(Ze, function(e, n) {
            if (e.label) e.label = e.label.transform(n);
        });
        e(tn, function(e, n) {
            e.condition = e.condition.transform(n);
            e.body = e.body.transform(n);
            if (e.alternative) e.alternative = e.alternative.transform(n);
        });
        e(rn, function(e, n) {
            e.expression = e.expression.transform(n);
            e.body = t(e.body, n);
        });
        e(sn, function(e, n) {
            e.expression = e.expression.transform(n);
            e.body = t(e.body, n);
        });
        e(fn, function(e, n) {
            e.body = t(e.body, n);
            if (e.bcatch) e.bcatch = e.bcatch.transform(n);
            if (e.bfinally) e.bfinally = e.bfinally.transform(n);
        });
        e(un, function(e, n) {
            e.argname = e.argname.transform(n);
            e.body = t(e.body, n);
        });
        e(ln, function(e, n) {
            e.definitions = t(e.definitions, n);
        });
        e(hn, function(e, n) {
            e.name = e.name.transform(n);
            if (e.value) e.value = e.value.transform(n);
        });
        e(Le, function(e, n) {
            if (e.name) e.name = e.name.transform(n);
            e.argnames = t(e.argnames, n);
            e.body = t(e.body, n);
        });
        e(dn, function(e, n) {
            e.expression = e.expression.transform(n);
            e.args = t(e.args, n);
        });
        e(_n, function(e, n) {
            e.expressions = t(e.expressions, n);
        });
        e(gn, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(bn, function(e, n) {
            e.expression = e.expression.transform(n);
            e.property = e.property.transform(n);
        });
        e(yn, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(En, function(e, n) {
            e.left = e.left.transform(n);
            e.right = e.right.transform(n);
        });
        e(An, function(e, n) {
            e.condition = e.condition.transform(n);
            e.consequent = e.consequent.transform(n);
            e.alternative = e.alternative.transform(n);
        });
        e(Dn, function(e, n) {
            e.elements = t(e.elements, n);
        });
        e(Fn, function(e, n) {
            e.properties = t(e.properties, n);
        });
        e(Cn, function(e, n) {
            e.value = e.value.transform(n);
        });
    })(function(e, r) {
        e.DEFMETHOD("transform", function(e, n) {
            var t, i;
            e.push(this);
            if (e.before) t = e.before(this, r, n);
            if (typeof t === "undefined") {
                t = this;
                r(t, e);
                if (e.after) {
                    i = e.after(t, n);
                    if (typeof i !== "undefined") t = i;
                }
            }
            e.pop();
            return t;
        });
    });
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function b(e, n, t, i) {
        this.eliminated = 0;
        this.global = false;
        this.id = e;
        this.init = i;
        this.lambda = t instanceof Mn;
        this.mangled_name = null;
        this.name = t.name;
        this.orig = [ t ];
        this.references = [];
        this.replaced = 0;
        this.scope = n;
        this.undeclared = false;
    }
    b.prototype = {
        unmangleable: function(e) {
            return this.global && !e.toplevel || this.undeclared || !e.eval && this.scope.pinned() || e.keep_fnames && (this.orig[0] instanceof Mn || this.orig[0] instanceof $n);
        },
        mangle: function(e) {
            var n = e.cache && e.cache.props;
            if (this.global && n && n.has(this.name)) {
                this.mangled_name = n.get(this.name);
            } else if (!this.mangled_name && !this.unmangleable(e)) {
                var t;
                if (t = this.redefined()) {
                    this.mangled_name = t.mangled_name || t.name;
                } else {
                    this.mangled_name = w(this.scope, e, this);
                }
                if (this.global && n) {
                    n.set(this.name, this.mangled_name);
                }
            }
        },
        redefined: function() {
            return this.defun && this.defun.variables.get(this.name);
        }
    };
    Ye.DEFMETHOD("figure_out_scope", function(a) {
        a = ie(a, {
            cache: null,
            ie8: false
        });
        var s = this;
        var f = s.parent_scope = null;
        var u = null;
        var c = new Kn(function(e, n) {
            if (e instanceof un) {
                var t = f;
                f = new Ue(e);
                f.init_scope_vars(t);
                n();
                f = t;
                return true;
            }
            if (e instanceof Ue) {
                e.init_scope_vars(f);
                var t = f;
                var i = u;
                u = f = e;
                n();
                f = t;
                u = i;
                return true;
            }
            if (e instanceof Ie) {
                for (var r = f; r; r = r.parent_scope) r.uses_with = true;
                return;
            }
            if (e instanceof Sn) {
                e.scope = f;
            }
            if (e instanceof pe) {
                e.thedef = e;
                e.references = [];
            }
            if (e instanceof $n) {
                (e.scope = u.parent_scope.resolve()).def_function(e, u);
            } else if (e instanceof Mn) {
                var o = u.def_function(e, e.name == "arguments" ? undefined : u);
                if (a.ie8) o.defun = u.parent_scope.resolve();
            } else if (e instanceof On) {
                u.def_variable(e, e.TYPE == "SymbolVar" ? null : undefined);
                if (u !== f) {
                    e.mark_enclosed(a);
                    var o = f.find_variable(e);
                    if (e.thedef !== o) {
                        e.thedef = o;
                    }
                    e.reference(a);
                }
            } else if (e instanceof qn) {
                f.def_variable(e).defun = u;
            }
        });
        s.next_def_id = 0;
        s.walk(c);
        s.globals = new Ae();
        var c = new Kn(function(e) {
            if (e instanceof Ze) {
                if (e.label) e.label.thedef.references.push(e);
                return true;
            }
            if (e instanceof jn) {
                var n = e.name;
                var t = e.scope.find_variable(n);
                if (!t) {
                    t = s.def_global(e);
                } else if (t.scope instanceof Le && n == "arguments") {
                    t.scope.uses_arguments = true;
                }
                if (n == "eval") {
                    var i = c.parent();
                    if (i.TYPE == "Call" && i.expression === e) {
                        for (var r = e.scope; r && !r.uses_eval; r = r.parent_scope) {
                            r.uses_eval = true;
                        }
                    } else if (t.undeclared) {
                        s.uses_eval = true;
                    }
                }
                e.thedef = t;
                e.reference(a);
                return true;
            }
            if (e instanceof qn) {
                var o = e.definition().redefined();
                if (o) for (var r = e.scope; r; r = r.parent_scope) {
                    v(r.enclosed, o);
                    if (r === o.scope) break;
                }
                return true;
            }
        });
        s.walk(c);
        if (a.ie8) s.walk(new Kn(function(e) {
            if (e instanceof qn) {
                var n = e.thedef.defun;
                if (n.name instanceof Mn && n.name.name == e.name) {
                    n = n.parent_scope.resolve();
                }
                i(e, n);
                return true;
            }
            if (e instanceof Mn) {
                var t = e.thedef;
                i(e, e.scope.parent_scope.resolve());
                if (typeof e.thedef.init !== "undefined") {
                    e.thedef.init = false;
                } else if (t.init) {
                    e.thedef.init = t.init;
                }
                return true;
            }
        }));
        function i(e, n) {
            var t = e.name;
            var i = e.thedef;
            var r = n.find_variable(t);
            if (r) {
                var o;
                while (o = r.redefined()) r = o;
            } else {
                r = s.globals.get(t);
            }
            if (r) {
                r.orig.push(e);
            } else {
                r = n.def_variable(e);
            }
            i.orig.concat(i.references).forEach(function(e) {
                e.thedef = r;
                e.reference(a);
            });
            if (i.lambda) r.lambda = true;
            if (r.undeclared) s.variables.set(t, r);
        }
    });
    Ue.DEFMETHOD("make_def", function(e, n) {
        var t = this;
        while (t.parent_scope) t = t.parent_scope;
        return new b(++t.next_def_id, this, e, n);
    });
    Ye.DEFMETHOD("def_global", function(e) {
        var n = this.globals, t = e.name;
        if (n.has(t)) {
            return n.get(t);
        } else {
            var i = this.make_def(e);
            i.undeclared = true;
            i.global = true;
            n.set(t, i);
            return i;
        }
    });
    Ue.DEFMETHOD("init_scope_vars", function(e) {
        this.variables = new Ae();
        this.functions = new Ae();
        this.uses_with = false;
        this.uses_eval = false;
        this.parent_scope = e;
        this.enclosed = [];
        this.cname = -1;
    });
    Le.DEFMETHOD("init_scope_vars", function() {
        Ue.prototype.init_scope_vars.apply(this, arguments);
        this.uses_arguments = false;
        this.def_variable(new zn({
            name: "arguments",
            start: this.start,
            end: this.end
        }));
    });
    Sn.DEFMETHOD("mark_enclosed", function(e) {
        var n = this.definition();
        for (var t = this.scope; t; t = t.parent_scope) {
            v(t.enclosed, n);
            if (e.keep_fnames) {
                t.functions.each(function(e) {
                    v(n.scope.enclosed, e);
                });
            }
            if (t === n.scope) break;
        }
    });
    Sn.DEFMETHOD("reference", function(e) {
        this.definition().references.push(this);
        this.mark_enclosed(e);
    });
    Ue.DEFMETHOD("find_variable", function(e) {
        if (e instanceof Sn) e = e.name;
        return this.variables.get(e) || this.parent_scope && this.parent_scope.find_variable(e);
    });
    Ue.DEFMETHOD("def_function", function(e, n) {
        var t = this.def_variable(e, n);
        if (!t.init || t.init instanceof Je) t.init = n;
        this.functions.set(e.name, t);
        return t;
    });
    Ue.DEFMETHOD("def_variable", function(e, n) {
        var t = this.variables.get(e.name);
        if (t) {
            t.orig.push(e);
            if (t.init instanceof We) t.init = n;
        } else {
            t = this.make_def(e, n);
            this.variables.set(e.name, t);
            t.global = !this.parent_scope;
        }
        return e.thedef = t;
    });
    Le.DEFMETHOD("resolve", R);
    Ue.DEFMETHOD("resolve", function() {
        return this.parent_scope.resolve();
    });
    Ye.DEFMETHOD("resolve", R);
    function y(e, n) {
        var t = e.names_in_use;
        if (!t) {
            e.names_in_use = t = Object.create(e.mangled_names || null);
            e.cname_holes = [];
            var i = n.cache && n.cache.props;
            e.enclosed.forEach(function(e) {
                if (e.unmangleable(n)) t[e.name] = true;
                if (e.global && i && i.has(e.name)) {
                    t[i.get(e.name)] = true;
                }
            });
        }
        return t;
    }
    function w(e, i, n) {
        var t = y(e, i);
        var r = e.cname_holes;
        var o = Object.create(null);
        var a = [ e ];
        n.references.forEach(function(e) {
            var n = e.scope;
            do {
                if (a.indexOf(n) < 0) {
                    for (var t in y(n, i)) {
                        o[t] = true;
                    }
                    a.push(n);
                } else break;
            } while (n = n.parent_scope);
        });
        var s;
        for (var f = 0; f < r.length; f++) {
            s = E(r[f]);
            if (o[s]) continue;
            r.splice(f, 1);
            e.names_in_use[s] = true;
            return s;
        }
        while (true) {
            s = E(++e.cname);
            if (t[s] || g[s] || i.reserved.has[s]) continue;
            if (!o[s]) break;
            r.push(e.cname);
        }
        e.names_in_use[s] = true;
        return s;
    }
    Sn.DEFMETHOD("unmangleable", function(e) {
        var n = this.definition();
        return !n || n.unmangleable(e);
    });
    pe.DEFMETHOD("unmangleable", ye);
    Sn.DEFMETHOD("unreferenced", function() {
        return !this.definition().references.length && !this.scope.pinned();
    });
    Sn.DEFMETHOD("definition", function() {
        return this.thedef;
    });
    Sn.DEFMETHOD("global", function() {
        return this.definition().global;
    });
    function x(e) {
        e = ie(e, {
            eval: false,
            ie8: false,
            keep_fnames: false,
            reserved: [],
            toplevel: false
        });
        if (!Array.isArray(e.reserved)) e.reserved = [];
        v(e.reserved, "arguments");
        e.reserved.has = se(e.reserved);
        return e;
    }
    Ye.DEFMETHOD("mangle_names", function(s) {
        s = x(s);
        var f = -1;
        if (s.cache && s.cache.props) {
            var n = this.mangled_names = Object.create(null);
            s.cache.props.each(function(e) {
                n[e] = true;
            });
        }
        var r = [];
        var u = new Kn(function(e, n) {
            if (e instanceof Me) {
                var t = f;
                n();
                f = t;
                return true;
            }
            if (e instanceof Ue) {
                n();
                if (s.cache && e instanceof Ye) {
                    e.globals.each(c);
                }
                if (e instanceof Je && u.has_directive("use asm")) {
                    var i = new jn(e.name);
                    i.scope = e;
                    i.reference(s);
                }
                e.variables.each(function(e) {
                    if (!l(e)) c(e);
                });
                return true;
            }
            if (e instanceof pe) {
                var r;
                do {
                    r = E(++f);
                } while (g[r]);
                e.mangled_name = r;
                return true;
            }
            if (!s.ie8 && e instanceof un) {
                var o = e.argname.definition();
                var a = l(o, e.argname);
                n();
                if (!a) c(o);
                return true;
            }
        });
        this.walk(u);
        r.forEach(c);
        function c(e) {
            if (s.reserved.has[e.name]) return;
            e.mangle(s);
        }
        function l(n, e) {
            var t = n.redefined();
            if (!t) return false;
            r.push(n);
            n.references.forEach(i);
            if (e) i(e);
            return true;
            function i(e) {
                e.thedef = t;
                e.reference(s);
                e.thedef = n;
            }
        }
    });
    Ye.DEFMETHOD("find_colliding_names", function(t) {
        var i = t.cache && t.cache.props;
        var n = Object.create(null);
        t.reserved.forEach(r);
        this.globals.each(o);
        this.walk(new Kn(function(e) {
            if (e instanceof Ue) e.variables.each(o);
            if (e instanceof qn) o(e.definition());
        }));
        return n;
        function r(e) {
            n[e] = true;
        }
        function o(e) {
            var n = e.name;
            if (e.global && i && i.has(n)) n = i.get(n); else if (!e.unmangleable(t)) return;
            r(n);
        }
    });
    Ye.DEFMETHOD("expand_names", function(i) {
        E.reset();
        E.sort();
        i = x(i);
        var n = this.find_colliding_names(i);
        var t = 0;
        this.globals.each(o);
        this.walk(new Kn(function(e) {
            if (e instanceof Ue) e.variables.each(o);
            if (e instanceof qn) o(e.definition());
        }));
        function r() {
            var e;
            do {
                e = E(t++);
            } while (n[e] || g[e]);
            return e;
        }
        function o(e) {
            if (e.global && i.cache) return;
            if (e.unmangleable(i)) return;
            if (i.reserved.has[e.name]) return;
            var n = e.redefined();
            var t = n ? n.rename || n.name : r();
            e.rename = t;
            e.orig.forEach(function(e) {
                e.name = t;
            });
            e.references.forEach(function(e) {
                e.name = t;
            });
        }
    });
    De.DEFMETHOD("tail_node", R);
    _n.DEFMETHOD("tail_node", function() {
        return this.expressions[this.expressions.length - 1];
    });
    Ye.DEFMETHOD("compute_char_frequency", function(t) {
        t = x(t);
        E.reset();
        try {
            De.prototype.print = function(e, n) {
                this._print(e, n);
                if (this instanceof Sn && !this.unmangleable(t)) {
                    E.consider(this.name, -1);
                } else if (t.properties) {
                    if (this instanceof gn) {
                        E.consider(this.property, -1);
                    } else if (this instanceof bn) {
                        i(this.property);
                    }
                }
            };
            E.consider(this.print_to_string(), 1);
        } finally {
            De.prototype.print = De.prototype._print;
        }
        E.sort();
        function i(e) {
            if (e instanceof Pn) {
                E.consider(e.value, -1);
            } else if (e instanceof An) {
                i(e.consequent);
                i(e.alternative);
            } else if (e instanceof _n) {
                i(e.tail_node());
            }
        }
    });
    var E = function() {
        var r = Object.create(null);
        function e(e) {
            var n = [];
            for (var t = 0; t < e.length; t++) {
                var i = e[t];
                n.push(i);
                r[i] = -.01 * t;
            }
            return n;
        }
        var n = e("0123456789");
        var t = e("abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ$_");
        var i, o;
        function a() {
            o = Object.create(r);
        }
        f.consider = function(e, n) {
            for (var t = e.length; --t >= 0; ) {
                o[e[t]] += n;
            }
        };
        function s(e, n) {
            return o[n] - o[e];
        }
        f.sort = function() {
            i = t.sort(s).concat(n.sort(s));
        };
        f.reset = a;
        a();
        function f(e) {
            var n = "", t = 54;
            e++;
            do {
                e--;
                n += i[e % t];
                e = Math.floor(e / t);
                t = 64;
            } while (e > 0);
            return n;
        }
        return f;
    }();
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function st(e) {
        return e.type == "comment2" && /@preserve|@license|@cc_on/i.test(e.value);
    }
    function ft(f) {
        var e = !f;
        f = ie(f, {
            ascii_only: false,
            beautify: false,
            braces: false,
            comments: false,
            ie8: false,
            indent_level: 4,
            indent_start: 0,
            inline_script: true,
            keep_quoted_props: false,
            max_line_len: false,
            preamble: null,
            preserve_line: false,
            quote_keys: false,
            quote_style: 0,
            semicolons: true,
            shebang: true,
            source_map: null,
            webkit: false,
            width: 80,
            wrap_iife: false
        }, true);
        var u = ye;
        if (f.comments) {
            var n = f.comments;
            if (typeof f.comments === "string" && /^\/.*\/[a-zA-Z]*$/.test(f.comments)) {
                var t = f.comments.lastIndexOf("/");
                n = new RegExp(f.comments.substr(1, t - 1), f.comments.substr(t + 1));
            }
            if (n instanceof RegExp) {
                u = function(e) {
                    return e.type != "comment5" && n.test(e.value);
                };
            } else if (typeof n === "function") {
                u = function(e) {
                    return e.type != "comment5" && n(this, e);
                };
            } else if (n === "some") {
                u = st;
            } else {
                u = oe;
            }
        }
        var r = 0;
        var o = 0;
        var a = 1;
        var c = 0;
        var s = "";
        var l = f.ascii_only ? function(e, t) {
            return e.replace(/[\u0000-\u001f\u007f-\uffff]/g, function(e) {
                var n = e.charCodeAt(0).toString(16);
                if (n.length <= 2 && !t) {
                    while (n.length < 2) n = "0" + n;
                    return "\\x" + n;
                } else {
                    while (n.length < 4) n = "0" + n;
                    return "\\u" + n;
                }
            });
        } : function(e) {
            var n = "";
            for (var t = 0, i = 0; t < e.length; t++) {
                var r = e.charCodeAt(t);
                if (ee(r)) {
                    if (ne(e.charCodeAt(t + 1))) {
                        t++;
                        continue;
                    }
                } else if (!ne(r)) {
                    continue;
                }
                n += e.slice(i, t) + "\\u" + r.toString(16);
                i = t + 1;
            }
            return i == 0 ? e : n + e.slice(i);
        };
        function i(t, e) {
            var i = 0, r = 0;
            t = t.replace(/[\\\b\f\n\r\v\t\x22\x27\u2028\u2029\0\ufeff]/g, function(e, n) {
                switch (e) {
                  case '"':
                    ++i;
                    return '"';

                  case "'":
                    ++r;
                    return "'";

                  case "\\":
                    return "\\\\";

                  case "\n":
                    return "\\n";

                  case "\r":
                    return "\\r";

                  case "\t":
                    return "\\t";

                  case "\b":
                    return "\\b";

                  case "\f":
                    return "\\f";

                  case "\v":
                    return f.ie8 ? "\\x0B" : "\\v";

                  case "\u2028":
                    return "\\u2028";

                  case "\u2029":
                    return "\\u2029";

                  case "\ufeff":
                    return "\\ufeff";

                  case "\0":
                    return /[0-9]/.test(t.charAt(n + 1)) ? "\\x00" : "\\0";
                }
                return e;
            });
            function n() {
                return "'" + t.replace(/\x27/g, "\\'") + "'";
            }
            function o() {
                return '"' + t.replace(/\x22/g, '\\"') + '"';
            }
            t = l(t);
            switch (f.quote_style) {
              case 1:
                return n();

              case 2:
                return o();

              case 3:
                return e == "'" ? n() : o();

              default:
                return i > r ? n() : o();
            }
        }
        function p(e, n) {
            var t = i(e, n);
            if (f.inline_script) {
                t = t.replace(/<\x2f(script)([>\/\t\n\f\r ])/gi, "<\\/$1$2");
                t = t.replace(/\x3c!--/g, "\\x3c!--");
                t = t.replace(/--\x3e/g, "--\\x3e");
            }
            return t;
        }
        function h(e) {
            e = e.toString();
            e = l(e, true);
            return e;
        }
        function d(e) {
            return Q(" ", f.indent_start + r - e * f.indent_level);
        }
        var v = false;
        var _ = 0;
        var m = true;
        var g = false;
        var b = false;
        var y = false;
        var w = false;
        var x = -1;
        var E = "";
        var A, k, D = f.source_map && [];
        var F = D ? function(n, t) {
            D.forEach(function(e) {
                e.line += n;
                e.col += t;
            });
        } : re;
        var C = D ? function() {
            D.forEach(function(e) {
                f.source_map.add(e.token.file, e.line, e.col, e.token.line, e.token.col, !e.name && e.token.type == "name" ? e.token.value : e.name);
            });
            D = [];
        } : re;
        function B(e) {
            var n = s.lastIndexOf("\n");
            if (_ < n) _ = n;
            var t = s.slice(0, _);
            var i = s.slice(_);
            F(e, i.length - o);
            a += e;
            c += e;
            o = i.length;
            s = t;
            while (e--) s += "\n";
            s += i;
        }
        var S = f.max_line_len ? function() {
            if (m) {
                if (o > f.max_line_len) {
                    De.warn("Output exceeds {max_line_len} characters", f);
                }
                return;
            }
            if (o > f.max_line_len) B(1);
            m = true;
            C();
        } : re;
        var T = se("( [ + * / - , .");
        function O(e) {
            e = String(e);
            var n = e.charAt(0);
            if (y && n) {
                y = false;
                if (n != "\n") {
                    O("\n");
                    $();
                }
            }
            if (w && n) {
                w = false;
                if (!/[\s;})]/.test(n)) {
                    z();
                }
            }
            x = -1;
            var t = E.slice(-1);
            if (b) {
                b = false;
                if (t == ":" && n == "}" || (!n || ";}".indexOf(n) < 0) && t != ";") {
                    if (f.semicolons || T[n]) {
                        s += ";";
                        o++;
                        c++;
                    } else {
                        S();
                        s += "\n";
                        c++;
                        a++;
                        o = 0;
                        if (/^\s+$/.test(e)) {
                            b = true;
                        }
                    }
                    if (!f.beautify) g = false;
                }
            }
            if (g) {
                if (ve(t) && (ve(n) || n == "\\") || n == "/" && n == t || (n == "+" || n == "-") && n == E || e == "--" && E == "!" || E == "--" && n == ">") {
                    s += " ";
                    o++;
                    c++;
                }
                if (t != "<" || e != "!") g = false;
            }
            if (A) {
                D.push({
                    token: A,
                    name: k,
                    line: a,
                    col: o
                });
                A = false;
                if (m) C();
            }
            s += e;
            v = e.slice(-1) == "(";
            c += e.length;
            var i = e.split(/\r?\n/), r = i.length - 1;
            a += r;
            o += i[0].length;
            if (r > 0) {
                S();
                o = i[r].length;
            }
            E = e;
        }
        var z = f.beautify ? function() {
            O(" ");
        } : function() {
            g = true;
        };
        var $ = f.beautify ? function(e) {
            if (f.beautify) {
                O(d(e ? .5 : 0));
            }
        } : re;
        var M = f.beautify ? function(e, n) {
            if (e === true) e = P();
            var t = r;
            r = e;
            var i = n();
            r = t;
            return i;
        } : function(e, n) {
            return n();
        };
        var q = f.max_line_len || f.preserve_line ? function() {
            S();
            _ = s.length;
            m = false;
        } : re;
        var j = f.beautify ? function() {
            if (x < 0) return O("\n");
            if (s[x] != "\n") {
                s = s.slice(0, x) + "\n" + s.slice(x);
                c++;
                a++;
            }
            x++;
        } : q;
        var H = f.beautify ? function() {
            O(";");
        } : function() {
            b = true;
        };
        function N() {
            if (b) O(";");
            O(";");
        }
        function P() {
            return r + f.indent_level;
        }
        function R(e) {
            var n;
            O("{");
            j();
            M(P(), function() {
                n = e();
            });
            $();
            O("}");
            return n;
        }
        function I(e) {
            O("(");
            q();
            var n = e();
            q();
            O(")");
            return n;
        }
        function U(e) {
            O("[");
            q();
            var n = e();
            q();
            O("]");
            return n;
        }
        function Y() {
            q();
            O(",");
            q();
            z();
        }
        function L() {
            O(":");
            z();
        }
        var V = D ? function(e, n) {
            A = e;
            k = n;
        } : re;
        function W() {
            if (!m) S();
            return s;
        }
        function J() {
            var e = s.lastIndexOf("\n");
            return /^ *$/.test(s.slice(e + 1));
        }
        function G(e) {
            var i = this;
            var r = e instanceof Xe && e.value;
            var o = s(e);
            if (!o) o = [];
            if (r) {
                var a = new Kn(function(e) {
                    var n = a.parent();
                    if (n instanceof Xe || n instanceof En && n.left === e || n.TYPE == "Call" && n.expression === e || n instanceof An && n.condition === e || n instanceof gn && n.expression === e || n instanceof _n && n.expressions[0] === e || n instanceof bn && n.expression === e || n instanceof xn) {
                        var t = s(e);
                        if (t) o = o.concat(t);
                    } else {
                        return true;
                    }
                });
                a.push(e);
                e.value.walk(a);
            }
            if (c == 0) {
                if (o.length > 0 && f.shebang && o[0].type == "comment5") {
                    O("#!" + o.shift().value + "\n");
                    $();
                }
                var n = f.preamble;
                if (n) {
                    O(n.replace(/\r\n?|[\n\u2028\u2029]|\s*$/g, "\n"));
                }
            }
            o = o.filter(u, e);
            if (o.length == 0) return;
            var t = J();
            o.forEach(function(e, n) {
                if (!t) {
                    if (e.nlb) {
                        O("\n");
                        $();
                        t = true;
                    } else if (n > 0) {
                        z();
                    }
                }
                if (/comment[134]/.test(e.type)) {
                    O("//" + e.value.replace(/[@#]__PURE__/g, " ") + "\n");
                    $();
                    t = true;
                } else if (e.type == "comment2") {
                    O("/*" + e.value.replace(/[@#]__PURE__/g, " ") + "*/");
                    t = false;
                }
            });
            if (!t) {
                if (e.start.nlb) {
                    O("\n");
                    $();
                } else {
                    z();
                }
            }
            function s(e) {
                var n = e.start;
                if (!n) {
                    if (!r) return;
                    e.start = n = new Z();
                }
                var t = n.comments_before;
                if (!t) {
                    if (!r) return;
                    n.comments_before = t = [];
                }
                if (t._dumped === i) return;
                t._dumped = i;
                return t;
            }
        }
        function X(e, t) {
            var n = this;
            var i = e.end;
            if (!i) return;
            var r = i[t ? "comments_before" : "comments_after"];
            if (!r || r._dumped === n) return;
            if (!(e instanceof Fe || Ee(r, function(e) {
                return !/comment[134]/.test(e.type);
            }))) return;
            r._dumped = n;
            var o = s.length;
            r.filter(u, e).forEach(function(e, n) {
                w = false;
                if (y) {
                    O("\n");
                    $();
                    y = false;
                } else if (e.nlb && (n > 0 || !J())) {
                    O("\n");
                    $();
                } else if (n > 0 || !t) {
                    z();
                }
                if (/comment[134]/.test(e.type)) {
                    O("//" + e.value.replace(/[@#]__PURE__/g, " "));
                    y = true;
                } else if (e.type == "comment2") {
                    O("/*" + e.value.replace(/[@#]__PURE__/g, " ") + "*/");
                    w = true;
                }
            });
            if (s.length > o) x = o;
        }
        var K = [];
        return {
            get: W,
            toString: W,
            indent: $,
            indentation: function() {
                return r;
            },
            current_width: function() {
                return o - r;
            },
            should_break: function() {
                return f.width && this.current_width() >= f.width;
            },
            has_parens: function() {
                return v;
            },
            newline: j,
            print: O,
            space: z,
            comma: Y,
            colon: L,
            last: function() {
                return E;
            },
            semicolon: H,
            force_semicolon: N,
            to_utf8: l,
            print_name: function(e) {
                O(h(e));
            },
            print_string: function(e, n) {
                O(p(e, n));
            },
            next_indent: P,
            with_indent: M,
            with_block: R,
            with_parens: I,
            with_square: U,
            add_mapping: V,
            option: function(e) {
                return f[e];
            },
            prepend_comments: e ? re : G,
            append_comments: e || u === ye ? re : X,
            line: function() {
                return a;
            },
            col: function() {
                return o;
            },
            pos: function() {
                return c;
            },
            push_node: function(e) {
                K.push(e);
            },
            pop_node: f.preserve_line ? function() {
                var e = K.pop();
                if (e.start && e.start.line > a) {
                    B(e.start.line - a);
                }
            } : function() {
                K.pop();
            },
            parent: function(e) {
                return K[K.length - 2 - (e || 0)];
            }
        };
    }
    (function() {
        function e(e, n) {
            e.DEFMETHOD("_codegen", n);
        }
        var s = false;
        De.DEFMETHOD("print", function(e, n) {
            var t = this, i = t._codegen;
            function r() {
                e.prepend_comments(t);
                t.add_source_map(e);
                i(t, e);
                e.append_comments(t);
            }
            e.push_node(t);
            if (n || t.needs_parens(e)) {
                e.with_parens(r);
            } else {
                r();
            }
            e.pop_node();
        });
        De.DEFMETHOD("_print", De.prototype.print);
        De.DEFMETHOD("print_to_string", function(e) {
            var n = ft(e);
            this.print(n);
            return n.get();
        });
        function t(e, n) {
            if (Array.isArray(e)) {
                e.forEach(function(e) {
                    t(e, n);
                });
            } else {
                e.DEFMETHOD("needs_parens", n);
            }
        }
        t(De, ye);
        t(We, function(e) {
            if (!e.has_parens() && ke(e)) return true;
            if (e.option("webkit")) {
                var n = e.parent();
                if (n instanceof mn && n.expression === this) return true;
            }
            if (e.option("wrap_iife")) {
                var n = e.parent();
                if (n instanceof dn && n.expression === this) return true;
            }
        });
        t(Fn, function(e) {
            return !e.has_parens() && ke(e);
        });
        t(yn, function(e) {
            var n = e.parent();
            return n instanceof mn && n.expression === this || n instanceof dn && n.expression === this;
        });
        t(_n, function(e) {
            var n = e.parent();
            return n instanceof dn || n instanceof yn || n instanceof En || n instanceof hn || n instanceof mn && n.expression === this || n instanceof Dn || n instanceof Cn || n instanceof An;
        });
        t(En, function(e) {
            var n = e.parent();
            if (n instanceof dn && n.expression === this) return true;
            if (n instanceof yn) return true;
            if (n instanceof mn && n.expression === this) return true;
            if (n instanceof En) {
                var t = n.operator, i = it[t];
                var r = this.operator, o = it[r];
                if (i > o || i == o && this === n.right) {
                    return true;
                }
            }
        });
        t(mn, function(e) {
            var n = e.parent();
            if (n instanceof vn && n.expression === this) {
                var t = false;
                this.walk(new Kn(function(e) {
                    if (t || e instanceof Ue) return true;
                    if (e instanceof dn) {
                        t = true;
                        return true;
                    }
                }));
                return t;
            }
        });
        t(dn, function(e) {
            var n = e.parent();
            if (n instanceof vn && n.expression === this) return true;
            if (e.option("webkit")) {
                var t = e.parent(1);
                return this.expression instanceof We && n instanceof mn && n.expression === this && t instanceof kn && t.left === n;
            }
        });
        t(vn, function(e) {
            var n = e.parent();
            if (!p(this, e) && (n instanceof mn || n instanceof dn && n.expression === this)) return true;
        });
        t(Rn, function(e) {
            var n = e.parent();
            if (n instanceof mn && n.expression === this) {
                var t = this.value;
                if (t < 0 || /^0/.test(d(t))) {
                    return true;
                }
            }
        });
        t([ kn, An ], function(e) {
            var n = e.parent();
            if (n instanceof yn) return true;
            if (n instanceof En && !(n instanceof kn)) return true;
            if (n instanceof dn && n.expression === this) return true;
            if (n instanceof An && n.condition === this) return true;
            if (n instanceof mn && n.expression === this) return true;
        });
        e(Be, function(e, n) {
            var t = e.quote;
            var i = e.value;
            switch (n.option("quote_style")) {
              case 0:
              case 2:
                if (i.indexOf('"') == -1) t = '"';
                break;

              case 1:
                if (i.indexOf("'") == -1) t = "'";
                break;
            }
            n.print(t + i + t);
            n.semicolon();
        });
        e(Ce, function(e, n) {
            n.print("debugger");
            n.semicolon();
        });
        function i(e, t, i, n) {
            var r = e.length - 1;
            var o = n;
            var a = s;
            e.forEach(function(e, n) {
                if (o) {
                    if (e instanceof Be) {
                        if (e.value == "use asm") s = true;
                    } else if (!(e instanceof $e)) {
                        if (e instanceof Se && e.body instanceof Pn) {
                            i.force_semicolon();
                        }
                        o = false;
                    }
                }
                if (e instanceof $e) return;
                i.indent();
                e.print(i);
                if (n == r && t) return;
                i.newline();
                if (t) i.newline();
            });
            s = a;
        }
        _.DEFMETHOD("_do_print_body", function(e) {
            l(this.body, e);
        });
        e(Fe, function(e, n) {
            e.body.print(n);
            n.semicolon();
        });
        e(Ye, function(e, n) {
            i(e.body, true, n, true);
            n.print("");
        });
        e(Me, function(e, n) {
            e.label.print(n);
            n.colon();
            e.body.print(n);
        });
        e(Se, function(e, n) {
            e.body.print(n);
            n.semicolon();
        });
        function r(e, n) {
            n.print("{");
            n.with_indent(n.next_indent(), function() {
                n.append_comments(e, true);
            });
            n.print("}");
        }
        function o(e, n, t) {
            if (e.body.length > 0) {
                n.with_block(function() {
                    i(e.body, false, n, t);
                });
            } else r(e, n);
        }
        e(ze, function(e, n) {
            o(e, n);
        });
        e($e, function(e, n) {
            n.semicolon();
        });
        e(He, function(e, n) {
            n.print("do");
            n.space();
            v(e.body, n);
            n.space();
            n.print("while");
            n.space();
            n.with_parens(function() {
                e.condition.print(n);
            });
            n.semicolon();
        });
        e(Ne, function(e, n) {
            n.print("while");
            n.space();
            n.with_parens(function() {
                e.condition.print(n);
            });
            n.space();
            e._do_print_body(n);
        });
        e(Pe, function(e, n) {
            n.print("for");
            n.space();
            n.with_parens(function() {
                if (e.init) {
                    if (e.init instanceof ln) {
                        e.init.print(n);
                    } else {
                        u(e.init, n, true);
                    }
                    n.print(";");
                    n.space();
                } else {
                    n.print(";");
                }
                if (e.condition) {
                    e.condition.print(n);
                    n.print(";");
                    n.space();
                } else {
                    n.print(";");
                }
                if (e.step) {
                    e.step.print(n);
                }
            });
            n.space();
            e._do_print_body(n);
        });
        e(Re, function(e, n) {
            n.print("for");
            n.space();
            n.with_parens(function() {
                e.init.print(n);
                n.space();
                n.print("in");
                n.space();
                e.object.print(n);
            });
            n.space();
            e._do_print_body(n);
        });
        e(Ie, function(e, n) {
            n.print("with");
            n.space();
            n.with_parens(function() {
                e.expression.print(n);
            });
            n.space();
            e._do_print_body(n);
        });
        Le.DEFMETHOD("_do_print", function(t, e) {
            var n = this;
            if (!e) {
                t.print("function");
            }
            if (n.name) {
                t.space();
                n.name.print(t);
            }
            t.with_parens(function() {
                n.argnames.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
            });
            t.space();
            o(n, t, true);
        });
        e(Le, function(e, n) {
            e._do_print(n);
        });
        function a(e, n, t) {
            e.print(n);
            if (t) {
                e.space();
                t.print(e);
            }
            e.semicolon();
        }
        e(Ke, function(e, n) {
            a(n, "return", e.value);
        });
        e(Qe, function(e, n) {
            a(n, "throw", e.value);
        });
        e(en, function(e, n) {
            a(n, "break", e.label);
        });
        e(nn, function(e, n) {
            a(n, "continue", e.label);
        });
        function f(e, n) {
            var t = e.body;
            if (n.option("braces") || n.option("ie8") && t instanceof He) return v(t, n);
            if (!t) return n.force_semicolon();
            while (true) {
                if (t instanceof tn) {
                    if (!t.alternative) {
                        v(e.body, n);
                        return;
                    }
                    t = t.alternative;
                } else if (t instanceof _) {
                    t = t.body;
                } else break;
            }
            l(e.body, n);
        }
        e(tn, function(e, n) {
            n.print("if");
            n.space();
            n.with_parens(function() {
                e.condition.print(n);
            });
            n.space();
            if (e.alternative) {
                f(e, n);
                n.space();
                n.print("else");
                n.space();
                if (e.alternative instanceof tn) e.alternative.print(n); else l(e.alternative, n);
            } else {
                e._do_print_body(n);
            }
        });
        e(rn, function(e, t) {
            t.print("switch");
            t.space();
            t.with_parens(function() {
                e.expression.print(t);
            });
            t.space();
            var i = e.body.length - 1;
            if (i < 0) r(e, t); else t.with_block(function() {
                e.body.forEach(function(e, n) {
                    t.indent(true);
                    e.print(t);
                    if (n < i && e.body.length > 0) t.newline();
                });
            });
        });
        on.DEFMETHOD("_do_print_body", function(n) {
            n.newline();
            this.body.forEach(function(e) {
                n.indent();
                e.print(n);
                n.newline();
            });
        });
        e(an, function(e, n) {
            n.print("default:");
            e._do_print_body(n);
        });
        e(sn, function(e, n) {
            n.print("case");
            n.space();
            e.expression.print(n);
            n.print(":");
            e._do_print_body(n);
        });
        e(fn, function(e, n) {
            n.print("try");
            n.space();
            o(e, n);
            if (e.bcatch) {
                n.space();
                e.bcatch.print(n);
            }
            if (e.bfinally) {
                n.space();
                e.bfinally.print(n);
            }
        });
        e(un, function(e, n) {
            n.print("catch");
            n.space();
            n.with_parens(function() {
                e.argname.print(n);
            });
            n.space();
            o(e, n);
        });
        e(cn, function(e, n) {
            n.print("finally");
            n.space();
            o(e, n);
        });
        e(pn, function(e, t) {
            t.print("var");
            t.space();
            e.definitions.forEach(function(e, n) {
                if (n) t.comma();
                e.print(t);
            });
            var n = t.parent();
            if (n && n.init !== e || !(n instanceof Pe || n instanceof Re)) t.semicolon();
        });
        function u(e, n, t) {
            var i = false;
            if (t) e.walk(new Kn(function(e) {
                if (i || e instanceof Ue) return true;
                if (e instanceof En && e.operator == "in") {
                    i = true;
                    return true;
                }
            }));
            e.print(n, i);
        }
        e(hn, function(e, n) {
            e.name.print(n);
            if (e.value) {
                n.space();
                n.print("=");
                n.space();
                var t = n.parent(1);
                var i = t instanceof Pe || t instanceof Re;
                u(e.value, n, i);
            }
        });
        e(dn, function(e, t) {
            e.expression.print(t);
            if (e instanceof vn && !p(e, t)) return;
            if (e.expression instanceof dn || e.expression instanceof Le) {
                t.add_mapping(e.start);
            }
            t.with_parens(function() {
                e.args.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
            });
        });
        e(vn, function(e, n) {
            n.print("new");
            n.space();
            dn.prototype._codegen(e, n);
        });
        e(_n, function(e, t) {
            e.expressions.forEach(function(e, n) {
                if (n > 0) {
                    t.comma();
                    if (t.should_break()) {
                        t.newline();
                        t.indent();
                    }
                }
                e.print(t);
            });
        });
        e(gn, function(e, n) {
            var t = e.expression;
            t.print(n);
            var i = e.property;
            if (n.option("ie8") && g[i]) {
                n.print("[");
                n.add_mapping(e.end);
                n.print_string(i);
                n.print("]");
            } else {
                if (t instanceof Rn && t.value >= 0) {
                    if (!/[xa-f.)]/i.test(n.last())) {
                        n.print(".");
                    }
                }
                n.print(".");
                n.add_mapping(e.end);
                n.print_name(i);
            }
        });
        e(bn, function(e, n) {
            e.expression.print(n);
            n.print("[");
            e.property.print(n);
            n.print("]");
        });
        e(wn, function(e, n) {
            var t = e.operator;
            n.print(t);
            if (/^[a-z]/i.test(t) || /[+-]$/.test(t) && e.expression instanceof wn && /^[+-]/.test(e.expression.operator)) {
                n.space();
            }
            e.expression.print(n);
        });
        e(xn, function(e, n) {
            e.expression.print(n);
            n.print(e.operator);
        });
        e(En, function(e, n) {
            e.left.print(n);
            n.space();
            n.print(e.operator);
            n.space();
            e.right.print(n);
        });
        e(An, function(e, n) {
            e.condition.print(n);
            n.space();
            n.print("?");
            n.space();
            e.consequent.print(n);
            n.space();
            n.colon();
            e.alternative.print(n);
        });
        e(Dn, function(n, i) {
            i.with_square(function() {
                var e = n.elements, t = e.length;
                if (t > 0) i.space();
                e.forEach(function(e, n) {
                    if (n) i.comma();
                    e.print(i);
                    if (n === t - 1 && e instanceof Vn) i.comma();
                });
                if (t > 0) i.space();
            });
        });
        e(Fn, function(e, t) {
            if (e.properties.length > 0) t.with_block(function() {
                e.properties.forEach(function(e, n) {
                    if (n) {
                        t.print(",");
                        t.newline();
                    }
                    t.indent();
                    e.print(t);
                });
                t.newline();
            }); else r(e, t);
        });
        function c(e, n, t) {
            if (t.option("quote_keys")) {
                t.print_string(e);
            } else if ("" + +e == e && e >= 0) {
                t.print(d(e));
            } else if (g[e] ? !t.option("ie8") : Qn(e)) {
                if (n && t.option("keep_quoted_props")) {
                    t.print_string(e, n);
                } else {
                    t.print_name(e);
                }
            } else {
                t.print_string(e, n);
            }
        }
        e(Bn, function(e, n) {
            c(e.key, e.quote, n);
            n.colon();
            e.value.print(n);
        });
        Cn.DEFMETHOD("_print_getter_setter", function(e, n) {
            n.print(e);
            n.space();
            c(this.key.name, this.quote, n);
            this.value._do_print(n, true);
        });
        e(ue, function(e, n) {
            e._print_getter_setter("set", n);
        });
        e(ce, function(e, n) {
            e._print_getter_setter("get", n);
        });
        e(Sn, function(e, n) {
            var t = e.definition();
            n.print_name(t && t.mangled_name || e.name);
        });
        e(Vn, re);
        e(Hn, function(e, n) {
            n.print("this");
        });
        e(Nn, function(e, n) {
            n.print(e.value);
        });
        e(Pn, function(e, n) {
            n.print_string(e.value, e.quote);
        });
        e(Rn, function(e, n) {
            if (s && e.start && e.start.raw != null) {
                n.print(e.start.raw);
            } else {
                n.print(d(e.value));
            }
        });
        e(In, function(e, n) {
            var t = e.value;
            var i = t.toString();
            var r = i.lastIndexOf("/");
            if (t.raw_source) {
                i = "/" + t.raw_source + i.slice(r);
            } else if (r == 1) {
                i = "/(?:)" + i.slice(r);
            } else if (i.indexOf("/", 1) < r) {
                i = "/" + i.slice(1, r).replace(/\\\\|[^/]?\//g, function(e) {
                    return e[0] == "\\" ? e : e.slice(0, -1) + "\\/";
                }) + i.slice(r);
            }
            n.print(n.to_utf8(i).replace(/\\(?:\0(?![0-9])|[^\0])/g, function(e) {
                switch (e[1]) {
                  case "\n":
                    return "\\n";

                  case "\r":
                    return "\\r";

                  case "\t":
                    return "\t";

                  case "\b":
                    return "\b";

                  case "\f":
                    return "\f";

                  case "\0":
                    return "\0";

                  case "\v":
                    return "\v";

                  case "\u2028":
                    return "\\u2028";

                  case "\u2029":
                    return "\\u2029";

                  default:
                    return e;
                }
            }).replace(/[\n\r\u2028\u2029]/g, function(e) {
                switch (e) {
                  case "\n":
                    return "\\n";

                  case "\r":
                    return "\\r";

                  case "\u2028":
                    return "\\u2028";

                  case "\u2029":
                    return "\\u2029";
                }
            }));
            var o = n.parent();
            if (o instanceof En && /^in/.test(o.operator) && o.left === e) n.print(" ");
        });
        function l(e, n) {
            if (n.option("braces")) {
                v(e, n);
            } else {
                if (!e || e instanceof $e) n.force_semicolon(); else e.print(n);
            }
        }
        function p(e, n) {
            if (e.args.length > 0) return true;
            return n.option("beautify");
        }
        function h(e) {
            var n = e[0], t = n.length;
            for (var i = 1; i < e.length; ++i) {
                if (e[i].length < t) {
                    n = e[i];
                    t = n.length;
                }
            }
            return n;
        }
        function d(e) {
            var n = e.toString(10).replace(/^0\./, ".").replace("e+", "e");
            var t = [ n ];
            if (Math.floor(e) === e) {
                if (e < 0) {
                    t.push("-0x" + (-e).toString(16).toLowerCase());
                } else {
                    t.push("0x" + e.toString(16).toLowerCase());
                }
            }
            var i, r, o;
            if (i = /^\.0+/.exec(n)) {
                r = i[0].length;
                o = n.slice(r);
                t.push(o + "e-" + (o.length + r - 1));
            } else if (i = /0+$/.exec(n)) {
                r = i[0].length;
                t.push(n.slice(0, -r) + "e" + r);
            } else if (i = /^(\d)\.(\d+)e(-?\d+)$/.exec(n)) {
                t.push(i[1] + i[2] + "e" + (i[3] - i[2].length));
            }
            return h(t);
        }
        function v(e, n) {
            if (!e || e instanceof $e) n.print("{}"); else if (e instanceof ze) e.print(n); else n.with_block(function() {
                n.indent();
                e.print(n);
                n.newline();
            });
        }
        function n(e, n) {
            e.forEach(function(e) {
                e.DEFMETHOD("add_source_map", n);
            });
        }
        n([ De, Me ], re);
        n([ Dn, ze, un, Nn, Ce, ln, cn, Ge, Le, vn, Fn, _, Sn, rn, on, fn ], function(e) {
            e.add_mapping(this.start);
        });
        n([ ce, ue ], function(e) {
            e.add_mapping(this.start, this.key.name);
        });
        n([ Cn ], function(e) {
            e.add_mapping(this.start, this.key);
        });
    })();
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function ut(e, n) {
        if (!(this instanceof ut)) return new ut(e, n);
        at.call(this, this.before, this.after);
        this.options = ie(e, {
            arguments: !n,
            assignments: !n,
            booleans: !n,
            collapse_vars: !n,
            comparisons: !n,
            conditionals: !n,
            dead_code: !n,
            directives: !n,
            drop_console: false,
            drop_debugger: !n,
            evaluate: !n,
            expression: false,
            functions: !n,
            global_defs: false,
            hoist_funs: false,
            hoist_props: !n,
            hoist_vars: false,
            ie8: false,
            if_return: !n,
            inline: !n,
            join_vars: !n,
            keep_fargs: n || "strict",
            keep_fnames: false,
            keep_infinity: false,
            loops: !n,
            negate_iife: !n,
            objects: !n,
            passes: 1,
            properties: !n,
            pure_getters: !n && "strict",
            pure_funcs: null,
            reduce_funcs: !n,
            reduce_vars: !n,
            sequences: !n,
            side_effects: !n,
            strings: !n,
            switches: !n,
            top_retain: null,
            toplevel: !!(e && e["top_retain"]),
            typeofs: !n,
            unsafe: false,
            unsafe_comps: false,
            unsafe_Function: false,
            unsafe_math: false,
            unsafe_proto: false,
            unsafe_regexp: false,
            unsafe_undefined: false,
            unused: !n
        }, true);
        var t = this.options["evaluate"];
        this.eval_threshold = /eager/.test(t) ? 1 / 0 : +t;
        var i = this.options["global_defs"];
        if (typeof i == "object") for (var r in i) {
            if (/^@/.test(r) && fe(i, r)) {
                i[r.slice(1)] = ot(i[r], {
                    expression: true
                });
            }
        }
        if (this.options["inline"] === true) this.options["inline"] = 3;
        var o = this.options["keep_fargs"];
        this.drop_fargs = o == "strict" ? function(e, n) {
            if (e.length_read) return false;
            var t = e.name;
            if (!t) return n && n.TYPE == "Call" && n.expression === e;
            if (t.fixed_value() !== e) return false;
            var i = t.definition();
            if (i.direct_access) return false;
            var r = i.escaped;
            return r && r.depth != 1;
        } : o ? ye : oe;
        var a = this.options["pure_funcs"];
        if (typeof a == "function") {
            this.pure_funcs = a;
        } else if (typeof a == "string") {
            this.pure_funcs = function(e) {
                return a !== e.expression.print_to_string();
            };
        } else if (Array.isArray(a)) {
            this.pure_funcs = function(e) {
                return !be(e.expression.print_to_string(), a);
            };
        } else {
            this.pure_funcs = oe;
        }
        var s = this.options["sequences"];
        this.sequences_limit = s == 1 ? 800 : s | 0;
        var f = this.options["top_retain"];
        if (f instanceof RegExp) {
            this.top_retain = function(e) {
                return f.test(e.name);
            };
        } else if (typeof f == "function") {
            this.top_retain = f;
        } else if (f) {
            if (typeof f == "string") {
                f = f.split(/,/);
            }
            this.top_retain = function(e) {
                return be(e.name, f);
            };
        }
        var u = this.options["toplevel"];
        this.toplevel = typeof u == "string" ? {
            funcs: /funcs/.test(u),
            vars: /vars/.test(u)
        } : {
            funcs: u,
            vars: u
        };
    }
    ut.prototype = new at();
    t(ut.prototype, {
        option: function(e) {
            return this.options[e];
        },
        exposed: function(e) {
            if (e.global) for (var n = 0; n < e.orig.length; n++) if (!this.toplevel[e.orig[n] instanceof $n ? "funcs" : "vars"]) return true;
            return false;
        },
        compress: function(e) {
            e = e.resolve_defines(this);
            if (this.option("expression")) {
                e.process_expression(true);
            }
            var n = +this.options.passes || 1;
            var t = 1 / 0;
            var i = false;
            var r = {
                ie8: this.option("ie8")
            };
            for (var o = 0; o < n; o++) {
                e.figure_out_scope(r);
                if (o > 0 || this.option("reduce_vars")) e.reset_opt_flags(this);
                e = e.transform(this);
                if (n > 1) {
                    var a = 0;
                    e.walk(new Kn(function() {
                        a++;
                    }));
                    De.info("pass " + o + ": last_count: " + t + ", count: " + a);
                    if (a < t) {
                        t = a;
                        i = false;
                    } else if (i) {
                        break;
                    } else {
                        i = true;
                    }
                }
            }
            if (this.option("expression")) {
                e.process_expression(false);
            }
            return e;
        },
        before: function(e, n, t) {
            if (e._squeezed) return e;
            var i = e instanceof Ue;
            if (i) {
                e.hoist_properties(this);
                e.hoist_declarations(this);
                e.process_boolean_returns(this);
            }
            n(e, this);
            n(e, this);
            var r = e.optimize(this);
            if (i && r === e) {
                r.drop_unused(this);
                n(r, this);
            }
            if (r === e) r._squeezed = true;
            return r;
        }
    });
    (function(e) {
        e(De, function(e, n) {
            return e;
        });
        De.DEFMETHOD("equivalent_to", function(e) {
            return this.TYPE == e.TYPE && this.print_to_string() == e.print_to_string();
        });
        Ue.DEFMETHOD("process_expression", function(t, i) {
            var r = this;
            var o = new at(function(e) {
                if (t && e instanceof Se) {
                    return pe(Ke, e, {
                        value: e.body
                    });
                }
                if (!t && e instanceof Ke) {
                    return i ? i(e) : pe(Se, e, {
                        body: e.value || pe(wn, e, {
                            operator: "void",
                            expression: pe(Rn, e, {
                                value: 0
                            })
                        })
                    });
                }
                if (e instanceof Le && e !== r) {
                    return e;
                }
                if (e instanceof Oe) {
                    var n = e.body.length - 1;
                    if (n >= 0) {
                        e.body[n] = e.body[n].transform(o);
                    }
                } else if (e instanceof tn) {
                    e.body = e.body.transform(o);
                    if (e.alternative) {
                        e.alternative = e.alternative.transform(o);
                    }
                } else if (e instanceof Ie) {
                    e.body = e.body.transform(o);
                }
                return e;
            });
            r.transform(o);
        });
        function x(e, n) {
            var t = n.getProperty();
            if (t instanceof De) return;
            var i;
            if (e instanceof Dn) {
                var r = e.elements;
                if (t == "length") return E(r.length, e);
                if (typeof t == "number" && t in r) i = r[t];
            } else if (e instanceof Le) {
                if (t == "length") {
                    e.length_read = true;
                    return E(e.argnames.length, e);
                }
            } else if (e instanceof Fn) {
                t = "" + t;
                var o = e.properties;
                for (var a = o.length; --a >= 0; ) {
                    var s = o[a];
                    if (!(s instanceof Bn)) return;
                    if (!i && o[a].key === t) i = o[a].value;
                }
            }
            return i instanceof jn && i.fixed_value() || i;
        }
        function l(e, n) {
            if (e instanceof Jn) return m.Boolean[n];
            if (e instanceof Rn) return m.Number[n];
            if (e instanceof Pn) return m.String[n];
            if (n == "valueOf") return false;
            if (e instanceof Dn) return m.Array[n];
            if (e instanceof We) return m.Function[n];
            if (e instanceof Fn) return m.Object[n];
            if (e instanceof In) return m.RegExp[n] && !e.value.global;
        }
        function ue(e, n, t, i, r, o, a) {
            var s = n.parent(r);
            if (e.option("unsafe") && s instanceof gn && l(i, s.property)) {
                return;
            }
            var f = ge(t, s);
            if (f) return f;
            if (!o && s instanceof dn && s.expression === t && !s.is_expr_pure(e) && (!(i instanceof We) || !(s instanceof vn) && i.contains_this())) {
                return true;
            }
            if (s instanceof Dn) {
                return ue(e, n, s, s, r + 1);
            }
            if (s instanceof Bn && t === s.value) {
                var u = n.parent(r + 1);
                return ue(e, n, u, u, r + 2);
            }
            if (s instanceof mn && s.expression === t) {
                var c = x(i, s);
                return (!o || a) && ue(e, n, s, c, r + 1);
            }
        }
        function ce(e) {
            if (e.name != "arguments") return false;
            var n = e.orig;
            return n.length == 1 && n[0] instanceof zn;
        }
        (function(e) {
            e(De, re);
            function i(e, n, t) {
                t.assignments = 0;
                t.bool_fn = 0;
                t.cross_loop = false;
                t.direct_access = false;
                t.escaped = [];
                t.fixed = !t.scope.pinned() && !n.exposed(t) && !(t.init instanceof We && t.init !== t.scope) && t.init;
                if (t.fixed instanceof Je && !Ee(t.references, function(e) {
                    var n = e.scope;
                    do {
                        if (t.scope === n) return true;
                    } while (n instanceof We && (n = n.parent_scope));
                })) {
                    e.defun_ids[t.id] = false;
                }
                t.recursive_refs = 0;
                t.references = [];
                t.should_replace = undefined;
                t.single_use = undefined;
            }
            function f(n, t, e) {
                e.variables.each(function(e) {
                    i(n, t, e);
                    if (e.fixed === null) {
                        e.safe_ids = n.safe_ids;
                        h(n, e, true);
                    } else if (e.fixed) {
                        n.loop_ids[e.id] = n.in_loop;
                        h(n, e, true);
                    }
                });
                e.may_call_this = function() {
                    e.may_call_this = re;
                    if (!e.contains_this()) return;
                    e.functions.each(function(e) {
                        if (e.init instanceof Je && !(e.id in n.defun_ids)) {
                            n.defun_ids[e.id] = false;
                        }
                    });
                };
                if (t.option("ie8")) e.variables.each(function(e) {
                    var n = e.orig[0].definition();
                    if (n !== e) n.fixed = false;
                });
            }
            function u(n, t) {
                if (t.id in n.defun_ids) {
                    var e = n.defun_ids[t.id];
                    if (!e) return;
                    var i = n.defun_visited[t.id];
                    if (e === n.safe_ids) {
                        if (!i) return t.fixed;
                    } else if (i) {
                        t.init.enclosed.forEach(function(e) {
                            if (t.init.variables.get(e.name) === e) return;
                            if (!_(n, e)) e.fixed = false;
                        });
                    } else {
                        n.defun_ids[t.id] = false;
                    }
                } else {
                    if (!n.in_loop) {
                        n.defun_ids[t.id] = n.safe_ids;
                        return t.fixed;
                    }
                    n.defun_ids[t.id] = false;
                }
            }
            function c(n, e) {
                e.functions.each(function(e) {
                    if (e.init instanceof Je && !n.defun_visited[e.id]) {
                        n.defun_ids[e.id] = n.safe_ids;
                        e.init.walk(n);
                    }
                });
            }
            function l(e) {
                e.safe_ids = Object.create(e.safe_ids);
            }
            function p(e) {
                e.safe_ids = Object.getPrototypeOf(e.safe_ids);
            }
            function h(e, n, t) {
                e.safe_ids[n.id] = t;
            }
            function d(e, n, t) {
                if (n.fixed === false) return;
                e.assigns.add(n.id, t);
            }
            function v(e, n, t) {
                if (n.fixed === false) return;
                var i = e.assigns.get(n.id);
                if (i) i.forEach(function(e) {
                    e.assigns = i;
                });
                e.assigns.set(n.id, n.assigns = [ t ]);
            }
            function _(e, n) {
                if (n.single_use == "m") return false;
                if (e.safe_ids[n.id]) {
                    if (n.fixed == null) {
                        if (ce(n)) return false;
                        if (n.global && n.name == "arguments") return false;
                        n.fixed = pe(Ln, n.orig[0]);
                    }
                    return true;
                }
                return n.fixed instanceof Je;
            }
            function m(e, n, t) {
                if (n.fixed === undefined) return true;
                if (n.fixed === null && n.safe_ids) {
                    n.safe_ids[n.id] = false;
                    delete n.safe_ids;
                    return true;
                }
                if (!fe(e.safe_ids, n.id)) return false;
                if (!_(e, n)) return false;
                if (n.fixed === false) return false;
                if (n.fixed != null && (!t || n.references.length > n.assignments)) return false;
                return Ee(n.orig, function(e) {
                    return !(e instanceof Mn);
                });
            }
            function g(e, n, t) {
                return n.option("unused") && !t.scope.pinned() && t.references.length - t.recursive_refs == 1;
            }
            function b(e) {
                if (!e) return false;
                return e.is_constant() || e instanceof Le || e instanceof Hn;
            }
            function y(e, n, t, i, r, o, a) {
                var s = e.parent(o);
                if (r && r.is_constant()) return;
                if (s instanceof kn && s.operator == "=" && i === s.right || s instanceof dn && (i !== s.expression || s instanceof vn) || s instanceof Xe && i === s.value && i.scope !== n.scope || s instanceof hn && i === s.value) {
                    n.escaped.push(s);
                    if (a > 1 && !(r && r.is_constant_expression(t))) a = 1;
                    if (!n.escaped.depth || n.escaped.depth > a) n.escaped.depth = a;
                    return;
                } else if (s instanceof Dn || s instanceof En && _e[s.operator] || s instanceof An && i !== s.condition || s instanceof _n && i === s.tail_node()) {
                    y(e, n, t, s, s, o + 1, a);
                } else if (s instanceof Bn && i === s.value) {
                    var f = e.parent(o + 1);
                    y(e, n, t, f, f, o + 2, a);
                } else if (s instanceof mn && i === s.expression) {
                    r = x(r, s);
                    y(e, n, t, s, r, o + 1, a + 1);
                    if (r) return;
                }
                if (o > 0) return;
                if (s instanceof dn && i === s.expression) return;
                if (s instanceof _n && i !== s.tail_node()) return;
                if (s instanceof Se) return;
                if (s instanceof yn && !A[s.operator]) return;
                n.direct_access = true;
            }
            function w(e) {
                if (!(e instanceof bn)) return;
                var n = e.expression;
                if (!(n instanceof jn)) return;
                var t = n.definition();
                if (ce(t) && e.property instanceof Rn) t.reassigned = true;
            }
            var t = new Kn(function(e) {
                if (!(e instanceof Sn)) return;
                var n = e.definition();
                if (!n) return;
                if (e instanceof jn) n.references.push(e);
                n.fixed = false;
            });
            e(Ve, function(e, n, t) {
                l(e);
                f(e, t, this);
                n();
                p(e);
                c(e, this);
                return true;
            });
            e(kn, function(e, n, t) {
                var i = this;
                var r = i.left;
                if (!(r instanceof jn)) {
                    w(r);
                    return;
                }
                if (r.fixed) delete r.fixed;
                var o = r.definition();
                var a = m(e, o, i.right);
                o.assignments++;
                var s = o.fixed;
                if (!s && i.operator != "=") return;
                var f = i.operator == "=";
                var u = f ? i.right : i;
                if (ue(t, e, i, u, 0)) return;
                r.fixed = o.fixed = f ? function() {
                    return i.right;
                } : function() {
                    var e = s instanceof De ? s : s();
                    return e && pe(En, i, {
                        operator: i.operator.slice(0, -1),
                        left: e,
                        right: i.right
                    });
                };
                if (!a) return;
                o.references.push(r);
                h(e, o, false);
                i.right.walk(e);
                h(e, o, true);
                if (f) {
                    y(e, o, r.scope, i, u, 0, 1);
                    v(e, o, i);
                } else {
                    d(e, o, i);
                }
                return true;
            });
            e(En, function(e) {
                if (!_e[this.operator]) return;
                this.left.walk(e);
                l(e);
                this.right.walk(e);
                p(e);
                return true;
            });
            e(dn, function(n, e) {
                n.find_parent(Ue).may_call_this();
                var t = this.expression;
                if (t instanceof We) {
                    this.args.forEach(function(e) {
                        e.walk(n);
                    });
                    t.walk(n);
                    return true;
                } else if (t instanceof jn) {
                    var i = t.definition();
                    if (this.TYPE == "Call" && n.in_boolean_context()) i.bool_fn++;
                    if (!(i.fixed instanceof Je)) return;
                    var r = u(n, i);
                    if (!r) return;
                    e();
                    r.walk(n);
                    return true;
                } else if (this.TYPE == "Call" && t instanceof kn && t.operator == "=" && t.left instanceof jn && n.in_boolean_context()) {
                    t.left.definition().bool_fn++;
                }
            });
            e(sn, function(e) {
                l(e);
                this.expression.walk(e);
                p(e);
                l(e);
                Te(this, e);
                p(e);
                return true;
            });
            e(An, function(e) {
                this.condition.walk(e);
                l(e);
                this.consequent.walk(e);
                p(e);
                l(e);
                this.alternative.walk(e);
                p(e);
                return true;
            });
            e(an, function(e, n) {
                l(e);
                n();
                p(e);
                return true;
            });
            e(Je, function(e, n, t) {
                var i = this.name.definition().id;
                if (e.defun_visited[i]) return true;
                if (e.defun_ids[i] !== e.safe_ids) return true;
                e.defun_visited[i] = true;
                this.inlined = false;
                l(e);
                f(e, t, this);
                n();
                p(e);
                c(e, this);
                return true;
            });
            e(He, function(e) {
                var n = e.in_loop;
                e.in_loop = this;
                l(e);
                this.body.walk(e);
                if (S(this, e.parent())) {
                    p(e);
                    l(e);
                }
                this.condition.walk(e);
                p(e);
                e.in_loop = n;
                return true;
            });
            e(Pe, function(e) {
                if (this.init) this.init.walk(e);
                var n = e.in_loop;
                e.in_loop = this;
                l(e);
                if (this.condition) this.condition.walk(e);
                this.body.walk(e);
                if (this.step) {
                    if (S(this, e.parent())) {
                        p(e);
                        l(e);
                    }
                    this.step.walk(e);
                }
                p(e);
                e.in_loop = n;
                return true;
            });
            e(Re, function(e) {
                this.init.walk(t);
                this.object.walk(e);
                var n = e.in_loop;
                e.in_loop = this;
                l(e);
                this.body.walk(e);
                p(e);
                e.in_loop = n;
                return true;
            });
            e(We, function(r, e, n) {
                var o = this;
                o.inlined = false;
                var a;
                if (!o.name && (a = r.parent()) instanceof dn && a.expression === o) {
                    var t = false;
                    var i = false;
                    o.walk(new Kn(function(e) {
                        if (t) return i = true;
                        if (e instanceof Ke) return t = true;
                        if (e instanceof Ue && e !== o) return true;
                    }));
                    if (i) l(r);
                    f(r, n, o);
                    o.argnames.forEach(function(n, e) {
                        var t = n.definition();
                        if (t.fixed === undefined && (!o.uses_arguments || r.has_directive("use strict"))) {
                            var i = a.args[e];
                            t.fixed = function() {
                                var e = o.argnames.indexOf(n);
                                return (e < 0 ? i : a.args[e]) || pe(Ln, a);
                            };
                            r.loop_ids[t.id] = r.in_loop;
                            h(r, t, true);
                        } else {
                            t.fixed = false;
                        }
                    });
                    e();
                    var s = r.safe_ids;
                    p(r);
                    c(r, o);
                    if (!i) r.safe_ids = s;
                } else {
                    l(r);
                    f(r, n, o);
                    e();
                    p(r);
                    c(r, o);
                }
                return true;
            });
            e(tn, function(e) {
                this.condition.walk(e);
                l(e);
                this.body.walk(e);
                p(e);
                if (this.alternative) {
                    l(e);
                    this.alternative.walk(e);
                    p(e);
                }
                return true;
            });
            e(Me, function(e) {
                l(e);
                this.body.walk(e);
                p(e);
                return true;
            });
            e(qn, function() {
                this.definition().fixed = false;
            });
            e(jn, function(e, n, t) {
                if (this.fixed) delete this.fixed;
                var i = this.definition();
                i.references.push(this);
                if (i.references.length == 1 && !i.fixed && i.orig[0] instanceof $n) {
                    e.loop_ids[i.id] = e.in_loop;
                }
                var r;
                if (i.fixed === undefined || !_(e, i)) {
                    i.fixed = false;
                } else if (i.fixed) {
                    r = this.fixed_value();
                    var o = ee(e, i);
                    if (o) {
                        i.recursive_refs++;
                    } else if (r && g(e, t, i)) {
                        i.in_loop = e.loop_ids[i.id] !== e.in_loop;
                        i.single_use = r instanceof Le && !r.pinned() && (!i.in_loop || e.parent() instanceof dn) || !i.in_loop && i.scope === this.scope && r.is_constant_expression();
                    } else {
                        i.single_use = false;
                    }
                    if (ue(t, e, this, r, 0, b(r), o)) {
                        if (i.single_use) {
                            i.single_use = "m";
                        } else {
                            i.fixed = false;
                        }
                    }
                    if (i.fixed && e.loop_ids[i.id] !== e.in_loop) {
                        i.cross_loop = true;
                    }
                    y(e, i, this.scope, this, r, 0, 1);
                }
                var a;
                if (i.fixed instanceof Je && !((a = e.parent()) instanceof dn && a.expression === this)) {
                    var s = u(e, i);
                    if (s) s.walk(e);
                }
            });
            e(Ye, function(n, e, t) {
                this.globals.each(function(e) {
                    i(n, t, e);
                });
                l(n);
                f(n, t, this);
                e();
                p(n);
                c(n, this);
                return true;
            });
            e(fn, function(e) {
                l(e);
                Te(this, e);
                p(e);
                if (this.bcatch) {
                    l(e);
                    this.bcatch.walk(e);
                    p(e);
                }
                if (this.bfinally) this.bfinally.walk(e);
                return true;
            });
            e(yn, function(e, n) {
                var t = this;
                if (!me[t.operator]) return;
                var i = t.expression;
                if (!(i instanceof jn)) {
                    w(i);
                    return;
                }
                if (i.fixed) delete i.fixed;
                var r = i.definition();
                var o = m(e, r, true);
                r.assignments++;
                var a = r.fixed;
                if (!a) return;
                r.fixed = function() {
                    var e = a instanceof De ? a : a();
                    return e && pe(En, t, {
                        operator: t.operator.slice(0, -1),
                        left: pe(wn, t, {
                            operator: "+",
                            expression: e
                        }),
                        right: pe(Rn, t, {
                            value: 1
                        })
                    });
                };
                i.fixed = t instanceof wn ? r.fixed : function() {
                    var e = a instanceof De ? a : a();
                    return e && pe(wn, t, {
                        operator: "+",
                        expression: e
                    });
                };
                if (!o) return;
                r.references.push(i);
                h(e, r, true);
                d(e, r, t);
                return true;
            });
            e(hn, function(e, n) {
                var t = this;
                var i = t.name.definition();
                if (t.value) {
                    if (m(e, i, t.value)) {
                        i.fixed = function() {
                            return t.value;
                        };
                        e.loop_ids[i.id] = e.in_loop;
                        h(e, i, false);
                        n();
                        h(e, i, true);
                        v(e, i, t);
                        return true;
                    } else {
                        i.fixed = false;
                    }
                }
            });
            e(Ne, function(e, n) {
                var t = e.in_loop;
                e.in_loop = this;
                l(e);
                n();
                p(e);
                e.in_loop = t;
                return true;
            });
        })(function(e, n) {
            e.DEFMETHOD("reduce_vars", n);
        });
        Ye.DEFMETHOD("reset_opt_flags", function(t) {
            var i = new Kn(t.option("reduce_vars") ? function(e, n) {
                r(e);
                return e.reduce_vars(i, n, t);
            } : r);
            i.assigns = new Ae();
            i.defun_ids = Object.create(null);
            i.defun_visited = Object.create(null);
            i.in_loop = null;
            i.loop_ids = Object.create(null);
            i.safe_ids = Object.create(null);
            this.walk(i);
            function r(e) {
                e._squeezed = false;
                e._optimized = false;
                if (e instanceof Ue) delete e._var_names;
            }
        });
        Sn.DEFMETHOD("fixed_value", function() {
            var e = this.definition().fixed;
            if (!e) return e;
            if (this.fixed) e = this.fixed;
            return e instanceof De ? e : e();
        });
        jn.DEFMETHOD("is_immutable", function() {
            var e = this.definition();
            if (e.orig.length != 1) return false;
            var n = e.orig[0];
            return n instanceof Mn && e.scope.name === n;
        });
        function le(e, n) {
            if (e instanceof Hn) return true;
            if (e instanceof jn) {
                var t = e.definition();
                return t.lambda || n.exposed(t) && J[t.name];
            }
            if (e instanceof mn) {
                e = e.expression;
                if (e instanceof jn) {
                    if (e.is_immutable()) return false;
                    e = e.fixed_value();
                }
                if (!e) return true;
                if (e.is_constant()) return true;
                return le(e, n);
            }
            return false;
        }
        function o(e, n) {
            var t, i = 0;
            while (t = e.parent(i++)) {
                if (t instanceof Ue) break;
                if (t instanceof un) {
                    t = t.argname.definition().scope;
                    break;
                }
            }
            return t.find_variable(n);
        }
        function pe(e, n, t) {
            if (!t) t = {};
            if (n) {
                if (!t.start) t.start = n.start;
                if (!t.end) t.end = n.end;
            }
            return new e(t);
        }
        function U(e, n) {
            if (n.length == 1) return n[0];
            return pe(_n, e, {
                expressions: n.reduce(_, [])
            });
        }
        function E(e, n) {
            switch (typeof e) {
              case "string":
                return pe(Pn, n, {
                    value: e
                });

              case "number":
                if (isNaN(e)) return pe(Yn, n);
                if (isFinite(e)) {
                    return 1 / e < 0 ? pe(wn, n, {
                        operator: "-",
                        expression: pe(Rn, n, {
                            value: -e
                        })
                    }) : pe(Rn, n, {
                        value: e
                    });
                }
                return e < 0 ? pe(wn, n, {
                    operator: "-",
                    expression: pe(Wn, n)
                }) : pe(Wn, n);

              case "boolean":
                return pe(e ? Xn : Gn, n);

              case "undefined":
                return pe(Ln, n);

              default:
                if (e === null) {
                    return pe(Un, n, {
                        value: null
                    });
                }
                if (e instanceof RegExp) {
                    return pe(In, n, {
                        value: e
                    });
                }
                throw new Error(ae("Can't handle constant of type: {type}", {
                    type: typeof e
                }));
            }
        }
        function Y(e, n) {
            return n instanceof mn || W(n) && n.name == "eval";
        }
        function he(e, n, t, i) {
            if (n instanceof wn && n.operator == "delete" || n.TYPE == "Call" && n.expression === t && Y(e, i)) {
                return U(t, [ pe(Rn, t, {
                    value: 0
                }), i ]);
            }
            return i;
        }
        function _(e, n) {
            if (n instanceof _n) {
                e.push.apply(e, n.expressions);
            } else {
                e.push(n);
            }
            return e;
        }
        function D(e) {
            if (e === null) return [];
            if (e instanceof ze) return e.body;
            if (e instanceof $e) return [];
            if (e instanceof Fe) return [ e ];
            throw new Error("Can't convert thing to statement array");
        }
        function L(e) {
            if (e === null) return true;
            if (e instanceof $e) return true;
            if (e instanceof ze) return e.body.length == 0;
            return false;
        }
        function y(e) {
            return Ee(e.body, function(e) {
                return L(e) || e instanceof Je || e instanceof pn && Ee(e.definitions, function(e) {
                    return !e.value;
                });
            });
        }
        function F(e) {
            if (e instanceof qe) {
                return e.body instanceof ze ? e.body : e;
            }
            return e;
        }
        function de(e) {
            while (e instanceof mn) e = e.expression;
            return e;
        }
        function V(e) {
            if (e.TYPE != "Call") return false;
            return e.expression instanceof We || V(e.expression);
        }
        function W(e) {
            return e instanceof jn && e.definition().undeclared;
        }
        function ve(e) {
            return e[e instanceof kn ? "right" : "value"];
        }
        var n = se("Array Boolean clearInterval clearTimeout console Date decodeURI decodeURIComponent encodeURI encodeURIComponent Error escape eval EvalError Function isFinite isNaN JSON Math Number parseFloat parseInt RangeError ReferenceError RegExp Object setInterval setTimeout String SyntaxError TypeError unescape URIError");
        jn.DEFMETHOD("is_declared", function(e) {
            return this.defined || !this.definition().undeclared || e.option("unsafe") && n[this.name];
        });
        var J = se("Infinity NaN undefined");
        function r(e) {
            return e instanceof Wn || e instanceof Yn || e instanceof Ln;
        }
        function c(e, f) {
            var oe, ae, se;
            t();
            var fe, n = 10;
            do {
                fe = false;
                r(e);
                if (f.option("dead_code")) {
                    a(e, f);
                }
                if (f.option("if_return")) {
                    o(e, f);
                }
                if (f.sequences_limit > 0) {
                    s(e, f);
                    u(e, f);
                }
                if (f.option("join_vars")) {
                    v(e);
                }
                if (f.option("collapse_vars")) {
                    i(e, f);
                }
            } while (fe && n-- > 0);
            return e;
            function t() {
                var e = f.self(), n = 0;
                do {
                    if (e instanceof un || e instanceof cn) {
                        n++;
                    } else if (e instanceof qe) {
                        oe = true;
                    } else if (e instanceof Ue) {
                        se = e;
                        break;
                    } else if (e instanceof fn) {
                        ae = e;
                    }
                } while (e = f.parent(n++));
            }
            function i(o, c) {
                if (se.pinned()) return o;
                var f;
                var a = Object.create(null);
                var u = [];
                var s = Object.create(null);
                var t;
                var l = o.length;
                var p = new at(function(e, n) {
                    if (S) return e;
                    if (!B) {
                        if (e !== h[d]) return e;
                        d++;
                        if (d < h.length) return q(e, p);
                        B = true;
                        m = (_ ? U : I)(e, 0);
                        if (m === e) S = true;
                        return e;
                    }
                    var t = p.parent();
                    if (j(e, t)) {
                        S = true;
                        return e;
                    }
                    if (!g && H(e, t)) {
                        g = t;
                    }
                    if (e.single_use && t instanceof hn && t.value === e) return e;
                    var i;
                    if (!(e instanceof Tn) && (w && b.equivalent_to(e) || x && (i = x(e, this)))) {
                        if (!z || g && (i || !k || !D)) {
                            if (!i || !_) S = true;
                            return e;
                        }
                        if (ge(e, t)) {
                            if (_ && !i) {
                                O = true;
                                T++;
                            }
                            return e;
                        } else if (_) {
                            if (!i) T++;
                            return e;
                        } else {
                            T++;
                        }
                        fe = S = true;
                        De.info("Collapsing {name} [{file}:{line},{col}]", {
                            name: e.print_to_string(),
                            file: e.start.file,
                            line: e.start.line,
                            col: e.start.col
                        });
                        if (v instanceof xn) {
                            delete v.expression.fixed;
                            return pe(wn, v, v);
                        }
                        if (v instanceof hn) {
                            var r = v.name.definition();
                            if (r.references.length - r.replaced == 1 && !c.exposed(r)) {
                                r.replaced++;
                                return he(c, t, e, v.value);
                            }
                            return pe(kn, v, {
                                operator: "=",
                                left: pe(jn, v.name, v.name),
                                right: v.value
                            });
                        }
                        v.write_only = false;
                        return v;
                    }
                    if (N(e, t) || F(e)) {
                        m = e;
                        if (e instanceof Ue) S = true;
                    }
                    if (e instanceof Ve) {
                        var o = z;
                        z = false;
                        n(e, p);
                        z = o;
                        return e;
                    }
                    return q(e, p);
                }, function(e) {
                    if (S) return;
                    if (m === e) S = true;
                    if (g === e) g = null;
                });
                var i = new at(function(e) {
                    if (S) return e;
                    if (!B) {
                        if (e !== h[d]) return e;
                        d++;
                        switch (h.length - d) {
                          case 0:
                            B = true;
                            if (O) return e;
                            if (e instanceof hn) return e;
                            $.replaced++;
                            var n = i.parent();
                            if (n instanceof _n && n.tail_node() !== e) {
                                _.replaced++;
                                return we.skip;
                            }
                            return r;

                          case 1:
                            if (!O && e.body === v) {
                                B = true;
                                $.replaced++;
                                _.replaced++;
                                return null;
                            }

                          default:
                            return;
                        }
                    }
                    if (e instanceof jn && e.name == $.name) {
                        if (!--T) S = true;
                        if (ge(e, i.parent())) return e;
                        $.replaced++;
                        _.replaced--;
                        return r.clone();
                    }
                    if (e instanceof an || e instanceof Ue) return e;
                }, Q);
                while (--l >= 0) {
                    if (l == 0 && c.option("unused")) P();
                    var h = [];
                    R(o[l]);
                    while (u.length > 0) {
                        h = u.pop();
                        var d = 0;
                        var v = h[h.length - 1];
                        var _ = null;
                        var m = null;
                        var g = null;
                        var b = V(v);
                        var y = b && b.has_side_effects(c);
                        var w = b && !y && !le(b, c);
                        var x = J(v);
                        if (!w && !x) continue;
                        var E = false;
                        var A = X(v);
                        var k = Z(b);
                        var r = ve(v);
                        if (!y) y = ee();
                        var D = ne(v);
                        var F = v.may_throw(c) ? ae ? function(e) {
                            return e.has_side_effects(c);
                        } : re : ye;
                        var C = v.name instanceof zn;
                        var B = C;
                        var S = false;
                        var T = 0;
                        var O = false;
                        var z = !f || !B;
                        if (!z) {
                            for (var e = c.self().argnames.lastIndexOf(v.name) + 1; !S && e < f.length; e++) {
                                f[e].transform(p);
                            }
                            z = true;
                        }
                        for (var n = l; !S && n < o.length; n++) {
                            o[n].transform(p);
                        }
                        if (_) {
                            var $ = b.definition();
                            var M = $.references.length - $.replaced;
                            if (v instanceof kn) M--;
                            if (T && M == T) {
                                S = false;
                            } else {
                                u.push(h);
                                t = true;
                                continue;
                            }
                            if (T) {
                                d = 0;
                                B = C;
                                for (var n = l; !S && n < o.length; n++) {
                                    if (!o[n].transform(i)) o.splice(n--, 1);
                                }
                                if (v instanceof hn) {
                                    T = !c.exposed($) && $.references.length == $.replaced;
                                }
                                _.single_use = false;
                            }
                        }
                        if (T && !K(v)) o.splice(l, 1);
                    }
                }
                function q(e, n) {
                    if (e instanceof Ue) return e;
                    if (e instanceof rn) {
                        e.expression = e.expression.transform(n);
                        for (var t = 0; !S && t < e.body.length; t++) {
                            var i = e.body[t];
                            if (i instanceof sn) {
                                if (!B) {
                                    if (i !== h[d]) continue;
                                    d++;
                                }
                                i.expression = i.expression.transform(n);
                                if (!D) break;
                                x = false;
                            }
                        }
                        S = true;
                        return e;
                    }
                }
                function j(e, n) {
                    if (e === r) return true;
                    if (n instanceof Pe) return e !== n.init;
                    if (e instanceof kn) {
                        return e.operator != "=" && b.equivalent_to(e.left);
                    }
                    if (e instanceof dn) {
                        if (!(b instanceof mn)) return false;
                        if (!b.equivalent_to(e.expression)) return false;
                        return !(r instanceof We && !r.contains_this());
                    }
                    if (e instanceof Ce) return true;
                    if (e instanceof Je) return C && b.name === e.name.name;
                    if (e instanceof qe) return !(e instanceof Pe);
                    if (e instanceof Ze) return true;
                    if (e instanceof fn) return true;
                    if (e instanceof Ie) return true;
                    if (D) return false;
                    return e instanceof jn && !e.is_declared(c) && !(n instanceof kn && n.operator == "=" && n.left === e);
                }
                function H(e, n) {
                    if (n instanceof En) return _e[n.operator] && n.left !== e;
                    if (n instanceof sn) return n.expression !== e;
                    if (n instanceof An) return n.condition !== e;
                    return n instanceof tn && n.condition !== e;
                }
                function N(e, n) {
                    if (e instanceof dn) {
                        var t = e.expression;
                        if (t instanceof jn) {
                            if (t.definition().recursive_refs > 0) return true;
                            t = t.fixed_value();
                        }
                        if (!(t instanceof Le)) return true;
                        if (t.collapse_scanning) return false;
                        t.collapse_scanning = true;
                        var i = z;
                        z = false;
                        var r = m;
                        var o = g;
                        var a = x;
                        for (var s = 0; !S && s < t.body.length; s++) {
                            var f = t.body[s];
                            if (f instanceof Ke) {
                                if (f.value) f.value.transform(p);
                                break;
                            }
                            f.transform(p);
                        }
                        x = a;
                        g = o;
                        m = r;
                        z = i;
                        delete t.collapse_scanning;
                        if (!S) return false;
                        S = false;
                        return true;
                    }
                    if (e instanceof Xe) {
                        if (ae) {
                            if (ae.bfinally) return true;
                            if (ae.bcatch && e instanceof Qe) return true;
                        }
                        return y || b instanceof mn || ie(b);
                    }
                    if (e instanceof We) {
                        return c.option("ie8") && e.name && A.has(e.name.name);
                    }
                    if (e instanceof mn) {
                        return y || !_ && e.expression.may_throw_on_access(c);
                    }
                    if (e instanceof jn) {
                        if (te(e, n)) {
                            return !n || n.operator != "=" || n.left !== e;
                        }
                        return y && ie(e);
                    }
                    if (e instanceof Hn) return te(e, n);
                    if (e instanceof hn) {
                        if (!e.value) return false;
                        return A.has(e.name.name) || y && ie(e.name);
                    }
                    var u = ge(e.left, e);
                    if (u && A.has(u.name)) return true;
                    if (u instanceof mn) return true;
                }
                function P() {
                    var e, t = c.self();
                    if (t instanceof We && !t.name && !t.uses_arguments && !t.pinned() && (e = c.parent()) instanceof dn && e.expression === t) {
                        var i = c.has_directive("use strict");
                        if (i && !be(i, t.body)) i = false;
                        var n = t.argnames.length;
                        f = e.args.slice(n);
                        var r = Object.create(null);
                        for (var o = n; --o >= 0; ) {
                            var a = t.argnames[o];
                            var s = e.args[o];
                            f.unshift(pe(hn, a, {
                                name: a,
                                value: s
                            }));
                            if (a.name in r) continue;
                            r[a.name] = true;
                            if (!s) {
                                s = pe(Ln, a).transform(c);
                            } else if (s instanceof Le && s.pinned()) {
                                s = null;
                            } else {
                                s.walk(new Kn(function(e) {
                                    if (!s) return true;
                                    if (e instanceof jn && t.variables.has(e.name)) {
                                        var n = e.definition().scope;
                                        if (n !== se) while (n = n.parent_scope) {
                                            if (n === se) return true;
                                        }
                                        s = null;
                                    }
                                    if (e instanceof Hn && (i || !this.find_parent(Ue))) {
                                        s = null;
                                        return true;
                                    }
                                }));
                            }
                            if (s) u.unshift([ pe(hn, a, {
                                name: a,
                                value: s
                            }) ]);
                        }
                    }
                }
                function R(e) {
                    h.push(e);
                    if (e instanceof Dn) {
                        e.elements.forEach(R);
                    } else if (e instanceof kn) {
                        u.push(h.slice());
                        R(e.left);
                        R(e.right);
                        if (e.left instanceof jn) {
                            a[e.left.name] = (a[e.left.name] || 0) + 1;
                        }
                    } else if (e instanceof En) {
                        R(e.left);
                        R(e.right);
                    } else if (e instanceof dn) {
                        R(e.expression);
                        e.args.forEach(R);
                    } else if (e instanceof sn) {
                        R(e.expression);
                    } else if (e instanceof An) {
                        R(e.condition);
                        R(e.consequent);
                        R(e.alternative);
                    } else if (e instanceof ln) {
                        e.definitions.forEach(R);
                    } else if (e instanceof gn) {
                        R(e.expression);
                    } else if (e instanceof je) {
                        R(e.condition);
                        if (!(e.body instanceof Oe)) {
                            R(e.body);
                        }
                    } else if (e instanceof Xe) {
                        if (e.value) R(e.value);
                    } else if (e instanceof Pe) {
                        if (e.init) R(e.init);
                        if (e.condition) R(e.condition);
                        if (e.step) R(e.step);
                        if (!(e.body instanceof Oe)) {
                            R(e.body);
                        }
                    } else if (e instanceof Re) {
                        R(e.object);
                        if (!(e.body instanceof Oe)) {
                            R(e.body);
                        }
                    } else if (e instanceof tn) {
                        R(e.condition);
                        if (!(e.body instanceof Oe)) {
                            R(e.body);
                        }
                        if (e.alternative && !(e.alternative instanceof Oe)) {
                            R(e.alternative);
                        }
                    } else if (e instanceof Fn) {
                        e.properties.forEach(function(e) {
                            if (e instanceof Bn) {
                                h.push(e);
                                R(e.value);
                                h.pop();
                            }
                        });
                    } else if (e instanceof _n) {
                        e.expressions.forEach(R);
                    } else if (e instanceof Se) {
                        R(e.body);
                    } else if (e instanceof bn) {
                        R(e.expression);
                        R(e.property);
                    } else if (e instanceof rn) {
                        R(e.expression);
                        e.body.forEach(R);
                    } else if (e instanceof yn) {
                        if (me[e.operator]) {
                            u.push(h.slice());
                        } else {
                            R(e.expression);
                        }
                    } else if (e instanceof hn) {
                        if (e.value) {
                            var n = e.name.definition();
                            if (n.references.length > n.replaced) {
                                u.push(h.slice());
                            }
                            R(e.value);
                        } else {
                            s[e.name.name] = (s[e.name.name] || 0) + 1;
                        }
                    }
                    h.pop();
                }
                function I(e, n) {
                    var t = p.parent(n);
                    if (t instanceof Dn) return e;
                    if (t instanceof kn) return e;
                    if (t instanceof En) return e;
                    if (t instanceof dn) return e;
                    if (t instanceof sn) return e;
                    if (t instanceof An) return e;
                    if (t instanceof ln) return Y(t, n + 1);
                    if (t instanceof Xe) return e;
                    if (t instanceof tn) return e;
                    if (t instanceof qe) return e;
                    if (t instanceof Bn) return e;
                    if (t instanceof mn) return e;
                    if (t instanceof _n) {
                        return (t.tail_node() === e ? I : Y)(t, n + 1);
                    }
                    if (t instanceof Se) return Y(t, n + 1);
                    if (t instanceof rn) return e;
                    if (t instanceof yn) return e;
                    if (t instanceof hn) return e;
                    return null;
                }
                function U(e, n) {
                    var t = p.parent(n);
                    if (t instanceof Dn) return U(t, n + 1);
                    if (t instanceof kn) {
                        if (F(t)) return e;
                        if (t.left instanceof jn) {
                            var i = t.left.name;
                            if (b.name == i) return e;
                            if (_.name == i) return e;
                        }
                        return U(t, n + 1);
                    }
                    if (t instanceof En) {
                        if (_e[t.operator] && t.left !== e) {
                            do {
                                e = t;
                                t = p.parent(++n);
                            } while (t instanceof En && t.operator == e.operator);
                            return e;
                        }
                        return U(t, n + 1);
                    }
                    if (t instanceof dn) return t;
                    if (t instanceof sn) {
                        if (t.expression !== e) return e;
                        return U(t, n + 1);
                    }
                    if (t instanceof An) {
                        if (t.condition !== e) return e;
                        return U(t, n + 1);
                    }
                    if (t instanceof ln) return Y(t, n + 1);
                    if (t instanceof He) return e;
                    if (t instanceof Xe) return Y(t, n + 1);
                    if (t instanceof Pe) {
                        if (t.init !== e && t.condition !== e) return e;
                        return U(t, n + 1);
                    }
                    if (t instanceof Re) {
                        if (t.init !== e) return e;
                        return U(t, n + 1);
                    }
                    if (t instanceof tn) {
                        if (t.condition !== e) return e;
                        return U(t, n + 1);
                    }
                    if (t instanceof Bn) {
                        var r = p.parent(n + 1);
                        return Ee(r.properties, function(e) {
                            return e instanceof Bn;
                        }) ? U(r, n + 2) : r;
                    }
                    if (t instanceof mn) return U(t, n + 1);
                    if (t instanceof _n) {
                        return (t.tail_node() === e ? U : Y)(t, n + 1);
                    }
                    if (t instanceof Se) return Y(t, n + 1);
                    if (t instanceof rn) {
                        if (t.expression !== e) return e;
                        return U(t, n + 1);
                    }
                    if (t instanceof yn) {
                        if (t.operator == "delete") return e;
                        return U(t, n + 1);
                    }
                    if (t instanceof hn) {
                        var i = t.name.name;
                        if (b.name == i) return e;
                        if (_.name == i) return e;
                        return U(t, n + 1);
                    }
                    if (t instanceof Ne) {
                        if (t.condition !== e) return e;
                        return U(t, n + 1);
                    }
                    return null;
                }
                function Y(e, n) {
                    var t = p.parent(n);
                    if (N(e, t)) return e;
                    if (H(e, t)) return e;
                    if (t instanceof Dn) return Y(t, n + 1);
                    if (t instanceof kn) {
                        return F(t) ? e : Y(t, n + 1);
                    }
                    if (t instanceof En) return Y(t, n + 1);
                    if (t instanceof dn) return Y(t, n + 1);
                    if (t instanceof sn) return Y(t, n + 1);
                    if (t instanceof An) return Y(t, n + 1);
                    if (t instanceof ln) return Y(t, n + 1);
                    if (t instanceof Xe) return Y(t, n + 1);
                    if (t instanceof tn) return Y(t, n + 1);
                    if (t instanceof qe) return e;
                    if (t instanceof Bn) {
                        var i = p.parent(n + 1);
                        return Ee(i.properties, function(e) {
                            return e instanceof Bn;
                        }) ? Y(i, n + 2) : i;
                    }
                    if (t instanceof mn) {
                        var r = t.expression;
                        if (r === e) return Y(t, n + 1);
                        var o = de(r);
                        if (!(o instanceof jn)) return Y(t, n + 1);
                        var a = A.get(o.name);
                        return !a || Ee(a, function(e) {
                            return !(e instanceof mn);
                        }) ? Y(t, n + 1) : e;
                    }
                    if (t instanceof _n) return Y(t, n + 1);
                    if (t instanceof Se) return Y(t, n + 1);
                    if (t instanceof rn) return Y(t, n + 1);
                    if (t instanceof yn) return Y(t, n + 1);
                    if (t instanceof hn) return Y(t, n + 1);
                    return null;
                }
                function L(e) {
                    if (t) {
                        t = false;
                        return;
                    }
                    if (!(e instanceof jn)) return;
                    var n = e.definition();
                    if (n.undeclared) return;
                    if (ce(n)) return;
                    return _ = n;
                }
                function V(e) {
                    if (e instanceof hn) {
                        var n = e.name.definition();
                        if (!be(e.name, n.orig)) return;
                        var t = n.orig.length - n.eliminated - (s[n.name] || 0);
                        var i = n.references.length - n.replaced - (a[n.name] || 0);
                        if (t > 1 && !(e.name instanceof zn)) {
                            L(e.value);
                            return pe(jn, e.name, e.name);
                        }
                        if (L(e.value) || i == 1 && !c.exposed(n)) {
                            return pe(jn, e.name, e.name);
                        }
                    } else if (e instanceof kn) {
                        var r = e.left;
                        if (e.operator == "=" && r instanceof jn) {
                            var n = r.definition();
                            if (n.references[0] === r) {
                                var i = n.references.length - n.replaced;
                                if (i > 1) L(e.right);
                            }
                        }
                        return r;
                    } else {
                        return e.expression;
                    }
                }
                function W(e) {
                    if (e instanceof Dn) return false;
                    if (e instanceof En && _e[e.operator]) {
                        return W(e.left) && W(e.right);
                    }
                    if (e instanceof dn) return false;
                    if (e instanceof An) {
                        return W(e.consequent) && W(e.alternative);
                    }
                    if (e instanceof Fn) return false;
                    return !e.has_side_effects(c);
                }
                function J(n) {
                    var t = Object.create(null);
                    var e = new Kn(function(e) {
                        if (e instanceof jn) t[e.definition().id] = true;
                    });
                    while (n instanceof kn && n.operator == "=") {
                        n.left.walk(e);
                        n = n.right;
                    }
                    if (n instanceof jn) {
                        var i = n.evaluate(c);
                        if (i === n) return o;
                        return G(i, o);
                    }
                    if (n instanceof Hn) return o;
                    if (n.is_truthy()) return G(true, ye);
                    if (n.is_constant()) {
                        return G(n.evaluate(c), o);
                    }
                    if (!(b instanceof jn)) return false;
                    if (!W(n)) return false;
                    var r;
                    n.walk(new Kn(function(e) {
                        if (r) return true;
                        if (e instanceof jn && t[e.definition().id]) r = true;
                    }));
                    return !r && o;
                    function o(e) {
                        return n.equivalent_to(e);
                    }
                }
                function G(t, i) {
                    return function(e, n) {
                        if (n.in_boolean_context()) {
                            if (t && e.is_truthy() && !e.has_side_effects(c)) {
                                return true;
                            }
                            if (e.is_constant()) {
                                return !e.evaluate(c) == !t;
                            }
                        }
                        return i(e);
                    };
                }
                function X(e) {
                    var i = new Ae();
                    if (v instanceof hn) i.add(v.name.name, b);
                    var r = se instanceof Ye;
                    var o = new Kn(function(e) {
                        if (r && e.TYPE == "Call") {
                            var n = e.expression;
                            if (n instanceof mn) return;
                            if (n instanceof We && !n.contains_this()) return;
                            E = true;
                            r = false;
                            return;
                        }
                        var t;
                        if (e instanceof jn) {
                            t = e.fixed_value() || e;
                        } else if (e instanceof Hn) {
                            t = e;
                        }
                        if (t) i.add(e.name, ue(c, o, e, t, 0));
                    });
                    e.walk(o);
                    return i;
                }
                function K(e) {
                    if (e.name instanceof zn) {
                        var n = c.self().argnames.indexOf(e.name);
                        var t = c.parent().args;
                        if (t[n]) t[n] = pe(Rn, t[n], {
                            value: 0
                        });
                        return true;
                    }
                    var i = h.length - 1;
                    if (h[i - 1].body === h[i]) i--;
                    var r = new at(function(e, n, t) {
                        if (B) return e;
                        if (e !== h[d]) return e;
                        d++;
                        if (d <= i) return q(e, r);
                        B = true;
                        if (e instanceof hn) {
                            e.value = null;
                            s[e.name.name] = (s[e.name.name] || 0) + 1;
                            if (_) _.replaced++;
                            return e;
                        }
                        return t ? we.skip : null;
                    }, Q);
                    S = false;
                    B = false;
                    d = 0;
                    return o[l].transform(r);
                }
                function Q(e) {
                    if (e instanceof _n) switch (e.expressions.length) {
                      case 0:
                        return null;

                      case 1:
                        return e.expressions[0];
                    }
                }
                function Z(e) {
                    var n = de(e);
                    return n instanceof jn && n.definition().scope === se && !(oe && (A.has(n.name) && A.get(n.name)[0] !== e || v instanceof yn || v instanceof kn && v.operator != "="));
                }
                function ee() {
                    if (v instanceof yn) return false;
                    return r.has_side_effects(c);
                }
                function ne(e) {
                    if (e instanceof yn) return false;
                    if (y) return false;
                    if (_) return true;
                    if (!(b instanceof jn)) return false;
                    var n;
                    if (e instanceof hn) {
                        n = 1;
                    } else if (e.operator == "=") {
                        n = 2;
                    } else {
                        return false;
                    }
                    var t = b.definition();
                    return t.references.length - t.replaced == n;
                }
                function te(e, n) {
                    var t = A.get(e.name);
                    if (!t || Ee(t, function(e) {
                        return !e;
                    })) return;
                    if (t[0] !== b) return true;
                    x = false;
                }
                function ie(e) {
                    var n = e.definition();
                    if (n.orig.length == 1 && n.orig[0] instanceof $n) return false;
                    if (n.scope !== se) return true;
                    if (E && c.exposed(n)) return true;
                    return !Ee(n.references, function(e) {
                        return e.scope.resolve() === se;
                    });
                }
                function re(e, n) {
                    if (e instanceof kn) return re(e.left, true);
                    if (e instanceof yn) return re(e.expression, true);
                    if (e instanceof hn) return e.value && re(e.value);
                    if (n) {
                        if (e instanceof gn) return re(e.expression, true);
                        if (e instanceof bn) return re(e.expression, true);
                        if (e instanceof jn) return e.definition().scope !== se;
                    }
                    return false;
                }
            }
            function r(e) {
                var n = [];
                for (var t = 0; t < e.length; ) {
                    var i = e[t];
                    if (i instanceof ze) {
                        fe = true;
                        r(i.body);
                        [].splice.apply(e, [ t, 1 ].concat(i.body));
                        t += i.body.length;
                    } else if (i instanceof $e) {
                        fe = true;
                        e.splice(t, 1);
                    } else if (i instanceof Be) {
                        if (!be(i.value, n)) {
                            t++;
                            n.push(i.value);
                        } else {
                            fe = true;
                            e.splice(t, 1);
                        }
                    } else t++;
                }
            }
            function o(i, t) {
                var r = t.self();
                var e = t.parent();
                var o = r instanceof Le;
                var n = o && e && e.TYPE == "Call";
                var a = g(i);
                for (var s = i.length; --s >= 0; ) {
                    var f = i[s];
                    var u = E(s);
                    var c = i[u];
                    if (o && !c && f instanceof Ke) {
                        if (!f.value) {
                            fe = true;
                            i.splice(s, 1);
                            continue;
                        }
                        if (f.value instanceof wn && f.value.operator == "void") {
                            fe = true;
                            i[s] = pe(Se, f, {
                                body: f.value.expression
                            });
                            continue;
                        }
                    }
                    if (f instanceof tn) {
                        var l = C(f.body);
                        if (y(l)) {
                            if (l.label) xe(l.label.thedef.references, l);
                            fe = true;
                            f = f.clone();
                            f.condition = f.condition.negate(t);
                            var p = x(f.body, l);
                            f.body = pe(ze, f, {
                                body: D(f.alternative).concat(w())
                            });
                            f.alternative = pe(ze, f, {
                                body: p
                            });
                            i[s] = f;
                            i[s] = f.transform(t);
                            continue;
                        }
                        if (l && !f.alternative && f.body instanceof ze && c instanceof Ge) {
                            var h = f.condition.negate(t);
                            if (h.print_to_string().length <= f.condition.print_to_string().length) {
                                fe = true;
                                f = f.clone();
                                f.condition = h;
                                i[u] = f.body;
                                f.body = c;
                                i[s] = f;
                                i[s] = f.transform(t);
                                continue;
                            }
                        }
                        var d = C(f.alternative);
                        if (y(d)) {
                            if (d.label) xe(d.label.thedef.references, d);
                            fe = true;
                            f = f.clone();
                            f.body = pe(ze, f.body, {
                                body: D(f.body).concat(w())
                            });
                            var p = x(f.alternative, d);
                            f.alternative = pe(ze, f.alternative, {
                                body: p
                            });
                            i[s] = f;
                            i[s] = f.transform(t);
                            continue;
                        }
                        if (t.option("typeofs")) {
                            if (l && !d) {
                                T(f.condition, null, pe(ze, r, {
                                    body: i.slice(s + 1)
                                }));
                            }
                            if (!l && d) {
                                T(f.condition, pe(ze, r, {
                                    body: i.slice(s + 1)
                                }));
                            }
                        }
                    }
                    if (f instanceof tn && f.body instanceof Ke) {
                        var v = f.body.value;
                        var _ = f.body.in_bool || c instanceof Ke && c.in_bool;
                        if (!v && !f.alternative && (o && !c || c instanceof Ke && !c.value)) {
                            fe = true;
                            i[s] = pe(Se, f.condition, {
                                body: f.condition
                            });
                            continue;
                        }
                        if ((_ || v) && !f.alternative && c instanceof Ke) {
                            fe = true;
                            f = f.clone();
                            f.alternative = c;
                            i.splice(s, 1, f.transform(t));
                            i.splice(u, 1);
                            continue;
                        }
                        if (!f.alternative && !c && o && (_ || v && a)) {
                            fe = true;
                            f = f.clone();
                            f.alternative = pe(Ke, f, {
                                value: null
                            });
                            i.splice(s, 1, f.transform(t));
                            continue;
                        }
                        var m = i[A(s)];
                        if (t.option("sequences") && o && !f.alternative && (!m && n || m instanceof tn && m.body instanceof Ke) && E(u) == i.length && c instanceof Se) {
                            fe = true;
                            f = f.clone();
                            f.alternative = pe(ze, c, {
                                body: [ c, pe(Ke, c, {
                                    value: null
                                }) ]
                            });
                            i.splice(s, 1, f.transform(t));
                            i.splice(u, 1);
                            continue;
                        }
                    }
                }
                function g(e) {
                    var n = 0;
                    for (var t = e.length; --t >= 0; ) {
                        var i = e[t];
                        if (i instanceof tn && i.body instanceof Ke) {
                            if (++n > 1) return true;
                        }
                    }
                    return false;
                }
                function b(e) {
                    return !e || e instanceof wn && e.operator == "void";
                }
                function y(e) {
                    if (!e) return false;
                    var n = e instanceof Ze ? t.loopcontrol_target(e) : null;
                    return e instanceof Ke && o && b(e.value) || e instanceof nn && r === F(n) || e instanceof en && n instanceof ze && r === n;
                }
                function w() {
                    var e = i.slice(s + 1);
                    i.length = s + 1;
                    return e.filter(function(e) {
                        if (e instanceof Je) {
                            i.push(e);
                            return false;
                        }
                        return true;
                    });
                }
                function x(e, n) {
                    var t = D(e).slice(0, -1);
                    if (n.value) {
                        t.push(pe(Se, n.value, {
                            body: n.value.expression
                        }));
                    }
                    return t;
                }
                function E(e) {
                    for (var n = e + 1; n < i.length; n++) {
                        var t = i[n];
                        if (!(t instanceof pn && k(t))) {
                            break;
                        }
                    }
                    return n;
                }
                function A(e) {
                    for (var n = e; --n >= 0; ) {
                        var t = i[n];
                        if (!(t instanceof pn && k(t))) {
                            break;
                        }
                    }
                    return n;
                }
            }
            function a(n, e) {
                var t;
                var i = e.self();
                for (var r = 0, o = 0, a = n.length; r < a; r++) {
                    var s = n[r];
                    if (s instanceof Ze) {
                        var f = e.loopcontrol_target(s);
                        if (s instanceof en && !(f instanceof qe) && F(f) === i || s instanceof nn && F(f) === i) {
                            if (s.label) xe(s.label.thedef.references, s);
                        } else {
                            n[o++] = s;
                        }
                    } else {
                        n[o++] = s;
                    }
                    if (C(s)) {
                        t = n.slice(r + 1);
                        break;
                    }
                }
                n.length = o;
                fe = o != a;
                if (t) t.forEach(function(e) {
                    w(e, n);
                });
            }
            function k(e) {
                return Ee(e.definitions, function(e) {
                    return !e.value;
                });
            }
            function s(n, e) {
                if (n.length < 2) return;
                var t = [], i = 0;
                function r() {
                    if (!t.length) return;
                    var e = U(t[0], t);
                    n[i++] = pe(Se, e, {
                        body: e
                    });
                    t = [];
                }
                for (var o = 0, a = n.length; o < a; o++) {
                    var s = n[o];
                    if (s instanceof Se) {
                        if (t.length >= e.sequences_limit) r();
                        var f = s.body;
                        if (t.length > 0) f = f.drop_side_effect_free(e);
                        if (f) _(t, f);
                    } else if (s instanceof ln && k(s) || s instanceof Je) {
                        n[i++] = s;
                    } else {
                        r();
                        n[i++] = s;
                    }
                }
                r();
                n.length = i;
                if (i != a) fe = true;
            }
            function p(e, n) {
                if (!(e instanceof ze)) return e;
                var t = null;
                for (var i = 0; i < e.body.length; i++) {
                    var r = e.body[i];
                    if (r instanceof pn && k(r)) {
                        n.push(r);
                    } else if (t) {
                        return false;
                    } else {
                        t = r;
                    }
                }
                return t;
            }
            function u(e, n) {
                function t(e) {
                    i--;
                    fe = true;
                    var n = r.body;
                    return U(n, [ n, e ]);
                }
                var i = 0, r;
                for (var o = 0; o < e.length; o++) {
                    var a = e[o];
                    if (r) {
                        if (a instanceof Xe) {
                            a.value = t(a.value || pe(Ln, a)).transform(n);
                        } else if (a instanceof Pe) {
                            if (!(a.init instanceof ln)) {
                                var s = false;
                                r.body.walk(new Kn(function(e) {
                                    if (s || e instanceof Ue) return true;
                                    if (e instanceof En && e.operator == "in") {
                                        s = true;
                                        return true;
                                    }
                                }));
                                if (!s) {
                                    if (a.init) a.init = t(a.init); else {
                                        a.init = r.body;
                                        i--;
                                        fe = true;
                                    }
                                }
                            }
                        } else if (a instanceof Re) {
                            a.object = t(a.object);
                        } else if (a instanceof tn) {
                            a.condition = t(a.condition);
                        } else if (a instanceof rn) {
                            a.expression = t(a.expression);
                        } else if (a instanceof Ie) {
                            a.expression = t(a.expression);
                        }
                    }
                    if (n.option("conditionals") && a instanceof tn) {
                        var f = [];
                        var u = p(a.body, f);
                        var c = p(a.alternative, f);
                        if (u !== false && c !== false && f.length > 0) {
                            var l = f.length;
                            f.push(pe(tn, a, {
                                condition: a.condition,
                                body: u || pe($e, a.body),
                                alternative: c
                            }));
                            f.unshift(i, 1);
                            [].splice.apply(e, f);
                            o += l;
                            i += l + 1;
                            r = null;
                            fe = true;
                            continue;
                        }
                    }
                    e[i++] = a;
                    r = a instanceof Se ? a : null;
                }
                e.length = i;
            }
            function c(e, n, t) {
                var i;
                if (n instanceof kn) {
                    i = [ n ];
                } else if (n instanceof _n) {
                    i = n.expressions.slice();
                }
                if (!i) return;
                var r = false;
                for (var o = i.length - 1; --o >= 0; ) {
                    var a = i[o];
                    if (!(a instanceof kn)) continue;
                    if (a.operator != "=") continue;
                    if (!(a.left instanceof jn)) continue;
                    var s = i.slice(o + 1);
                    if (!d(a.left, a.right, s)) continue;
                    r = true;
                    i = i.slice(0, o + 1).concat(s);
                }
                if (e instanceof ln) {
                    t = t || 0;
                    for (var o = e.definitions.length; --o >= 0; ) {
                        var f = e.definitions[o];
                        if (!f.value) continue;
                        if (d(f.name, f.value, i)) r = true;
                        if (l(f, i, t)) r = true;
                        break;
                    }
                    if (h(e.definitions, i, t)) r = true;
                }
                return r && i;
            }
            function l(e, n, t) {
                if (!f.option("conditionals")) return;
                var i = false;
                var r = e.name.definition();
                while (n.length > t) {
                    var o = b(f, r, e.value, n[0]);
                    if (!o) break;
                    e.value = o;
                    n.shift();
                    i = true;
                }
                return i;
            }
            function h(e, n, t) {
                var i = false;
                while (n.length > t) {
                    var r = n[0];
                    if (!(r instanceof kn)) break;
                    if (r.operator != "=") break;
                    var o = r.left;
                    if (!(o instanceof jn)) break;
                    if (W(o)) break;
                    if (o.scope !== se) break;
                    var a = o.definition();
                    if (a.scope !== se) break;
                    if (a.orig.length > a.eliminated + 1) break;
                    if (a.orig[0].TYPE != "SymbolVar") break;
                    var s = pe(On, o, o);
                    e.push(pe(hn, r, {
                        name: s,
                        value: r.right
                    }));
                    a.orig.push(s);
                    a.replaced++;
                    n.shift();
                    i = true;
                }
                return i;
            }
            function d(e, n, t) {
                if (!(n instanceof Fn)) return;
                var i = false;
                do {
                    var r = t[0];
                    if (!(r instanceof kn)) break;
                    if (r.operator != "=") break;
                    if (!(r.left instanceof mn)) break;
                    var o = r.left.expression;
                    if (!(o instanceof jn)) break;
                    if (e.name != o.name) break;
                    if (!r.right.is_constant_expression(se)) break;
                    var a = r.left.property;
                    if (a instanceof De) {
                        a = a.evaluate(f);
                    }
                    if (a instanceof De) break;
                    a = "" + a;
                    var s = a == "__proto__" || f.has_directive("use strict") ? function(e) {
                        return e.key != a && e.key.name != a;
                    } : function(e) {
                        return e.key.name != a;
                    };
                    if (!Ee(n.properties, s)) break;
                    n.properties.push(pe(Bn, r, {
                        key: a,
                        value: r.right
                    }));
                    t.shift();
                    i = true;
                } while (t.length);
                return i;
            }
            function v(e) {
                var r;
                for (var n = 0, t = -1; n < e.length; n++) {
                    var i = e[n];
                    var o = e[t];
                    if (i instanceof ln) {
                        if (o && o.TYPE == i.TYPE) {
                            o.definitions = o.definitions.concat(i.definitions);
                            fe = true;
                        } else if (r && r.TYPE == i.TYPE && k(i)) {
                            r.definitions = r.definitions.concat(i.definitions);
                            fe = true;
                        } else {
                            e[++t] = i;
                            r = i;
                        }
                        continue;
                    } else if (i instanceof Xe) {
                        i.value = s(i.value);
                    } else if (i instanceof Pe) {
                        var a = c(o, i.init);
                        if (a) {
                            fe = true;
                            i.init = a.length ? U(i.init, a) : null;
                        } else if (o instanceof pn && (!i.init || i.init.TYPE == o.TYPE)) {
                            if (i.init) {
                                o.definitions = o.definitions.concat(i.init.definitions);
                            }
                            r = i.init = o;
                            e[t] = f(i);
                            fe = true;
                            continue;
                        } else if (r && i.init && r.TYPE == i.init.TYPE && k(i.init)) {
                            r.definitions = r.definitions.concat(i.init.definitions);
                            i.init = null;
                            fe = true;
                        } else if (i.init instanceof ln) {
                            r = i.init;
                        }
                    } else if (i instanceof Re) {
                        i.object = s(i.object);
                    } else if (i instanceof tn) {
                        i.condition = s(i.condition);
                    } else if (i instanceof Se) {
                        var a = c(o, i.body);
                        if (a) {
                            fe = true;
                            if (!a.length) continue;
                            i.body = U(i.body, a);
                        }
                    } else if (i instanceof rn) {
                        i.expression = s(i.expression);
                    } else if (i instanceof Ie) {
                        i.expression = s(i.expression);
                    }
                    e[++t] = r ? f(i) : i;
                }
                e.length = t + 1;
                function s(e) {
                    var n = c(o, e, 1);
                    if (!n) return e;
                    fe = true;
                    var t = e.tail_node();
                    if (n[n.length - 1] !== t) n.push(t.left);
                    return U(e, n);
                }
                function f(e) {
                    return e.transform(new at(function(e, n, t) {
                        if (e instanceof ln) {
                            if (r === e) return e;
                            if (r.TYPE != e.TYPE) return e;
                            var i = this.parent();
                            if (i instanceof Re && i.init === e) return e;
                            if (!k(e)) return e;
                            r.definitions = r.definitions.concat(e.definitions);
                            fe = true;
                            if (i instanceof Pe && i.init === e) return null;
                            return t ? we.skip : pe($e, e);
                        }
                        if (e instanceof Ue) return e;
                        if (!(e instanceof Fe)) return e;
                    }));
                }
            }
        }
        function w(e, n) {
            if (!(e instanceof Je)) {
                De.warn("Dropping unreachable code [{file}:{line},{col}]", e.start);
            }
            e.walk(new Kn(function(e) {
                if (e instanceof ln) {
                    De.warn("Declarations in unreachable code! [{file}:{line},{col}]", e.start);
                    e.remove_initializers();
                    n.push(e);
                    return true;
                }
                if (e instanceof Je) {
                    n.push(e);
                    return true;
                }
                if (e instanceof Ue) {
                    return true;
                }
            }));
        }
        function B(e, n) {
            return e.is_undefined || e instanceof Ln || e instanceof wn && e.operator == "void" && !e.expression.has_side_effects(n);
        }
        (function(e) {
            e(De, ye);
            e(Dn, oe);
            e(kn, function() {
                return this.operator == "=" && this.right.is_truthy();
            });
            e(Le, oe);
            e(Fn, oe);
            e(In, oe);
            e(_n, function() {
                return this.tail_node().is_truthy();
            });
            e(jn, function() {
                var e = this.fixed_value();
                if (!e) return false;
                this.is_truthy = ye;
                var n = e.is_truthy();
                delete this.is_truthy;
                return n;
            });
        })(function(e, n) {
            e.DEFMETHOD("is_truthy", n);
        });
        (function(e) {
            e(De, oe);
            e(Dn, ye);
            function n(e, n, t) {
                switch (e) {
                  case "-":
                    return n.is_negative_zero() && (!(t instanceof Nn) || t.value == 0);

                  case "&&":
                  case "||":
                    return n.is_negative_zero() || t.is_negative_zero();

                  case "*":
                  case "/":
                  case "%":
                    return true;

                  default:
                    return false;
                }
            }
            e(kn, function() {
                var e = this.operator;
                if (e == "=") return this.right.is_negative_zero();
                return n(e.slice(0, -1), this.left, this.right);
            });
            e(En, function() {
                return n(this.operator, this.left, this.right);
            });
            e(Nn, function() {
                return this.value == 0 && 1 / this.value < 0;
            });
            e(Le, ye);
            e(Fn, ye);
            e(In, ye);
            e(_n, function() {
                return this.tail_node().is_negative_zero();
            });
            e(jn, function() {
                var e = this.fixed_value();
                if (!e) return true;
                this.is_negative_zero = oe;
                var n = e.is_negative_zero();
                delete this.is_negative_zero;
                return n;
            });
            e(wn, function() {
                return this.operator == "+" && this.expression.is_negative_zero() || this.operator == "-";
            });
        })(function(e, n) {
            e.DEFMETHOD("is_negative_zero", n);
        });
        (function(e) {
            De.DEFMETHOD("may_throw_on_access", function(e) {
                return !e.option("pure_getters") || this._dot_throw(e);
            });
            function i(e) {
                return /strict/.test(e.option("pure_getters"));
            }
            e(De, i);
            e(Dn, ye);
            e(kn, function(e) {
                if (this.operator != "=") return false;
                var n = this.right;
                if (!n._dot_throw(e)) return false;
                var t = this.left;
                if (!(t instanceof jn)) return true;
                if (n instanceof En && n.operator == "||" && t.name == n.left.name) {
                    return n.right._dot_throw(e);
                }
                return true;
            });
            e(En, function(e) {
                switch (this.operator) {
                  case "&&":
                    return this.left._dot_throw(e) || this.right._dot_throw(e);

                  case "||":
                    return this.right._dot_throw(e);

                  default:
                    return false;
                }
            });
            e(An, function(e) {
                return this.consequent._dot_throw(e) || this.alternative._dot_throw(e);
            });
            e(Nn, ye);
            e(gn, function(e) {
                if (!i(e)) return false;
                var n = this.expression;
                if (n instanceof jn) n = n.fixed_value();
                return !(n instanceof Le && this.property == "prototype");
            });
            e(Le, ye);
            e(Un, oe);
            e(Fn, function(e) {
                if (!i(e)) return false;
                for (var n = this.properties.length; --n >= 0; ) if (this.properties[n].value instanceof Ve) return true;
                return false;
            });
            e(_n, function(e) {
                return this.tail_node()._dot_throw(e);
            });
            e(jn, function(e) {
                if (this.is_undefined) return true;
                if (!i(e)) return false;
                if (W(this) && this.is_declared(e)) return false;
                if (this.is_immutable()) return false;
                if (ce(this.definition())) return false;
                var n = this.fixed_value();
                if (!n) return true;
                this._dot_throw = oe;
                var t = n._dot_throw(e);
                delete this._dot_throw;
                return t;
            });
            e(wn, function() {
                return this.operator == "void";
            });
            e(xn, ye);
            e(Ln, oe);
        })(function(e, n) {
            e.DEFMETHOD("_dot_throw", n);
        });
        (function(e) {
            e(De, ye);
            e(Dn, oe);
            e(kn, function(e) {
                return this.operator != "=" || this.right.is_defined(e);
            });
            e(En, function(e) {
                switch (this.operator) {
                  case "&&":
                    return this.left.is_defined(e) && this.right.is_defined(e);

                  case "||":
                    return this.left.is_truthy() || this.right.is_defined(e);

                  default:
                    return true;
                }
            });
            e(An, function(e) {
                return this.consequent.is_defined(e) && this.alternative.is_defined(e);
            });
            e(Nn, oe);
            e(Le, oe);
            e(Fn, oe);
            e(_n, function(e) {
                return this.tail_node().is_defined(e);
            });
            e(jn, function(e) {
                if (this.is_undefined) return false;
                if (W(this) && this.is_declared(e)) return true;
                if (this.is_immutable()) return true;
                var n = this.fixed_value();
                if (!n) return false;
                this.is_defined = ye;
                var t = n.is_defined(e);
                delete this.is_defined;
                return t;
            });
            e(wn, function() {
                return this.operator != "void";
            });
            e(xn, oe);
            e(Ln, ye);
        })(function(e, n) {
            e.DEFMETHOD("is_defined", n);
        });
        (function(e) {
            e(De, ye);
            e(kn, function(e) {
                return this.operator == "=" && this.right.is_boolean(e);
            });
            var n = se("in instanceof == != === !== < <= >= >");
            e(En, function(e) {
                return n[this.operator] || _e[this.operator] && this.left.is_boolean(e) && this.right.is_boolean(e);
            });
            e(Jn, oe);
            var t = se("every hasOwnProperty isPrototypeOf propertyIsEnumerable some");
            e(dn, function(e) {
                if (!e.option("unsafe")) return false;
                var n = this.expression;
                return n instanceof gn && (t[n.property] || n.property == "test" && n.expression instanceof In);
            });
            e(An, function(e) {
                return this.consequent.is_boolean(e) && this.alternative.is_boolean(e);
            });
            e(vn, ye);
            e(_n, function(e) {
                return this.tail_node().is_boolean(e);
            });
            e(jn, function(e) {
                var n = this.fixed_value();
                if (!n) return false;
                this.is_boolean = ye;
                var t = n.is_boolean(e);
                delete this.is_boolean;
                return t;
            });
            var i = se("! delete");
            e(wn, function() {
                return i[this.operator];
            });
        })(function(e, n) {
            e.DEFMETHOD("is_boolean", n);
        });
        (function(e) {
            e(De, ye);
            var n = se("- * / % & | ^ << >> >>>");
            e(kn, function(e) {
                return n[this.operator.slice(0, -1)] || this.operator == "=" && this.right.is_number(e);
            });
            e(En, function(e) {
                if (n[this.operator]) return true;
                if (this.operator != "+") return false;
                return (this.left.is_boolean(e) || this.left.is_number(e)) && (this.right.is_boolean(e) || this.right.is_number(e));
            });
            var t = se([ "charCodeAt", "getDate", "getDay", "getFullYear", "getHours", "getMilliseconds", "getMinutes", "getMonth", "getSeconds", "getTime", "getTimezoneOffset", "getUTCDate", "getUTCDay", "getUTCFullYear", "getUTCHours", "getUTCMilliseconds", "getUTCMinutes", "getUTCMonth", "getUTCSeconds", "getYear", "indexOf", "lastIndexOf", "localeCompare", "push", "search", "setDate", "setFullYear", "setHours", "setMilliseconds", "setMinutes", "setMonth", "setSeconds", "setTime", "setUTCDate", "setUTCFullYear", "setUTCHours", "setUTCMilliseconds", "setUTCMinutes", "setUTCMonth", "setUTCSeconds", "setYear", "toExponential", "toFixed", "toPrecision" ]);
            e(dn, function(e) {
                if (!e.option("unsafe")) return false;
                var n = this.expression;
                return n instanceof gn && (t[n.property] || W(n.expression) && n.expression.name == "Math");
            });
            e(An, function(e) {
                return this.consequent.is_number(e) && this.alternative.is_number(e);
            });
            e(vn, ye);
            e(Rn, oe);
            e(_n, function(e) {
                return this.tail_node().is_number(e);
            });
            e(jn, function(e) {
                var n = this.fixed_value();
                if (!n) return false;
                this.is_number = ye;
                var t = n.is_number(e);
                delete this.is_number;
                return t;
            });
            var i = se("+ - ~ ++ --");
            e(yn, function() {
                return i[this.operator];
            });
        })(function(e, n) {
            e.DEFMETHOD("is_number", n);
        });
        (function(e) {
            e(De, ye);
            e(kn, function(e) {
                return (this.operator == "=" || this.operator == "+=") && this.right.is_string(e);
            });
            e(En, function(e) {
                return this.operator == "+" && (this.left.is_string(e) || this.right.is_string(e));
            });
            var t = se([ "charAt", "substr", "substring", "toLowerCase", "toString", "toUpperCase", "trim" ]);
            e(dn, function(e) {
                if (!e.option("unsafe")) return false;
                var n = this.expression;
                return n instanceof gn && t[n.property];
            });
            e(An, function(e) {
                return this.consequent.is_string(e) && this.alternative.is_string(e);
            });
            e(_n, function(e) {
                return this.tail_node().is_string(e);
            });
            e(Pn, oe);
            e(jn, function(e) {
                var n = this.fixed_value();
                if (!n) return false;
                this.is_string = ye;
                var t = n.is_string(e);
                delete this.is_string;
                return t;
            });
            e(wn, function() {
                return this.operator == "typeof";
            });
        })(function(e, n) {
            e.DEFMETHOD("is_string", n);
        });
        var _e = se("&& ||");
        var me = se("++ --");
        var A = se("delete ++ --");
        function ge(e, n) {
            if (n instanceof yn && A[n.operator]) return n.expression;
            if (n instanceof kn && n.left === e) return e;
        }
        (function(e) {
            function r(e, n) {
                if (e instanceof De) return pe(e.CTOR, n, e);
                if (Array.isArray(e)) return pe(Dn, n, {
                    elements: e.map(function(e) {
                        return r(e, n);
                    })
                });
                if (e && typeof e == "object") {
                    var t = [];
                    for (var i in e) if (fe(e, i)) {
                        t.push(pe(Bn, n, {
                            key: i,
                            value: r(e[i], n)
                        }));
                    }
                    return pe(Fn, n, {
                        properties: t
                    });
                }
                return E(e, n);
            }
            function a(e) {
                De.warn("global_defs " + e.print_to_string() + " redefined [{file}:{line},{col}]", e.start);
            }
            Ye.DEFMETHOD("resolve_defines", function(o) {
                if (!o.option("global_defs")) return this;
                this.figure_out_scope({
                    ie8: o.option("ie8")
                });
                return this.transform(new at(function(e) {
                    var n = e._find_defs(o, "");
                    if (!n) return;
                    var t = 0, i = e, r;
                    while (r = this.parent(t++)) {
                        if (!(r instanceof mn)) break;
                        if (r.expression !== i) break;
                        i = r;
                    }
                    if (ge(i, r)) {
                        a(e);
                        return;
                    }
                    return n;
                }));
            });
            e(De, re);
            e(gn, function(e, n) {
                return this.expression._find_defs(e, "." + this.property + n);
            });
            e(Tn, function(e) {
                if (!this.global()) return;
                if (fe(e.option("global_defs"), this.name)) a(this);
            });
            e(jn, function(e, n) {
                if (!this.global()) return;
                var t = e.option("global_defs");
                var i = this.name + n;
                if (fe(t, i)) return r(t[i], this);
            });
        })(function(e, n) {
            e.DEFMETHOD("_find_defs", n);
        });
        function k(e, n, t) {
            var i = n.print_to_string().length - e.print_to_string().length;
            return i < (t || 0) ? n : e;
        }
        function a(e, n, t) {
            return k(pe(Se, e, {
                body: e
            }), pe(Se, n, {
                body: n
            }), t).body;
        }
        function G(e, n, t, i) {
            return (ke(e) ? a : k)(n, t, i);
        }
        function t(n) {
            var t = Object.create(null);
            Object.keys(n).forEach(function(e) {
                t[e] = se(n[e]);
            });
            return t;
        }
        Le.DEFMETHOD("first_statement", function() {
            var e = this.body;
            for (var n = 0; n < e.length; n++) {
                var t = e[n];
                if (!(t instanceof Be)) return t;
            }
        });
        function X(e, n) {
            var t = n.evaluate(e);
            if (t === n) return n;
            t = E(t, n).optimize(e);
            return G(e, n, t, e.eval_threshold);
        }
        var i = [ "constructor", "toString", "valueOf" ];
        var m = t({
            Array: [ "indexOf", "join", "lastIndexOf", "slice" ].concat(i),
            Boolean: i,
            Function: i,
            Number: [ "toExponential", "toFixed", "toPrecision" ].concat(i),
            Object: i,
            RegExp: [ "exec", "test" ].concat(i),
            String: [ "charAt", "charCodeAt", "concat", "indexOf", "italics", "lastIndexOf", "match", "replace", "search", "slice", "split", "substr", "substring", "toLowerCase", "toUpperCase", "trim" ].concat(i)
        });
        var g = t({
            Array: [ "isArray" ],
            Math: [ "abs", "acos", "asin", "atan", "ceil", "cos", "exp", "floor", "log", "round", "sin", "sqrt", "tan", "atan2", "pow", "max", "min" ],
            Number: [ "isFinite", "isNaN" ],
            Object: [ "create", "getOwnPropertyDescriptor", "getOwnPropertyNames", "getPrototypeOf", "isExtensible", "isFrozen", "isSealed", "keys" ],
            String: [ "fromCharCode" ]
        });
        (function(e) {
            De.DEFMETHOD("evaluate", function(e, n) {
                if (!e.option("evaluate")) return this;
                var t = [];
                var i = this._eval(e, n, t, 1);
                t.forEach(function(e) {
                    delete e._eval;
                });
                if (n) return i;
                if (!i || i instanceof RegExp) return i;
                if (typeof i == "function" || typeof i == "object") return this;
                return i;
            });
            var n = se("! ~ - + void");
            De.DEFMETHOD("is_constant", function() {
                if (this instanceof Nn) {
                    return !(this instanceof In);
                } else {
                    return this instanceof wn && this.expression instanceof Nn && n[this.operator];
                }
            });
            var u = new Kn(function(e) {
                if (e instanceof kn) f(e.left);
                if (e instanceof yn && me[e.operator]) f(e.expression);
            });
            function f(e) {
                if (e instanceof gn) {
                    f(e.expression);
                } else if (e instanceof bn) {
                    f(e.expression);
                    e.property.walk(u);
                } else if (e instanceof jn) {
                    e.definition().references.forEach(function(e) {
                        delete e._eval;
                    });
                }
            }
            e(Fe, function() {
                throw new Error(ae("Cannot evaluate a statement [{file}:{line},{col}]", this.start));
            });
            e(Ve, R);
            e(De, R);
            e(Nn, function() {
                return this.value;
            });
            e(kn, function(e, n, t, i) {
                if (!n) return this;
                if (this.operator != "=") return this;
                var r = this.right;
                var o = r._eval(e, n, t, i);
                f(this.left);
                return o === r ? this : o;
            });
            e(_n, function(e, n, t, i) {
                if (!n) return this;
                var r = this.expressions;
                for (var o = 0, a = r.length - 1; o < a; o++) {
                    r[o].walk(u);
                }
                var s = r[a];
                var f = s._eval(e, n, t, i);
                return f === s ? this : f;
            });
            e(Le, function(e) {
                if (e.option("unsafe")) {
                    var n = function() {};
                    n.node = this;
                    n.toString = function() {
                        return "function(){}";
                    };
                    return n;
                }
                return this;
            });
            e(Dn, function(e, n, t, i) {
                if (e.option("unsafe")) {
                    var r = [];
                    for (var o = 0; o < this.elements.length; o++) {
                        var a = this.elements[o];
                        var s = a._eval(e, n, t, i);
                        if (a === s) return this;
                        r.push(s);
                    }
                    return r;
                }
                return this;
            });
            e(Fn, function(e, n, t, i) {
                if (e.option("unsafe")) {
                    var r = {};
                    for (var o = 0; o < this.properties.length; o++) {
                        var a = this.properties[o];
                        var s = a.key;
                        if (s instanceof Sn) {
                            s = s.name;
                        } else if (s instanceof De) {
                            s = s._eval(e, n, t, i);
                            if (s === a.key) return this;
                        }
                        if (typeof Object.prototype[s] === "function") {
                            return this;
                        }
                        if (a.value instanceof We) continue;
                        r[s] = a.value._eval(e, n, t, i);
                        if (r[s] === a.value) return this;
                    }
                    return r;
                }
                return this;
            });
            var c = se("! typeof void");
            e(wn, function(e, n, t, i) {
                var r = this.expression;
                var o = this.operator;
                if (e.option("typeofs") && o == "typeof" && (r instanceof Le || r instanceof jn && r.fixed_value() instanceof Le)) {
                    return typeof function() {};
                }
                if (!c[o]) i++;
                var a = r._eval(e, n, t, i);
                if (a === r) {
                    if (n && o == "void") return;
                    return this;
                }
                switch (o) {
                  case "!":
                    return !a;

                  case "typeof":
                    if (a instanceof RegExp) return this;
                    return typeof a;

                  case "void":
                    return;

                  case "~":
                    return ~a;

                  case "-":
                    return -a;

                  case "+":
                    return +a;

                  case "++":
                  case "--":
                    if (!(r instanceof jn)) return this;
                    var s = r.definition().references;
                    if (!n && s[s.length - 1] !== r) return this;
                    if (fe(r, "_eval")) a = +(o[0] + 1) + +a;
                    f(r);
                    return a;
                }
                return this;
            });
            e(xn, function(e, n, t, i) {
                var r = this.expression;
                if (!r.fixed) return this;
                var o = r.definition().references;
                if (!n && o[o.length - 1] !== r) return this;
                var a = r._eval(e, n, t, i + 1);
                f(r);
                return a === r ? this : +a;
            });
            var l = se("&& || === !==");
            e(En, function(e, n, t, i) {
                if (!l[this.operator]) i++;
                var r = this.left._eval(e, n, t, i);
                if (r === this.left) return this;
                if (this.operator == (r ? "||" : "&&")) return r;
                var o = this.right._eval(e, n, t, i);
                if (o === this.right) return this;
                var a;
                switch (this.operator) {
                  case "&&":
                    a = r && o;
                    break;

                  case "||":
                    a = r || o;
                    break;

                  case "|":
                    a = r | o;
                    break;

                  case "&":
                    a = r & o;
                    break;

                  case "^":
                    a = r ^ o;
                    break;

                  case "+":
                    a = r + o;
                    break;

                  case "*":
                    a = r * o;
                    break;

                  case "/":
                    a = r / o;
                    break;

                  case "%":
                    a = r % o;
                    break;

                  case "-":
                    a = r - o;
                    break;

                  case "<<":
                    a = r << o;
                    break;

                  case ">>":
                    a = r >> o;
                    break;

                  case ">>>":
                    a = r >>> o;
                    break;

                  case "==":
                    a = r == o;
                    break;

                  case "===":
                    a = r === o;
                    break;

                  case "!=":
                    a = r != o;
                    break;

                  case "!==":
                    a = r !== o;
                    break;

                  case "<":
                    a = r < o;
                    break;

                  case "<=":
                    a = r <= o;
                    break;

                  case ">":
                    a = r > o;
                    break;

                  case ">=":
                    a = r >= o;
                    break;

                  default:
                    return this;
                }
                if (isNaN(a)) return e.find_parent(Ie) ? this : a;
                if (e.option("unsafe_math") && !n && a && typeof a == "number" && (this.operator == "+" || this.operator == "-")) {
                    var s = Math.max(0, f(r), f(o));
                    if (s < 16) return +a.toFixed(s);
                }
                return a;
                function f(e) {
                    var n = /(\.[0-9]*)?(e.+)?$/.exec(+e);
                    return (n[1] || ".").length - 1 - (n[2] || "").slice(1);
                }
            });
            e(An, function(e, n, t, i) {
                var r = this.condition._eval(e, n, t, i);
                if (r === this.condition) return this;
                var o = r ? this.consequent : this.alternative;
                var a = o._eval(e, n, t, i);
                return a === o ? this : a;
            });
            e(jn, function(e, n, t, i) {
                var r = this.fixed_value();
                if (!r) return this;
                var o;
                if (be(r, t)) {
                    o = r._eval();
                } else {
                    this._eval = R;
                    o = r._eval(e, n, t, i);
                    delete this._eval;
                    if (o === r) return this;
                    r._eval = function() {
                        return o;
                    };
                    t.push(r);
                }
                if (o && typeof o == "object") {
                    var a = this.definition().escaped;
                    switch (a.length) {
                      case 0:
                        break;

                      case 1:
                        if (s(a[0], this)) break;

                      default:
                        if (i > a.depth) return this;
                    }
                }
                return o;
                function s(e, n) {
                    var t = false;
                    e.walk(new Kn(function(e) {
                        if (t) return true;
                        if (e === n) return t = true;
                    }));
                    return t;
                }
            });
            var _ = {
                Array: Array,
                Math: Math,
                Number: Number,
                Object: Object,
                String: String
            };
            var p = t({
                Math: [ "E", "LN10", "LN2", "LOG2E", "LOG10E", "PI", "SQRT1_2", "SQRT2" ],
                Number: [ "MAX_VALUE", "MIN_VALUE", "NaN", "NEGATIVE_INFINITY", "POSITIVE_INFINITY" ]
            });
            var h = se("global ignoreCase multiline source");
            e(mn, function(e, n, t, i) {
                if (e.option("unsafe")) {
                    var r = this.property;
                    if (r instanceof De) {
                        r = r._eval(e, n, t, i);
                        if (r === this.property) return this;
                    }
                    var o = this.expression;
                    var a;
                    if (W(o)) {
                        var s = p[o.name];
                        if (!s || !s[r]) return this;
                        a = _[o.name];
                    } else {
                        a = o._eval(e, n, t, i + 1);
                        if (a == null || a === o) return this;
                        if (a instanceof RegExp) {
                            if (!h[r]) return this;
                        } else if (typeof a == "object") {
                            if (!fe(a, r)) return this;
                        } else if (typeof a == "function") switch (r) {
                          case "name":
                            return a.node.name ? a.node.name.name : "";

                          case "length":
                            return a.node.argnames.length;

                          default:
                            return this;
                        }
                    }
                    return a[r];
                }
                return this;
            });
            e(dn, function(o, a, s, f) {
                var e = this.expression;
                var n = e instanceof jn ? e.fixed_value() : e;
                if (n instanceof Le) {
                    if (n.evaluating) return this;
                    if (n.name && n.name.definition().recursive_refs > 0) return this;
                    if (this.is_expr_pure(o)) return this;
                    var t = n.first_statement();
                    if (!(t instanceof Ke)) {
                        if (a) {
                            var i = false;
                            n.walk(new Kn(function(e) {
                                if (i) return true;
                                if (e instanceof Ke) {
                                    if (e.value && e.value.evaluate(o, true) !== undefined) i = true;
                                    return true;
                                }
                                if (e instanceof Ue && e !== n) return true;
                            }));
                            if (!i) return;
                        }
                        return this;
                    }
                    var r = v(this.args);
                    if (!r && !a) return this;
                    var u = t.value;
                    if (!u) return;
                    var c = [];
                    if (!r || Ee(n.argnames, function(e, n) {
                        var t = r[n];
                        var i = e.definition();
                        if (i.orig[i.orig.length - 1] !== e) return false;
                        i.references.forEach(function(e) {
                            e._eval = function() {
                                return t;
                            };
                            c.push(e);
                        });
                        return true;
                    }) || a) {
                        n.evaluating = true;
                        u = u._eval(o, a, s, f);
                        delete n.evaluating;
                    }
                    c.forEach(function(e) {
                        delete e._eval;
                    });
                    return u === t.value ? this : u;
                } else if (o.option("unsafe") && e instanceof mn) {
                    var l = e.property;
                    if (l instanceof De) {
                        l = l._eval(o, a, s, f);
                        if (l === e.property) return this;
                    }
                    var u;
                    var p = e.expression;
                    if (W(p)) {
                        var h = g[p.name];
                        if (!h || !h[l]) return this;
                        u = _[p.name];
                    } else {
                        u = p._eval(o, a, s, f + 1);
                        if (u == null || u === p) return this;
                        var d = m[u.constructor.name];
                        if (!d || !d[l]) return this;
                        if (u instanceof RegExp && u.global && !(p instanceof In)) return this;
                    }
                    var r = v(this.args);
                    if (!r) return this;
                    if (l == "replace" && typeof r[1] == "function") return this;
                    try {
                        return u[l].apply(u, r);
                    } catch (e) {
                        De.warn("Error evaluating {code} [{file}:{line},{col}]", {
                            code: this.print_to_string(),
                            file: this.start.file,
                            line: this.start.line,
                            col: this.start.col
                        });
                    } finally {
                        if (u instanceof RegExp) u.lastIndex = 0;
                    }
                }
                return this;
                function v(e) {
                    var n = [];
                    for (var t = 0; t < e.length; t++) {
                        var i = e[t];
                        var r = i._eval(o, a, s, f);
                        if (i === r) return;
                        n.push(r);
                    }
                    return n;
                }
            });
            e(vn, R);
        })(function(e, n) {
            e.DEFMETHOD("_eval", n);
        });
        (function(e) {
            function o(e) {
                return pe(wn, e, {
                    operator: "!",
                    expression: e
                });
            }
            function r(e, n, t) {
                var i = o(e);
                if (t) {
                    var r = pe(Se, n, {
                        body: n
                    });
                    return k(i, r) === r ? n : i;
                }
                return k(i, n);
            }
            e(De, function() {
                return o(this);
            });
            e(Fe, function() {
                throw new Error("Cannot negate a statement");
            });
            e(We, function() {
                return o(this);
            });
            e(wn, function() {
                if (this.operator == "!") return this.expression;
                return o(this);
            });
            e(_n, function(e) {
                var n = this.expressions.slice();
                n.push(n.pop().negate(e));
                return U(this, n);
            });
            e(An, function(e, n) {
                var t = this.clone();
                t.consequent = t.consequent.negate(e);
                t.alternative = t.alternative.negate(e);
                return r(this, t, n);
            });
            e(En, function(e, n) {
                var t = this.clone(), i = this.operator;
                if (e.option("unsafe_comps")) {
                    switch (i) {
                      case "<=":
                        t.operator = ">";
                        return t;

                      case "<":
                        t.operator = ">=";
                        return t;

                      case ">=":
                        t.operator = "<";
                        return t;

                      case ">":
                        t.operator = "<=";
                        return t;
                    }
                }
                switch (i) {
                  case "==":
                    t.operator = "!=";
                    return t;

                  case "!=":
                    t.operator = "==";
                    return t;

                  case "===":
                    t.operator = "!==";
                    return t;

                  case "!==":
                    t.operator = "===";
                    return t;

                  case "&&":
                    t.operator = "||";
                    t.left = t.left.negate(e, n);
                    t.right = t.right.negate(e);
                    return r(this, t, n);

                  case "||":
                    t.operator = "&&";
                    t.left = t.left.negate(e, n);
                    t.right = t.right.negate(e);
                    return r(this, t, n);
                }
                return o(this);
            });
        })(function(e, t) {
            e.DEFMETHOD("negate", function(e, n) {
                return t.call(this, e, n);
            });
        });
        var s = se("Boolean decodeURI decodeURIComponent Date encodeURI encodeURIComponent Error escape EvalError isFinite isNaN Number Object parseFloat parseInt RangeError ReferenceError String SyntaxError TypeError unescape URIError");
        dn.DEFMETHOD("is_expr_pure", function(e) {
            if (e.option("unsafe")) {
                var n = this.expression;
                if (W(n) && s[n.name]) return true;
                if (n instanceof gn && W(n.expression)) {
                    var t = g[n.expression.name];
                    return t && t[n.property];
                }
            }
            return this.pure || !e.pure_funcs(this);
        });
        De.DEFMETHOD("is_call_pure", ye);
        dn.DEFMETHOD("is_call_pure", function(e) {
            if (!e.option("unsafe")) return false;
            var n = this.expression;
            if (!(n instanceof gn)) return false;
            var t = n.expression;
            var i;
            var r = n.property;
            if (t instanceof Dn) {
                i = m.Array;
            } else if (t.is_boolean(e)) {
                i = m.Boolean;
            } else if (t.is_number(e)) {
                i = m.Number;
            } else if (t instanceof In) {
                i = m.RegExp;
            } else if (t.is_string(e)) {
                i = m.String;
                if (r == "replace") {
                    var o = this.args[1];
                    if (o && !o.is_string(e)) return false;
                }
            } else if (!n.may_throw_on_access(e)) {
                i = m.Object;
            }
            return i && i[r];
        });
        (function(e) {
            function n(e, n) {
                for (var t = e.length; --t >= 0; ) if (e[t].has_side_effects(n)) return true;
                return false;
            }
            e(De, oe);
            e(Dn, function(e) {
                return n(this.elements, e);
            });
            e(kn, oe);
            e(En, function(e) {
                return this.left.has_side_effects(e) || this.right.has_side_effects(e);
            });
            e(Oe, function(e) {
                return n(this.body, e);
            });
            e(dn, function(e) {
                if (!this.is_expr_pure(e) && (!this.is_call_pure(e) || this.expression.has_side_effects(e))) {
                    return true;
                }
                return n(this.args, e);
            });
            e(sn, function(e) {
                return this.expression.has_side_effects(e) || n(this.body, e);
            });
            e(An, function(e) {
                return this.condition.has_side_effects(e) || this.consequent.has_side_effects(e) || this.alternative.has_side_effects(e);
            });
            e(Nn, ye);
            e(ln, function(e) {
                return n(this.definitions, e);
            });
            e(gn, function(e) {
                return this.expression.may_throw_on_access(e) || this.expression.has_side_effects(e);
            });
            e($e, ye);
            e(tn, function(e) {
                return this.condition.has_side_effects(e) || this.body && this.body.has_side_effects(e) || this.alternative && this.alternative.has_side_effects(e);
            });
            e(Me, function(e) {
                return this.body.has_side_effects(e);
            });
            e(Le, ye);
            e(Fn, function(e) {
                return n(this.properties, e);
            });
            e(Cn, function(e) {
                return this.value.has_side_effects(e);
            });
            e(bn, function(e) {
                return this.expression.may_throw_on_access(e) || this.expression.has_side_effects(e) || this.property.has_side_effects(e);
            });
            e(_n, function(e) {
                return n(this.expressions, e);
            });
            e(Se, function(e) {
                return this.body.has_side_effects(e);
            });
            e(rn, function(e) {
                return this.expression.has_side_effects(e) || n(this.body, e);
            });
            e(Tn, ye);
            e(jn, function(e) {
                return !this.is_declared(e);
            });
            e(Hn, ye);
            e(fn, function(e) {
                return n(this.body, e) || this.bcatch && this.bcatch.has_side_effects(e) || this.bfinally && this.bfinally.has_side_effects(e);
            });
            e(yn, function(e) {
                return A[this.operator] || this.expression.has_side_effects(e);
            });
            e(hn, function(e) {
                return this.value;
            });
        })(function(e, n) {
            e.DEFMETHOD("has_side_effects", n);
        });
        (function(e) {
            e(De, oe);
            e(Nn, ye);
            e($e, ye);
            e(Le, ye);
            e(Tn, ye);
            e(Hn, ye);
            function n(e, n) {
                for (var t = e.length; --t >= 0; ) if (e[t].may_throw(n)) return true;
                return false;
            }
            e(Dn, function(e) {
                return n(this.elements, e);
            });
            e(kn, function(e) {
                if (this.right.may_throw(e)) return true;
                if (!e.has_directive("use strict") && this.operator == "=" && this.left instanceof jn) {
                    return false;
                }
                return this.left.may_throw(e);
            });
            e(En, function(e) {
                return this.left.may_throw(e) || this.right.may_throw(e);
            });
            e(Oe, function(e) {
                return n(this.body, e);
            });
            e(dn, function(e) {
                if (n(this.args, e)) return true;
                if (this.is_expr_pure(e)) return false;
                if (this.expression.may_throw(e)) return true;
                return !(this.expression instanceof Le) || n(this.expression.body, e);
            });
            e(sn, function(e) {
                return this.expression.may_throw(e) || n(this.body, e);
            });
            e(An, function(e) {
                return this.condition.may_throw(e) || this.consequent.may_throw(e) || this.alternative.may_throw(e);
            });
            e(ln, function(e) {
                return n(this.definitions, e);
            });
            e(gn, function(e) {
                return this.expression.may_throw_on_access(e) || this.expression.may_throw(e);
            });
            e(tn, function(e) {
                return this.condition.may_throw(e) || this.body && this.body.may_throw(e) || this.alternative && this.alternative.may_throw(e);
            });
            e(Me, function(e) {
                return this.body.may_throw(e);
            });
            e(Fn, function(e) {
                return n(this.properties, e);
            });
            e(Cn, function(e) {
                return this.value.may_throw(e);
            });
            e(Ke, function(e) {
                return this.value && this.value.may_throw(e);
            });
            e(_n, function(e) {
                return n(this.expressions, e);
            });
            e(Se, function(e) {
                return this.body.may_throw(e);
            });
            e(bn, function(e) {
                return this.expression.may_throw_on_access(e) || this.expression.may_throw(e) || this.property.may_throw(e);
            });
            e(rn, function(e) {
                return this.expression.may_throw(e) || n(this.body, e);
            });
            e(jn, function(e) {
                return !this.is_declared(e);
            });
            e(fn, function(e) {
                return (this.bcatch ? this.bcatch.may_throw(e) : n(this.body, e)) || this.bfinally && this.bfinally.may_throw(e);
            });
            e(yn, function(e) {
                if (this.operator == "typeof" && this.expression instanceof jn) return false;
                return this.expression.may_throw(e);
            });
            e(hn, function(e) {
                if (!this.value) return false;
                return this.value.may_throw(e);
            });
        })(function(e, n) {
            e.DEFMETHOD("may_throw", n);
        });
        (function(e) {
            function n(e) {
                for (var n = e.length; --n >= 0; ) if (!e[n].is_constant_expression()) return false;
                return true;
            }
            e(De, ye);
            e(Dn, function() {
                return n(this.elements);
            });
            e(En, function() {
                return this.left.is_constant_expression() && this.right.is_constant_expression();
            });
            e(Nn, oe);
            e(Le, function(r) {
                var o = this;
                var a = true;
                var s = [];
                o.walk(new Kn(function(e, n) {
                    if (!a) return true;
                    if (e instanceof un) {
                        s.push(e.argname.scope);
                        n();
                        s.pop();
                        return true;
                    }
                    if (e instanceof Ue) {
                        if (e === o) return;
                        s.push(e);
                        n();
                        s.pop();
                        return true;
                    }
                    if (e instanceof jn) {
                        if (o.inlined) {
                            a = false;
                            return true;
                        }
                        if (o.variables.has(e.name)) return true;
                        var t = e.definition();
                        if (be(t.scope, s)) return true;
                        if (r) {
                            var i = r.find_variable(e);
                            if (t.undeclared ? !i : i === t) {
                                a = "f";
                                return true;
                            }
                        }
                        a = false;
                        return true;
                    }
                }));
                return a;
            });
            e(Fn, function() {
                return n(this.properties);
            });
            e(Cn, function() {
                return this.value.is_constant_expression();
            });
            e(yn, function() {
                return this.expression.is_constant_expression();
            });
        })(function(e, n) {
            e.DEFMETHOD("is_constant_expression", n);
        });
        function C(e) {
            return e && e.aborts();
        }
        (function(e) {
            e(Fe, I);
            e(Ge, R);
            function n() {
                var e = this.body.length;
                return e > 0 && C(this.body[e - 1]);
            }
            e(ze, n);
            e(on, n);
            e(tn, function() {
                return this.alternative && C(this.body) && C(this.alternative) && this;
            });
        })(function(e, n) {
            e.DEFMETHOD("aborts", n);
        });
        var f = se([ "use asm", "use strict" ]);
        e(Be, function(e, n) {
            if (n.option("directives") && (!f[e.value] || n.has_directive(e.value) !== e)) {
                return pe($e, e);
            }
            return e;
        });
        e(Ce, function(e, n) {
            if (n.option("drop_debugger")) return pe($e, e);
            return e;
        });
        e(Me, function(e, n) {
            if (n.option("dead_code") && e.body instanceof en && n.loopcontrol_target(e.body) === e.body) {
                return pe($e, e);
            }
            return n.option("unused") && e.label.references.length == 0 ? e.body : e;
        });
        e(Oe, function(e, n) {
            e.body = c(e.body, n);
            return e;
        });
        e(ze, function(e, n) {
            e.body = c(e.body, n);
            switch (e.body.length) {
              case 1:
                return e.body[0];

              case 0:
                return pe($e, e);
            }
            return e;
        });
        e(We, function(n, e) {
            n.body = c(n.body, e);
            if (e.option("inline")) for (var t = 0; t < n.body.length; t++) {
                var i = n.body[t];
                if (i instanceof Be) continue;
                if (i instanceof Ke) {
                    var r = i.value;
                    if (!r || r.TYPE != "Call") break;
                    if (r.is_expr_pure(e)) break;
                    var o = r.expression;
                    if (o instanceof jn) {
                        if (n.name && n.name.definition() === o.definition()) break;
                        o = o.fixed_value();
                    }
                    if (!(o instanceof Le)) break;
                    if (o.uses_arguments) break;
                    if (o === r.expression) {
                        if (o.parent_scope !== n) break;
                        if (!Ee(o.enclosed, function(e) {
                            return e.scope !== n;
                        })) break;
                    }
                    if (o.contains_this()) break;
                    var a = o.argnames.length;
                    if (a > 0 && e.option("inline") < 2) break;
                    if (a > n.argnames.length) break;
                    for (var s = 0; s < a; s++) {
                        var f = r.args[s];
                        if (!(f instanceof jn)) break;
                        if (f.definition() !== n.argnames[s].definition()) break;
                    }
                    if (s < a) break;
                    for (;s < r.args.length; s++) {
                        if (r.args[s].has_side_effects(e)) break;
                    }
                    if (s < r.args.length) break;
                    if (a < n.argnames.length && !e.drop_fargs(n, e.parent())) {
                        if (!e.drop_fargs(o, r)) break;
                        do {
                            var u = pe(zn, o, {
                                name: o.make_var_name("argument_" + a),
                                scope: o
                            });
                            o.argnames.push(u);
                            o.enclosed.push(o.def_variable(u));
                        } while (++a < n.argnames.length);
                    }
                    return r.expression;
                }
                break;
            }
            return n;
        });
        Ue.DEFMETHOD("drop_unused", function(b) {
            if (!b.option("unused")) return;
            if (b.has_directive("use asm")) return;
            var y = this;
            if (y.pinned()) return;
            var w = !(y instanceof Ye) || b.toplevel.funcs;
            var x = !(y instanceof Ye) || b.toplevel.vars;
            var E = /keep_assign/.test(b.option("unused")) ? ye : function(e, n) {
                var t;
                if (e instanceof kn) {
                    if (e.write_only || e.operator == "=") t = e.left;
                } else if (e instanceof yn) {
                    if (e.write_only) t = e.expression;
                }
                if (/strict/.test(b.option("pure_getters"))) {
                    while (t instanceof mn && !t.expression.may_throw_on_access(b)) {
                        if (t instanceof bn) n.unshift(t.property);
                        t = t.expression;
                    }
                }
                if (!(t instanceof jn)) return;
                if (b.exposed(t.definition())) return;
                if (!Ee(t.definition().orig, function(e) {
                    return !(e instanceof Mn);
                })) return;
                return t;
            };
            var u = Object.create(null);
            var c = [];
            var A = Object.create(null);
            var l = Object.create(null);
            var p = Object.create(null);
            if (y instanceof Ye && b.top_retain) {
                y.variables.each(function(e) {
                    if (b.top_retain(e) && !(e.id in A)) {
                        A[e.id] = true;
                        c.push(e);
                    }
                });
            }
            var k = new Ae();
            var D = new Ae();
            var h = new Ae();
            var F = this;
            var d = new Kn(function(e, n) {
                if (e instanceof Le && e.uses_arguments && !d.has_directive("use strict")) {
                    e.argnames.forEach(function(e) {
                        var n = e.definition();
                        if (!(n.id in A)) {
                            A[n.id] = true;
                            c.push(n);
                        }
                    });
                }
                if (e === y) return;
                if (e instanceof Je) {
                    var t = e.name.definition();
                    if (!w && F === y) {
                        if (!(t.id in A)) {
                            A[t.id] = true;
                            c.push(t);
                        }
                    }
                    h.add(t.id, e);
                    return true;
                }
                if (e instanceof zn && F === y) {
                    D.add(e.definition().id, e);
                }
                if (e instanceof ln && F === y) {
                    e.definitions.forEach(function(e) {
                        var n = e.name.definition();
                        D.add(n.id, e);
                        if (!x) {
                            if (!(n.id in A)) {
                                A[n.id] = true;
                                c.push(n);
                            }
                        }
                        if (e.value) {
                            if (e.value.has_side_effects(b)) {
                                e.value.walk(d);
                            } else {
                                h.add(n.id, e.value);
                            }
                            v(n, e);
                        }
                    });
                    return true;
                }
                return i(e, n, true);
            });
            y.walk(d);
            d = new Kn(i);
            for (var e = 0; e < c.length; e++) {
                var n = h.get(c[e].id);
                if (n) n.forEach(function(e) {
                    e.walk(d);
                });
            }
            var C = b.option("keep_fnames") ? ye : b.option("ie8") ? function(e) {
                return !b.exposed(e) && e.references.length == e.replaced;
            } : function(e) {
                return !(e.id in A) || e.orig.length > 1;
            };
            var B = [];
            var S = [];
            var T = [];
            var O = new at(function(f, e, n) {
                var u = O.parent();
                if (x) {
                    var t = [], i = E(f, t);
                    if (i) {
                        var r = i.definition();
                        var o = r.id in A;
                        var a;
                        if (f instanceof kn) {
                            if (!o || f.left === i && M(r, f) < 0) {
                                a = q(f);
                                if (f.write_only === true) {
                                    a = a.drop_side_effect_free(b) || pe(Rn, f, {
                                        value: 0
                                    });
                                }
                            }
                        } else if (!o || f.expression === i && M(r, f) < 0) {
                            a = pe(Rn, f, {
                                value: 0
                            });
                        }
                        if (a) {
                            if (u instanceof _n && u.tail_node() !== f) {
                                a = a.drop_side_effect_free(b);
                            }
                            if (a) t.push(a);
                            switch (t.length) {
                              case 0:
                                return we.skip;

                              case 1:
                                return he(b, u, f, t[0].transform(O));

                              default:
                                return U(f, t.map(function(e) {
                                    return e.transform(O);
                                }));
                            }
                        }
                    }
                }
                if (f instanceof dn) S.push(f);
                if (F !== y) return;
                if (f instanceof Le) {
                    if (w && f !== y && f instanceof Je) {
                        var r = f.name.definition();
                        if (!(r.id in A)) {
                            z(f.name, "Dropping unused function {name} [{file}:{line},{col}]", $(f.name));
                            r.eliminated++;
                            return n ? we.skip : pe($e, f);
                        }
                    }
                    if (f instanceof We && f.name && C(f.name.definition())) {
                        B.push(f);
                    }
                    if (!(f instanceof Ve)) {
                        var s = b.drop_fargs(f, u);
                        for (var c = f.argnames, l = c.length; --l >= 0; ) {
                            var i = c[l];
                            if (!(i.definition().id in A)) {
                                i.__unused = true;
                                if (s) {
                                    z(i, "Dropping unused function argument {name} [{file}:{line},{col}]", $(i));
                                    c.pop();
                                }
                            } else {
                                s = false;
                            }
                        }
                        T.push(f);
                    }
                }
                if (f instanceof ln && !(u instanceof Re && u.init === f)) {
                    var p = [], h = [], d = [];
                    var v = [];
                    var _ = 0;
                    f.definitions.forEach(function(e) {
                        if (e.value) e.value = e.value.transform(O);
                        var n = e.name.definition();
                        if (!x || n.id in A) {
                            if (e.value && M(n, e) < 0) {
                                e.value = e.value.drop_side_effect_free(b);
                            }
                            var t = D.get(n.id);
                            if (!e.value) {
                                if (t.length > 1) {
                                    De.warn("Dropping duplicated declaration of variable {name} [{file}:{line},{col}]", $(e.name));
                                    xe(t, e);
                                    n.eliminated++;
                                } else {
                                    h.push(e);
                                }
                            } else if (b.option("functions") && !b.option("ie8") && t.length == 1 && n.assignments == 0 && e.value === e.name.fixed_value() && e.value instanceof We && !(e.value.name && e.value.name.definition().assignments) && s(e.value, e.name.name) && (!b.has_directive("use strict") || u instanceof Ue)) {
                                De.warn("Declaring {name} as function [{file}:{line},{col}]", $(e.name));
                                var i = pe(Je, e, e.value);
                                i.name = pe($n, e.name, e.name);
                                var r = e.name.scope.resolve().def_function(i.name);
                                if (e.value.name) {
                                    var o = e.value.name.definition();
                                    e.value.walk(new Kn(function(e) {
                                        if (e instanceof jn && e.definition() === o) {
                                            e.name = r.name;
                                            e.thedef = r;
                                            e.reference({});
                                        }
                                    }));
                                }
                                p.push(i);
                            } else {
                                if (t.length > 1 && n.orig.indexOf(e.name) > n.eliminated) {
                                    xe(t, e);
                                    _++;
                                }
                                if (v.length > 0) {
                                    if (d.length > 0) {
                                        v.push(e.value);
                                        e.value = U(e.value, v);
                                    } else {
                                        p.push(pe(Se, f, {
                                            body: U(f, v)
                                        }));
                                    }
                                    v = [];
                                }
                                d.push(e);
                            }
                        } else if (n.orig[0] instanceof qn) {
                            var a = e.value && e.value.drop_side_effect_free(b);
                            if (a) v.push(a);
                            var t = D.get(n.id);
                            if (t.length > 1) {
                                De.warn("Dropping duplicated declaration of variable {name} [{file}:{line},{col}]", $(e.name));
                                xe(t, e);
                                n.eliminated++;
                            } else {
                                e.value = null;
                                h.push(e);
                            }
                        } else {
                            var a = e.value && !e.value.single_use && e.value.drop_side_effect_free(b);
                            if (a) {
                                De.warn("Side effects in initialization of unused variable {name} [{file}:{line},{col}]", $(e.name));
                                v.push(a);
                            } else {
                                z(e.name, "Dropping unused variable {name} [{file}:{line},{col}]", $(e.name));
                            }
                            n.eliminated++;
                        }
                        function s(e, n) {
                            var t = e.variables.get(n);
                            return !t || e.name && t === e.name.definition();
                        }
                    });
                    if (h.length == 0 && d.length == _) {
                        [].unshift.apply(v, d.map(function(e) {
                            De.warn("Dropping duplicated definition of variable {name} [{file}:{line},{col}]", $(e.name));
                            var n = e.name.definition();
                            var t = pe(jn, e.name, e.name);
                            n.references.push(t);
                            var i = pe(kn, e, {
                                operator: "=",
                                left: t,
                                right: e.value
                            });
                            var r = M(n, e);
                            if (r >= 0) k.get(n.id)[r] = i;
                            n.eliminated++;
                            return i.transform(O);
                        }));
                    } else if (h.length > 0 || d.length > 0) {
                        f.definitions = h.concat(d);
                        p.push(f);
                    }
                    if (v.length > 0) {
                        p.push(pe(Se, f, {
                            body: U(f, v)
                        }));
                    }
                    switch (p.length) {
                      case 0:
                        return n ? we.skip : pe($e, f);

                      case 1:
                        return p[0];

                      default:
                        return n ? we.splice(p) : pe(ze, f, {
                            body: p
                        });
                    }
                }
                if (f instanceof Me && f.body instanceof Pe) {
                    e(f, O);
                    if (f.body instanceof ze) {
                        var m = f.body;
                        f.body = m.body.pop();
                        m.body.push(f);
                        return n ? we.splice(m.body) : m;
                    }
                    return f;
                }
                if (f instanceof Ue) {
                    var g = F;
                    F = f;
                    e(f, O);
                    F = g;
                    return f;
                }
            }, function(e, n) {
                if (e instanceof Pe) {
                    var t;
                    if (e.init instanceof ze) {
                        t = e.init;
                        e.init = t.body.pop();
                        t.body.push(e);
                    }
                    if (e.init instanceof Je) {
                        if (!t) {
                            t = pe(ze, e, {
                                body: [ e ]
                            });
                        }
                        t.body.splice(-1, 0, e.init);
                        e.init = null;
                    } else if (e.init instanceof Se) {
                        e.init = e.init.body;
                    } else if (L(e.init)) {
                        e.init = null;
                    }
                    return !t ? e : n ? we.splice(t.body) : t;
                } else if (e instanceof Re) {
                    if (!x || !b.option("loops")) return;
                    if (!(e.init instanceof ln)) return;
                    var i = e.init.definitions[0].name;
                    if (i.definition().id in A) return;
                    if (!L(e.body)) return;
                    z(i, "Dropping unused loop variable {name} [{file}:{line},{col}]", $(i));
                    var r = e.object.drop_side_effect_free(b);
                    if (r) {
                        De.warn("Side effects in object of for-in loop [{file}:{line},{col}]", $(i));
                        return pe(Se, e, {
                            body: r
                        });
                    }
                    return n ? we.skip : pe($e, e);
                } else if (e instanceof _n) {
                    if (e.expressions.length == 1) return e.expressions[0];
                }
            });
            O.push(b.parent());
            y.transform(O);
            if (y instanceof Le && y.body.length == 1 && y.body[0] instanceof Be && y.body[0].value == "use strict") {
                y.body.length = 0;
            }
            B.forEach(function(e) {
                e.name = null;
            });
            S.forEach(function(e) {
                Z(e, b, T);
            });
            function z(e, n, t) {
                De[e.unreferenced() ? "warn" : "info"](n, t);
            }
            function $(e) {
                return {
                    name: e.name,
                    file: e.start.file,
                    line: e.start.line,
                    col: e.start.col
                };
            }
            function v(e, n) {
                if (!e.fixed) return;
                if (!e.assigns) return;
                if (te(n instanceof yn ? function(e) {
                    return e === n;
                } : function(e) {
                    if (e === n) return true;
                    if (e instanceof yn) return false;
                    return ve(e) === ve(n);
                }, e.assigns)) {
                    k.add(e.id, n);
                }
            }
            function M(e, n) {
                if (!e.fixed) return;
                if (!e.assigns) return;
                var t = k.get(e.id);
                if (!t) return;
                if (t.length != e.assigns.length) return;
                var i = t.indexOf(n);
                if (i >= 0 || !u[e.id] || n.assigns && Ee(n.assigns, function(e) {
                    return e.write_only || e.operator == "=" || e instanceof hn;
                })) return i;
            }
            function _(e, n, t) {
                if (e.id in A) return;
                if (n && t) {
                    A[e.id] = true;
                    c.push(e);
                } else {
                    l[e.id] = n;
                    p[e.id] = t;
                }
            }
            function q(e) {
                var n = e.right;
                if (!e.write_only) return n;
                if (!(n instanceof En && _e[n.operator])) return n;
                var t = e.left;
                if (!(t instanceof jn) || t.name != n.left.name) return n;
                return n.right.has_side_effects(b) ? n : n.right;
            }
            function i(e, n, t) {
                if (e instanceof kn && e.left instanceof jn) {
                    var i = e.left.definition();
                    if (e.operator != "=") u[i.id] = true;
                    v(i, e);
                }
                if (e instanceof yn && e.expression instanceof jn) {
                    var i = e.expression.definition();
                    u[i.id] = true;
                    v(i, e);
                }
                var i, r = [], o = E(e, r);
                if (o && y.variables.get(o.name) === (i = o.definition())) {
                    r.forEach(function(e) {
                        e.walk(d);
                    });
                    if (e instanceof kn) {
                        if (e.write_only === "p" && e.right.may_throw_on_access(b)) return;
                        var a = q(e);
                        if (t && e.write_only === true && i.scope === y && !a.has_side_effects(b)) {
                            h.add(i.id, a);
                        } else {
                            a.walk(d);
                        }
                        if (e.left === o) {
                            if (!e.write_only) {
                                _(i, true, p[i.id]);
                            }
                        } else {
                            var s = o.fixed_value();
                            if (!s || !s.is_constant()) {
                                _(i, l[i.id], true);
                            }
                        }
                    }
                    return true;
                }
                if (e instanceof jn) {
                    i = e.definition();
                    if (!(i.id in A)) {
                        A[i.id] = true;
                        c.push(i);
                    }
                    return true;
                }
                if (e instanceof Ue) {
                    var f = F;
                    F = e;
                    n();
                    F = f;
                    return true;
                }
            }
        });
        Ue.DEFMETHOD("hoist_declarations", function(r) {
            if (r.has_directive("use asm")) return;
            var o = r.option("hoist_funs");
            var a = r.option("hoist_vars");
            var s = this;
            if (a) {
                var n = 0;
                s.walk(new Kn(function(e) {
                    if (n > 1) return true;
                    if (e instanceof Ue && e !== s) return true;
                    if (e instanceof pn) {
                        n++;
                        return true;
                    }
                }));
                if (n <= 1) a = false;
            }
            if (!o && !a) return;
            var f = [];
            var u = [];
            var c = new Ae(), l = 0;
            var p = new at(function(e) {
                if (e === s) return;
                if (e instanceof Be) {
                    f.push(e);
                    return pe($e, e);
                }
                if (o && e instanceof Je && (p.parent() === s || !r.has_directive("use strict"))) {
                    u.push(e);
                    return pe($e, e);
                }
                if (a && e instanceof pn) {
                    e.definitions.forEach(function(e) {
                        c.set(e.name.name, e);
                        ++l;
                    });
                    var n = e.to_assignments(r);
                    var t = p.parent();
                    if (t instanceof Re && t.init === e) {
                        if (n) return n;
                        var i = e.definitions[0].name;
                        return pe(jn, i, i);
                    }
                    if (t instanceof Pe && t.init === e) return n;
                    if (!n) return pe($e, e);
                    return pe(Se, e, {
                        body: n
                    });
                }
                if (e instanceof Ue) return e;
            });
            s.transform(p);
            if (l > 0) {
                var t = [];
                c.each(function(e, n) {
                    if (s instanceof Le && !Ee(s.argnames, function(e) {
                        return e.name != n;
                    })) {
                        c.del(n);
                    } else {
                        e = e.clone();
                        e.value = null;
                        t.push(e);
                        c.set(n, e);
                    }
                });
                if (t.length > 0) {
                    for (var e = 0; e < s.body.length; ) {
                        if (s.body[e] instanceof Se) {
                            var i = s.body[e].body, h, d;
                            if (i instanceof kn && i.operator == "=" && (h = i.left) instanceof Sn && c.has(h.name)) {
                                var v = c.get(h.name);
                                if (v.value) break;
                                v.value = i.right;
                                xe(t, v);
                                t.push(v);
                                s.body.splice(e, 1);
                                continue;
                            }
                            if (i instanceof _n && (d = i.expressions[0]) instanceof kn && d.operator == "=" && (h = d.left) instanceof Sn && c.has(h.name)) {
                                var v = c.get(h.name);
                                if (v.value) break;
                                v.value = d.right;
                                xe(t, v);
                                t.push(v);
                                s.body[e].body = U(i, i.expressions.slice(1));
                                continue;
                            }
                        }
                        if (s.body[e] instanceof $e) {
                            s.body.splice(e, 1);
                            continue;
                        }
                        if (s.body[e] instanceof ze) {
                            var _ = [ e, 1 ].concat(s.body[e].body);
                            s.body.splice.apply(s.body, _);
                            continue;
                        }
                        break;
                    }
                    t = pe(pn, s, {
                        definitions: t
                    });
                    u.push(t);
                }
            }
            s.body = f.concat(u, s.body);
        });
        function u(n, t) {
            n.walk(new Kn(function(e) {
                if (e instanceof Ke) {
                    t(e);
                    return true;
                }
                if (e instanceof Ue && e !== n) return true;
            }));
        }
        function p(e) {
            var i = Object.create(null);
            u(e, function(e) {
                var n = e.value;
                if (n) n = n.tail_node();
                if (n instanceof jn) {
                    var t = n.definition().id;
                    i[t] = (i[t] || 0) + 1;
                }
            });
            return i;
        }
        function h(e, n, t) {
            return e.bool_fn + (n[e.id] || 0) === e.references.length - e.replaced && !t.exposed(e);
        }
        function d(e, i) {
            u(e, function(e) {
                e.in_bool = true;
                var n = e.value;
                if (n) {
                    var t = n.is_truthy() || n.evaluate(i, true);
                    if (!t) {
                        n = n.drop_side_effect_free(i);
                        e.value = n ? U(e.value, [ n, pe(Rn, e.value, {
                            value: 0
                        }) ]) : null;
                    } else if (t && !(t instanceof De)) {
                        n = n.drop_side_effect_free(i);
                        e.value = n ? U(e.value, [ n, pe(Rn, e.value, {
                            value: 1
                        }) ]) : pe(Rn, e.value, {
                            value: 1
                        });
                    }
                }
            });
        }
        Ue.DEFMETHOD("process_boolean_returns", re);
        Je.DEFMETHOD("process_boolean_returns", function(e) {
            if (!e.option("booleans")) return;
            var n = p(this);
            if (!h(this.name.definition(), n, e)) return;
            d(this, e);
        });
        We.DEFMETHOD("process_boolean_returns", function(e) {
            if (!e.option("booleans")) return;
            var n = p(this);
            if (this.name && !h(this.name.definition(), n, e)) return;
            var t = e.parent();
            if (t instanceof kn) {
                if (t.operator != "=") return;
                var i = t.left;
                if (!(i instanceof jn)) return;
                if (!h(i.definition(), n, e)) return;
            } else if (t instanceof dn && t.expression !== this) {
                var r = t.expression;
                if (r instanceof jn) r = r.fixed_value();
                if (!(r instanceof Le)) return;
                if (r.uses_arguments || r.pinned()) return;
                var i = r.argnames[t.args.indexOf(this)];
                if (i && !h(i.definition(), n, e)) return;
            } else if (t.TYPE == "Call") {
                e.pop();
                var o = e.in_boolean_context();
                e.push(this);
                if (!o) return;
            } else return;
            d(this, e);
        });
        Ue.DEFMETHOD("var_names", function() {
            var t = this._var_names;
            if (!t) {
                this._var_names = t = Object.create(null);
                this.enclosed.forEach(function(e) {
                    t[e.name] = true;
                });
                this.variables.each(function(e, n) {
                    t[n] = true;
                });
            }
            return t;
        });
        Ue.DEFMETHOD("make_var_name", function(e) {
            var n = this.var_names();
            e = e.replace(/(?:^[^a-z_$]|[^a-z0-9_$])/gi, "_");
            var t = e;
            for (var i = 0; n[t]; i++) t = e + "$" + i;
            n[t] = true;
            return t;
        });
        Ue.DEFMETHOD("hoist_properties", function(e) {
            if (!e.option("hoist_props") || e.has_directive("use asm")) return;
            var f = this;
            var r = f instanceof Ye && e.top_retain || ye;
            var u = Object.create(null);
            f.transform(new at(function(i, e) {
                if (i instanceof kn) {
                    if (i.operator != "=") return;
                    if (!i.write_only) return;
                    if (i.left.scope !== f) return;
                    if (!t(i.left, i.right, 1)) return;
                    e(i, this);
                    var r = new Ae();
                    var o = [];
                    var a = [];
                    i.right.properties.forEach(function(e) {
                        var n = s(i.left, e.key);
                        a.push(pe(hn, i, {
                            name: n,
                            value: null
                        }));
                        var t = pe(jn, i, {
                            name: n.name,
                            scope: f,
                            thedef: n.definition()
                        });
                        t.reference({});
                        o.push(pe(kn, i, {
                            operator: "=",
                            left: t,
                            right: e.value
                        }));
                    });
                    u[i.left.definition().id] = r;
                    f.body.splice(f.body.indexOf(this.stack[1]) + 1, 0, pe(pn, i, {
                        definitions: a
                    }));
                    return U(i, o);
                }
                if (i instanceof Ue) return i === f ? undefined : i;
                if (i instanceof hn) {
                    if (!t(i.name, i.value, 0)) return;
                    e(i, this);
                    var r = new Ae();
                    var n = [];
                    i.value.properties.forEach(function(e) {
                        n.push(pe(hn, i, {
                            name: s(i.name, e.key),
                            value: e.value
                        }));
                    });
                    u[i.name.definition().id] = r;
                    return we.splice(n);
                }
                function s(e, n) {
                    var t = pe(On, e, {
                        name: f.make_var_name(e.name + "_" + n),
                        scope: f
                    });
                    var i = f.def_variable(t);
                    r.set(n, i);
                    f.enclosed.push(i);
                    return t;
                }
            }));
            f.transform(new at(function(e, n) {
                if (e instanceof mn) {
                    if (!(e.expression instanceof jn)) return;
                    var t = u[e.expression.definition().id];
                    if (!t) return;
                    var i = t.get(e.getProperty());
                    var r = pe(jn, e, {
                        name: i.name,
                        scope: e.expression.scope,
                        thedef: i
                    });
                    r.reference({});
                    return r;
                }
                if (e instanceof yn) {
                    if (A[e.operator]) return;
                    if (!(e.expression instanceof jn)) return;
                    if (!(e.expression.definition().id in u)) return;
                    var o = e.clone();
                    o.expression = pe(Fn, e, {
                        properties: []
                    });
                    return o;
                }
            }));
            function t(e, n, t) {
                var i = e.definition();
                if (i.assignments != t) return;
                if (i.direct_access) return;
                if (i.escaped.depth == 1) return;
                if (i.references.length - i.replaced == t) return;
                if (i.single_use) return;
                if (r(i)) return;
                if (e.fixed_value() !== n) return;
                return n instanceof Fn && n.properties.length > 0 && Ee(n.properties, function(e) {
                    return e instanceof Bn;
                });
            }
        });
        function K(e, n) {
            if (!e.name || !n.option("ie8")) return true;
            var t = e.name.definition();
            if (n.exposed(t)) return false;
            return Ee(t.references, function(e) {
                return !(e instanceof jn);
            });
        }
        (function(e) {
            function s(e, n, t) {
                var i = e.length;
                if (!i) return null;
                var r = [], o = false;
                for (var a = 0; a < i; a++) {
                    var s = e[a].drop_side_effect_free(n, t);
                    o |= s !== e[a];
                    if (s) {
                        r.push(s);
                        t = false;
                    }
                }
                return o ? r.length ? r : null : e;
            }
            e(De, R);
            e(Ve, I);
            e(Dn, function(e, n) {
                var t = s(this.elements, e, n);
                return t && U(this, t);
            });
            e(kn, function(e) {
                var n = this.left;
                if (n instanceof mn) {
                    var t = n.expression;
                    if (t instanceof kn && t.operator == "=" && !t.may_throw_on_access(e)) {
                        t.write_only = "p";
                    }
                    if (e.has_directive("use strict") && t.is_constant()) return this;
                }
                if (n.has_side_effects(e)) return this;
                this.write_only = true;
                if (de(n).is_constant_expression(e.find_parent(Ue))) {
                    return this.right.drop_side_effect_free(e);
                }
                return this;
            });
            e(En, function(e, n) {
                var t = this.right.drop_side_effect_free(e, n);
                if (!t) return this.left.drop_side_effect_free(e, n);
                if (_e[this.operator] && !(t instanceof We)) {
                    var i = this;
                    if (t !== i.right) {
                        i = this.clone();
                        i.right = t.drop_side_effect_free(e);
                    }
                    return (n ? a : k)(i, pe(En, this, {
                        operator: i.operator == "&&" ? "||" : "&&",
                        left: i.left.negate(e, n),
                        right: i.right
                    }));
                } else {
                    var r = this.left.drop_side_effect_free(e, n);
                    if (!r) return t;
                    return U(this, [ r, t.drop_side_effect_free(e) ]);
                }
            });
            e(dn, function(t, e) {
                if (!this.is_expr_pure(t)) {
                    var n = this.expression;
                    if (this.is_call_pure(t)) {
                        var i = this.args.slice();
                        i.unshift(n.expression);
                        i = s(i, t, e);
                        return i && U(this, i);
                    }
                    if (n instanceof We) {
                        if (n.name) {
                            var r = n.name.definition();
                            if (r.references.length > r.replaced) return this;
                        }
                        n.process_expression(false, function(e) {
                            var n = e.value && e.value.drop_side_effect_free(t, true);
                            return n ? pe(Se, e, {
                                body: n
                            }) : pe($e, e);
                        });
                        u(n, function(e) {
                            if (e.value) e.value = e.value.drop_side_effect_free(t);
                        });
                        return this.clone();
                    }
                    return this;
                }
                if (this.pure) De.warn("Dropping __PURE__ call [{file}:{line},{col}]", this.start);
                var o = s(this.args, t, e);
                return o && U(this, o);
            });
            e(An, function(e) {
                var n = this.consequent.drop_side_effect_free(e);
                var t = this.alternative.drop_side_effect_free(e);
                if (n === this.consequent && t === this.alternative) return this;
                var i;
                if (e.option("ie8")) {
                    i = [];
                    if (n instanceof We) {
                        i.push(n);
                        n = null;
                    }
                    if (t instanceof We) {
                        i.push(t);
                        t = null;
                    }
                }
                var r;
                if (!n) {
                    r = t ? pe(En, this, {
                        operator: "||",
                        left: this.condition,
                        right: t
                    }) : this.condition.drop_side_effect_free(e);
                } else if (!t) {
                    r = pe(En, this, {
                        operator: "&&",
                        left: this.condition,
                        right: n
                    });
                } else {
                    r = this.clone();
                    r.consequent = n;
                    r.alternative = t;
                }
                if (!e.option("ie8")) return r;
                if (r) i.push(r);
                return i.length == 0 ? null : U(this, i);
            });
            e(Nn, I);
            e(gn, function(e, n) {
                var t = this.expression;
                if (t.may_throw_on_access(e)) return this;
                return t.drop_side_effect_free(e, n);
            });
            e(We, function(e) {
                return K(this, e) ? null : this;
            });
            e(Fn, function(e, n) {
                var t = s(this.properties, e, n);
                return t && U(this, t);
            });
            e(Cn, function(e, n) {
                return this.value.drop_side_effect_free(e, n);
            });
            e(_n, function(e, n) {
                var t = s(this.expressions, e, n);
                if (!t) return null;
                var i = t.length - 1;
                var r, o, a;
                if (e.option("conditionals") && i > 0 && (r = t[i - 1]) instanceof kn && r.operator == "=" && (a = r.left) instanceof jn && (o = b(e, a.definition(), r.right, t[i]))) {
                    r = r.clone();
                    r.right = o;
                    t = t.slice(0, -2);
                    t.push(r);
                }
                return t === this.expressions ? this : U(this, t);
            });
            e(bn, function(e, n) {
                if (this.expression.may_throw_on_access(e)) return this;
                var t = this.expression.drop_side_effect_free(e, n);
                if (!t) return this.property.drop_side_effect_free(e, n);
                var i = this.property.drop_side_effect_free(e);
                if (!i) return t;
                return U(this, [ t, i ]);
            });
            e(jn, function(e) {
                if (!this.is_declared(e)) return this;
                this.definition().replaced++;
                return null;
            });
            e(Hn, I);
            e(yn, function(e, n) {
                if (A[this.operator]) {
                    this.write_only = !this.expression.has_side_effects(e);
                    return this;
                }
                if (this.operator == "typeof" && this.expression instanceof jn) {
                    this.expression.definition().replaced++;
                    return null;
                }
                var t = this.expression.drop_side_effect_free(e, n);
                if (n && t && V(t)) {
                    if (t === this.expression && this.operator == "!") return this;
                    return t.negate(e, n);
                }
                return t;
            });
        })(function(e, n) {
            e.DEFMETHOD("drop_side_effect_free", n);
        });
        e(Se, function(e, n) {
            if (n.option("side_effects")) {
                var t = e.body;
                var i = t.drop_side_effect_free(n, true);
                if (!i) {
                    De.warn("Dropping side-effect-free statement [{file}:{line},{col}]", e.start);
                    return pe($e, e);
                }
                if (i !== t) {
                    return pe(Se, e, {
                        body: i
                    });
                }
            }
            return e;
        });
        e(Ne, function(e, n) {
            return n.option("loops") ? pe(Pe, e, e).optimize(n) : e;
        });
        function S(n, e) {
            var t = false;
            var i = new Kn(function(e) {
                if (t || e instanceof Ue) return true;
                if (e instanceof Ze && i.loopcontrol_target(e) === n) {
                    return t = true;
                }
            });
            if (e instanceof Me) i.push(e);
            i.push(n);
            n.body.walk(i);
            return t;
        }
        e(He, function(e, n) {
            if (!n.option("loops")) return e;
            var t = e.condition.is_truthy() || e.condition.evaluate(n, true);
            if (!(t instanceof De)) {
                if (t) return pe(Pe, e, {
                    body: pe(ze, e.body, {
                        body: [ e.body, pe(Se, e.condition, {
                            body: e.condition
                        }) ]
                    })
                }).optimize(n);
                if (!S(e, n.parent())) {
                    return pe(ze, e.body, {
                        body: [ e.body, pe(Se, e.condition, {
                            body: e.condition
                        }) ]
                    }).optimize(n);
                }
            }
            if (e.body instanceof Se) return pe(Pe, e, {
                condition: U(e.condition, [ e.body.body, e.condition ]),
                body: pe($e, e)
            }).optimize(n);
            return e;
        });
        function v(n, t) {
            var e = a(n.body);
            if (t.option("dead_code") && (e instanceof en || e instanceof nn && s(e) || e instanceof Xe)) {
                var i = [];
                if (n.init instanceof Fe) {
                    i.push(n.init);
                } else if (n.init) {
                    i.push(pe(Se, n.init, {
                        body: n.init
                    }));
                }
                var r = s(e) || e instanceof Xe;
                if (n.condition && r) {
                    i.push(pe(tn, n, {
                        condition: n.condition,
                        body: e,
                        alternative: null
                    }));
                } else if (n.condition) {
                    i.push(pe(Se, n.condition, {
                        body: n.condition
                    }));
                } else if (r) {
                    i.push(e);
                }
                w(n.body, i);
                return pe(ze, n, {
                    body: i
                });
            }
            if (e instanceof tn) {
                var o = a(e.body);
                if (o instanceof en && !s(o)) {
                    if (n.condition) {
                        n.condition = pe(En, n.condition, {
                            left: n.condition,
                            operator: "&&",
                            right: e.condition.negate(t)
                        });
                    } else {
                        n.condition = e.condition.negate(t);
                    }
                    var i = D(e.alternative);
                    w(e.body, i);
                    return f(i);
                }
                o = a(e.alternative);
                if (o instanceof en && !s(o)) {
                    if (n.condition) {
                        n.condition = pe(En, n.condition, {
                            left: n.condition,
                            operator: "&&",
                            right: e.condition
                        });
                    } else {
                        n.condition = e.condition;
                    }
                    var i = D(e.body);
                    w(e.alternative, i);
                    return f(i);
                }
            }
            return n;
            function a(e) {
                return e instanceof ze ? e.body[0] : e;
            }
            function s(e) {
                return t.loopcontrol_target(e) !== t.self();
            }
            function f(e) {
                if (n.body instanceof ze) {
                    n.body = n.body.clone();
                    n.body.body = e.concat(n.body.body.slice(1));
                    n.body = n.body.transform(t);
                } else {
                    n.body = pe(ze, n.body, {
                        body: e
                    }).transform(t);
                }
                return v(n, t);
            }
        }
        e(Pe, function(e, n) {
            if (!n.option("loops")) return e;
            if (n.option("side_effects")) {
                if (e.init) e.init = e.init.drop_side_effect_free(n);
                if (e.step) e.step = e.step.drop_side_effect_free(n);
            }
            if (e.condition) {
                var t = e.condition.evaluate(n);
                if (t instanceof De) {
                    t = e.condition.is_truthy() || e.condition.evaluate(n, true);
                } else if (t) {
                    e.condition = null;
                } else if (!n.option("dead_code")) {
                    var i = e.condition;
                    e.condition = E(t, e.condition);
                    e.condition = k(e.condition.transform(n), i);
                }
                if (!t) {
                    if (n.option("dead_code")) {
                        var r = [];
                        w(e.body, r);
                        if (e.init instanceof Fe) {
                            r.push(e.init);
                        } else if (e.init) {
                            r.push(pe(Se, e.init, {
                                body: e.init
                            }));
                        }
                        r.push(pe(Se, e.condition, {
                            body: e.condition
                        }));
                        return pe(ze, e, {
                            body: r
                        }).optimize(n);
                    }
                } else if (e.condition && !(t instanceof De)) {
                    e.body = pe(ze, e.body, {
                        body: [ pe(Se, e.condition, {
                            body: e.condition
                        }), e.body ]
                    });
                    e.condition = null;
                }
            }
            return v(e, n);
        });
        function T(e, n, t) {
            if (!(e instanceof En)) return;
            if (!(e.left instanceof Pn)) {
                switch (e.operator) {
                  case "&&":
                    T(e.left, n);
                    T(e.right, n);
                    break;

                  case "||":
                    T(f(e.left), t);
                    T(f(e.right), t);
                    break;
                }
                return;
            }
            if (!(e.right instanceof wn)) return;
            if (e.right.operator != "typeof") return;
            var i = e.right.expression;
            if (!W(i)) return;
            var r;
            var o = e.left.value == "undefined";
            switch (e.operator) {
              case "==":
                r = o ? t : n;
                break;

              case "!=":
                r = o ? n : t;
                break;

              default:
                return;
            }
            if (!r) return;
            var a = i.definition();
            var s = new Kn(function(e) {
                if (e instanceof Ue) {
                    var n = s.parent();
                    if (n instanceof dn && n.expression === e) return;
                    return true;
                }
                if (e instanceof jn && e.definition() === a) e.defined = true;
            });
            r.walk(s);
            function f(e) {
                if (!(e instanceof En)) return;
                switch (e.operator) {
                  case "==":
                    e = e.clone();
                    e.operator = "!=";
                    return e;

                  case "!=":
                    e = e.clone();
                    e.operator = "==";
                    return e;
                }
            }
        }
        e(tn, function(e, f) {
            if (L(e.alternative)) e.alternative = null;
            if (!f.option("conditionals")) return e;
            var n = e.condition.evaluate(f);
            if (!f.option("dead_code") && !(n instanceof De)) {
                var t = e.condition;
                e.condition = E(n, t);
                e.condition = k(e.condition.transform(f), t);
            }
            if (f.option("dead_code")) {
                if (n instanceof De) {
                    n = e.condition.is_truthy() || e.condition.evaluate(f, true);
                }
                if (!n) {
                    De.warn("Condition always false [{file}:{line},{col}]", e.condition.start);
                    var i = [];
                    w(e.body, i);
                    i.push(pe(Se, e.condition, {
                        body: e.condition
                    }));
                    if (e.alternative) i.push(e.alternative);
                    return pe(ze, e, {
                        body: i
                    }).optimize(f);
                } else if (!(n instanceof De)) {
                    De.warn("Condition always true [{file}:{line},{col}]", e.condition.start);
                    var i = [];
                    if (e.alternative) w(e.alternative, i);
                    i.push(pe(Se, e.condition, {
                        body: e.condition
                    }));
                    i.push(e.body);
                    return pe(ze, e, {
                        body: i
                    }).optimize(f);
                }
            }
            var r = e.condition.negate(f);
            var o = e.condition.print_to_string().length;
            var a = r.print_to_string().length;
            var s = a < o;
            if (e.alternative && s) {
                s = false;
                e.condition = r;
                var u = e.body;
                e.body = e.alternative || pe($e, e);
                e.alternative = u;
            }
            var i = [], c = [], l = [];
            var p = _(e.body, i, c, l);
            var h = _(e.alternative, i, c, l);
            if (p && h) {
                if (c.length > 0) i.push(pe(pn, e, {
                    definitions: c
                }));
                if (p.length == 0) {
                    i.push(pe(Se, e.condition, {
                        body: h.length > 0 ? pe(En, e, {
                            operator: "||",
                            left: e.condition,
                            right: U(e.alternative, h)
                        }).transform(f) : e.condition.clone()
                    }).optimize(f));
                } else if (h.length == 0) {
                    if (o === a && !s && e.condition instanceof En && e.condition.operator == "||") {
                        s = true;
                    }
                    i.push(pe(Se, e, {
                        body: pe(En, e, {
                            operator: s ? "||" : "&&",
                            left: s ? r : e.condition,
                            right: U(e.body, p)
                        }).transform(f)
                    }).optimize(f));
                } else {
                    i.push(pe(Se, e, {
                        body: pe(An, e, {
                            condition: e.condition,
                            consequent: U(e.body, p),
                            alternative: U(e.alternative, h)
                        })
                    }).optimize(f));
                }
                l.forEach(function(e) {
                    e.definition().references.push(e);
                });
                return pe(ze, e, {
                    body: i
                }).optimize(f);
            }
            if (L(e.body)) {
                e = pe(tn, e, {
                    condition: r,
                    body: e.alternative,
                    alternative: null
                });
            }
            if (e.body instanceof Xe && e.alternative instanceof Xe && e.body.TYPE == e.alternative.TYPE) {
                var d = pe(e.body.CTOR, e, {
                    value: pe(An, e, {
                        condition: e.condition,
                        consequent: e.body.value || pe(Ln, e.body).transform(f),
                        alternative: e.alternative.value || pe(Ln, e.alternative).transform(f)
                    })
                });
                if (d instanceof Ke) {
                    d.in_bool = e.body.in_bool || e.alternative.in_bool;
                }
                return d;
            }
            if (e.body instanceof tn && !e.body.alternative && !e.alternative) {
                e = pe(tn, e, {
                    condition: pe(En, e.condition, {
                        operator: "&&",
                        left: e.condition,
                        right: e.body.condition
                    }),
                    body: e.body.body,
                    alternative: null
                });
            }
            if (C(e.body)) {
                if (e.alternative) {
                    var v = e.alternative;
                    e.alternative = null;
                    return pe(ze, e, {
                        body: [ e, v ]
                    }).optimize(f);
                }
            }
            if (C(e.alternative)) {
                var i = e.body;
                e.body = e.alternative;
                e.condition = s ? r : e.condition.negate(f);
                e.alternative = null;
                return pe(ze, e, {
                    body: [ e, i ]
                }).optimize(f);
            }
            if (f.option("typeofs")) T(e.condition, e.body, e.alternative);
            return e;
            function _(e, n, t, i) {
                if (e == null) return [];
                if (e instanceof ze) {
                    var r = [];
                    for (var o = 0; o < e.body.length; o++) {
                        var a = e.body[o];
                        if (a instanceof Je) {
                            n.push(a);
                        } else if (a instanceof $e) {
                            continue;
                        } else if (a instanceof Se) {
                            if (!f.option("sequences") && r.length > 0) return;
                            r.push(a.body);
                        } else if (a instanceof pn) {
                            if (!f.option("sequences") && r.length > 0) return;
                            a.definitions.forEach(s);
                        } else {
                            return;
                        }
                    }
                    return r;
                }
                if (e instanceof Je) {
                    n.push(e);
                    return [];
                }
                if (e instanceof $e) return [];
                if (e instanceof Se) return [ e.body ];
                if (e instanceof pn) {
                    var r = [];
                    e.definitions.forEach(s);
                    return r;
                }
                function s(e) {
                    t.push(pe(hn, e, {
                        name: e.name,
                        value: null
                    }));
                    if (!e.value) return;
                    var n = pe(jn, e.name, e.name);
                    r.push(pe(kn, e, {
                        operator: "=",
                        left: n,
                        right: e.value
                    }));
                    i.push(n);
                }
            }
        });
        e(rn, function(t, e) {
            if (!e.option("switches")) return t;
            var n;
            var i = t.expression.evaluate(e);
            if (!(i instanceof De)) {
                var r = t.expression;
                t.expression = E(i, r);
                t.expression = k(t.expression.transform(e), r);
            }
            if (!e.option("dead_code")) return t;
            if (i instanceof De) {
                i = t.expression.evaluate(e, true);
            }
            var o = [];
            var a = [];
            var s;
            var f;
            for (var u = 0, c = t.body.length; u < c && !f; u++) {
                n = t.body[u];
                if (n instanceof an) {
                    var l = a[a.length - 1];
                    if (s || g(n.body[0], e) && (!l || C(l))) {
                        b(n, l);
                        continue;
                    } else {
                        s = n;
                    }
                } else if (!(i instanceof De)) {
                    var p = n.expression.evaluate(e);
                    if (!(p instanceof De) && p !== i) {
                        b(n, a[a.length - 1]);
                        continue;
                    }
                    if (p instanceof De) p = n.expression.evaluate(e, true);
                    if (p === i) {
                        f = n;
                        if (s) {
                            var h = a.indexOf(s);
                            a.splice(h, 1);
                            b(s, a[h - 1]);
                            s = null;
                        }
                    }
                }
                if (C(n)) {
                    var l = a[a.length - 1];
                    if (C(l) && l.body.length == n.body.length && pe(ze, l, l).equivalent_to(pe(ze, n, n))) {
                        l.body = [];
                    }
                }
                a.push(n);
            }
            while (u < c) b(t.body[u++], a[a.length - 1]);
            while (n = a[a.length - 1]) {
                var d = n.body[n.body.length - 1];
                if (g(d, e)) n.body.pop();
                if (n === s) {
                    if (!y(n)) break;
                } else if (n.expression.has_side_effects(e)) {
                    break;
                } else if (s) {
                    if (!y(s)) break;
                    if (a[a.length - 2] !== s) break;
                    s.body = s.body.concat(n.body);
                    n.body = [];
                } else if (!y(n)) break;
                b(n);
                if (a.pop() === s) s = null;
            }
            if (a.length == 0) {
                return pe(ze, t, {
                    body: o.concat(pe(Se, t.expression, {
                        body: t.expression
                    }))
                }).optimize(e);
            }
            a[0].body = o.concat(a[0].body);
            t.body = a;
            if (a.length == 1 && (a[0] === f || a[0] === s)) {
                var v = false;
                var _ = new Kn(function(e) {
                    if (v || e instanceof Le || e instanceof Se) return true;
                    if (g(e, _)) v = true;
                });
                t.walk(_);
                if (!v) {
                    var m = a[0].body.slice();
                    var p = a[0].expression;
                    if (p) m.unshift(pe(Se, p, {
                        body: p
                    }));
                    m.unshift(pe(Se, t.expression, {
                        body: t.expression
                    }));
                    return pe(ze, t, {
                        body: m
                    }).optimize(e);
                }
            }
            return t;
            function g(e, n) {
                return e instanceof en && n.loopcontrol_target(e) === t;
            }
            function b(e, n) {
                if (n && !C(n)) {
                    n.body = n.body.concat(e.body);
                } else {
                    w(e, o);
                }
            }
        });
        e(fn, function(e, n) {
            e.body = c(e.body, n);
            if (n.option("dead_code")) {
                if (y(e)) {
                    var t = [];
                    if (e.bcatch) {
                        w(e.bcatch, t);
                        t.forEach(function(e) {
                            if (!(e instanceof ln)) return;
                            e.definitions.forEach(function(e) {
                                var n = e.name.definition().redefined();
                                if (!n) return;
                                e.name = e.name.clone();
                                e.name.thedef = n;
                            });
                        });
                    }
                    [].unshift.apply(t, e.body);
                    if (e.bfinally) [].push.apply(t, e.bfinally.body);
                    return pe(ze, e, {
                        body: t
                    }).optimize(n);
                }
                if (e.bfinally && y(e.bfinally)) {
                    var t = e.body.concat(e.bfinally.body);
                    if (!e.bcatch) return pe(ze, e, {
                        body: t
                    }).optimize(n);
                    e.body = t;
                    e.bfinally = null;
                }
            }
            return e;
        });
        ln.DEFMETHOD("remove_initializers", function() {
            this.definitions.forEach(function(e) {
                e.value = null;
            });
        });
        ln.DEFMETHOD("to_assignments", function(e) {
            var i = e.option("reduce_vars");
            var n = this.definitions.reduce(function(e, n) {
                if (n.value) {
                    var t = pe(jn, n.name, n.name);
                    e.push(pe(kn, n, {
                        operator: "=",
                        left: t,
                        right: n.value
                    }));
                    if (i) t.definition().fixed = false;
                }
                n = n.name.definition();
                n.eliminated++;
                n.replaced--;
                return e;
            }, []);
            if (n.length == 0) return null;
            return U(this, n);
        });
        e(ln, function(e, n) {
            return e.definitions.length ? e : pe($e, e);
        });
        function Q(e, n) {
            var t = e.expression;
            if (!(t instanceof _n)) return e;
            var i = t.expressions.slice();
            var r = e.clone();
            r.expression = i.pop();
            i.push(r);
            return U(e, i);
        }
        function Z(e, n, t) {
            var i = e.expression;
            var r = i instanceof jn ? i.fixed_value() : i;
            if (!(r instanceof Le)) return;
            if (r.uses_arguments) return;
            if (r.pinned()) return;
            if (t && t.indexOf(r) < 0) return;
            var o = e.args;
            var a = 0, s = 0;
            var f = r === i && !r.name && n.drop_fargs(r, e);
            var u = [];
            for (var c = 0; c < o.length; c++) {
                var l = c >= r.argnames.length;
                if (l || r.argnames[c].__unused) {
                    var p = o[c].drop_side_effect_free(n);
                    if (f) {
                        r.argnames.splice(c, 1);
                        o.splice(c, 1);
                        if (p) u.push(p);
                        c--;
                        continue;
                    } else if (p) {
                        u.push(p);
                        o[a++] = U(e, u);
                        u = [];
                    } else if (!l) {
                        if (u.length) {
                            p = U(e, u);
                            u = [];
                        } else {
                            p = pe(Rn, o[c], {
                                value: 0
                            });
                        }
                        o[a++] = p;
                        continue;
                    }
                } else {
                    u.push(o[c]);
                    o[a++] = U(e, u);
                    u = [];
                }
                s = a;
            }
            if (f) for (;c < r.argnames.length; c++) {
                if (r.argnames[c].__unused) r.argnames.splice(c--, 1);
            }
            o.length = s;
            if (!u.length) return;
            var h = U(e, u);
            o.push(o.length < r.argnames.length ? pe(wn, e, {
                operator: "void",
                expression: h
            }) : h);
        }
        e(dn, function(s, f) {
            var o = s.expression;
            if (f.option("sequences")) {
                if (o instanceof mn) {
                    var e = Q(o, f);
                    if (e !== o) {
                        var n = s.clone();
                        n.expression = e.expressions.pop();
                        e.expressions.push(n);
                        return e.optimize(f);
                    }
                } else if (!Y(f, o.tail_node())) {
                    var e = Q(s, f);
                    if (e !== s) return e.optimize(f);
                }
            }
            if (f.option("unused")) Z(s, f);
            if (f.option("unsafe")) {
                if (W(o)) switch (o.name) {
                  case "Array":
                    if (s.args.length == 1) {
                        var t = s.args[0];
                        if (t instanceof Rn) try {
                            var i = t.value;
                            if (i > 6) break;
                            var r = Array(i);
                            for (var a = 0; a < i; a++) r[a] = pe(Vn, s);
                            return pe(Dn, s, {
                                elements: r
                            });
                        } catch (e) {
                            De.warn("Invalid array length: {length} [{file}:{line},{col}]", {
                                length: i,
                                file: s.start.file,
                                line: s.start.line,
                                col: s.start.col
                            });
                            break;
                        }
                        if (!t.is_boolean(f) && !t.is_string(f)) break;
                    }
                    return pe(Dn, s, {
                        elements: s.args
                    });

                  case "Object":
                    if (s.args.length == 0) {
                        return pe(Fn, s, {
                            properties: []
                        });
                    }
                    break;

                  case "String":
                    if (s.args.length == 0) return pe(Pn, s, {
                        value: ""
                    });
                    if (s.args.length <= 1) return pe(En, s, {
                        left: s.args[0],
                        operator: "+",
                        right: pe(Pn, s, {
                            value: ""
                        })
                    }).optimize(f);
                    break;

                  case "Number":
                    if (s.args.length == 0) return pe(Rn, s, {
                        value: 0
                    });
                    if (s.args.length == 1) return pe(wn, s, {
                        expression: s.args[0],
                        operator: "+"
                    }).optimize(f);

                  case "Boolean":
                    if (s.args.length == 0) return pe(Gn, s);
                    if (s.args.length == 1) return pe(wn, s, {
                        expression: pe(wn, s, {
                            expression: s.args[0],
                            operator: "!"
                        }),
                        operator: "!"
                    }).optimize(f);
                    break;

                  case "RegExp":
                    var u = [];
                    if (Ee(s.args, function(e) {
                        var n = e.evaluate(f);
                        u.unshift(n);
                        return e !== n;
                    })) {
                        try {
                            return G(f, s, pe(In, s, {
                                value: RegExp.apply(RegExp, u)
                            }));
                        } catch (e) {
                            De.warn("Error converting {expr} [{file}:{line},{col}]", {
                                expr: s.print_to_string(),
                                file: s.start.file,
                                line: s.start.line,
                                col: s.start.col
                            });
                        }
                    }
                    break;
                } else if (o instanceof gn) switch (o.property) {
                  case "toString":
                    if (s.args.length == 0 && !o.expression.may_throw_on_access(f)) {
                        return pe(En, s, {
                            left: pe(Pn, s, {
                                value: ""
                            }),
                            operator: "+",
                            right: o.expression
                        }).optimize(f);
                    }
                    break;

                  case "join":
                    if (o.expression instanceof Dn) e: {
                        var c;
                        if (s.args.length > 0) {
                            c = s.args[0].evaluate(f);
                            if (c === s.args[0]) break e;
                        }
                        var r = [];
                        var l = [];
                        o.expression.elements.forEach(function(e) {
                            var n = e.evaluate(f);
                            if (n !== e) {
                                l.push(n);
                            } else {
                                if (l.length > 0) {
                                    r.push(pe(Pn, s, {
                                        value: l.join(c)
                                    }));
                                    l.length = 0;
                                }
                                r.push(e);
                            }
                        });
                        if (l.length > 0) {
                            r.push(pe(Pn, s, {
                                value: l.join(c)
                            }));
                        }
                        if (r.length == 0) return pe(Pn, s, {
                            value: ""
                        });
                        if (r.length == 1) {
                            if (r[0].is_string(f)) {
                                return r[0];
                            }
                            return pe(En, r[0], {
                                operator: "+",
                                left: pe(Pn, s, {
                                    value: ""
                                }),
                                right: r[0]
                            });
                        }
                        if (c == "") {
                            var t;
                            if (r[0].is_string(f) || r[1].is_string(f)) {
                                t = r.shift();
                            } else {
                                t = pe(Pn, s, {
                                    value: ""
                                });
                            }
                            return r.reduce(function(e, n) {
                                return pe(En, n, {
                                    operator: "+",
                                    left: e,
                                    right: n
                                });
                            }, t).optimize(f);
                        }
                        var p = s.clone();
                        p.expression = p.expression.clone();
                        p.expression.expression = p.expression.expression.clone();
                        p.expression.expression.elements = r;
                        return G(f, s, p);
                    }
                    break;

                  case "charAt":
                    if (s.args.length < 2) {
                        var p = pe(bn, s, {
                            expression: o.expression,
                            property: s.args.length ? pe(En, s.args[0], {
                                operator: "|",
                                left: pe(Rn, s, {
                                    value: 0
                                }),
                                right: s.args[0]
                            }) : pe(Rn, s, {
                                value: 0
                            })
                        });
                        p.is_string = oe;
                        return p.optimize(f);
                    }
                    break;

                  case "apply":
                    if (s.args.length == 2 && s.args[1] instanceof Dn) {
                        var h = s.args[1].elements.slice();
                        h.unshift(s.args[0]);
                        return pe(dn, s, {
                            expression: pe(gn, o, {
                                expression: o.expression,
                                property: "call"
                            }),
                            args: h
                        }).optimize(f);
                    }
                    break;

                  case "call":
                    var d = o.expression;
                    if (d instanceof jn) {
                        d = d.fixed_value();
                    }
                    if (d instanceof Le && !d.contains_this()) {
                        return (s.args.length ? U(this, [ s.args[0], pe(dn, s, {
                            expression: o.expression,
                            args: s.args.slice(1)
                        }) ]) : pe(dn, s, {
                            expression: o.expression,
                            args: []
                        })).optimize(f);
                    }
                    break;
                }
            }
            if (f.option("unsafe_Function") && W(o) && o.name == "Function") {
                if (s.args.length == 0) return pe(We, s, {
                    argnames: [],
                    body: []
                });
                if (Ee(s.args, function(e) {
                    return e instanceof Pn;
                })) {
                    try {
                        var v = "n(function(" + s.args.slice(0, -1).map(function(e) {
                            return e.value;
                        }).join(",") + "){" + s.args[s.args.length - 1].value + "})";
                        var _ = ot(v);
                        var m = {
                            ie8: f.option("ie8")
                        };
                        _.figure_out_scope(m);
                        var g = new ut(f.options);
                        _ = _.transform(g);
                        _.figure_out_scope(m);
                        _.compute_char_frequency(m);
                        _.mangle_names(m);
                        var b;
                        _.walk(new Kn(function(e) {
                            if (b) return true;
                            if (e instanceof Le) {
                                b = e;
                                return true;
                            }
                        }));
                        var v = ft();
                        ze.prototype._codegen.call(b, b, v);
                        s.args = [ pe(Pn, s, {
                            value: b.argnames.map(function(e) {
                                return e.print_to_string();
                            }).join(",")
                        }), pe(Pn, s.args[s.args.length - 1], {
                            value: v.get().replace(/^\{|\}$/g, "")
                        }) ];
                        return s;
                    } catch (e) {
                        if (e instanceof Zn) {
                            De.warn("Error parsing code passed to new Function [{file}:{line},{col}]", s.args[s.args.length - 1].start);
                            De.warn(e.toString());
                        } else {
                            throw e;
                        }
                    }
                }
            }
            var y = o instanceof jn ? o.fixed_value() : o;
            var w = y instanceof Le;
            var x = w && y.first_statement();
            var E = f.option("inline") && !s.is_expr_pure(f);
            if (E && x instanceof Ke) {
                var A = x.value;
                if (o === y && (!A || A.is_constant_expression())) {
                    var h = s.args.concat(A || pe(Ln, s));
                    return U(s, h).optimize(f);
                }
            }
            if (w) {
                var k, A, D = false;
                if (E && !y.uses_arguments && !y.pinned() && !(y.name && y instanceof We) && (o === y || !ee(f, k = o.definition()) && y.is_constant_expression(o.scope)) && (A = O(x)) && !y.contains_this()) {
                    if ($()) {
                        var h = s.args.slice();
                        h.push(A.clone(true).transform(new at(function(e) {
                            if (e instanceof jn) {
                                var n = e.definition();
                                if (y.variables.get(e.name) !== n) {
                                    if (o !== y) n.references.push(e);
                                    return e;
                                }
                                var t = z(n);
                                var i = h[t];
                                if (!i) return pe(Ln, s);
                                h[t] = null;
                                var r = this.parent();
                                return r ? he(f, r, e, i) : i;
                            }
                        })));
                        var p = U(s, h.filter(function(e) {
                            return e;
                        })).optimize(f);
                        p = he(f, f.parent(), f.self(), p);
                        if (G(f, s, p) === p) return p;
                    }
                    var F, C, B = -1;
                    if ((o === y || f.option("unused") && k.references.length - k.replaced == 1) && H()) {
                        y._squeezed = true;
                        if (o !== y) y.parent_scope = o.scope;
                        var p = U(s, I()).optimize(f);
                        return he(f, f.parent(), f.self(), p);
                    }
                }
                if (f.option("side_effects") && Ee(y.body, L) && (y !== o || K(y, f))) {
                    var h = s.args.concat(pe(Ln, s));
                    return U(s, h).optimize(f);
                }
            }
            if (f.option("drop_console")) {
                if (o instanceof mn) {
                    var S = o.expression;
                    while (S.expression) {
                        S = S.expression;
                    }
                    if (W(S) && S.name == "console") {
                        return pe(Ln, s).optimize(f);
                    }
                }
            }
            if (f.option("negate_iife") && f.parent() instanceof Se && V(s)) {
                return s.negate(f, true);
            }
            return X(f, s);
            function T(e) {
                if (!e) return pe(Ln, s);
                if (e instanceof Ke) {
                    if (!e.value) return pe(Ln, s);
                    return e.value.clone(true);
                }
                if (e instanceof Se) {
                    return pe(wn, e, {
                        operator: "void",
                        expression: e.body
                    });
                }
            }
            function O(e) {
                var n = y.body.length;
                if (f.option("inline") < 3) {
                    return n == 1 && T(e);
                }
                e = null;
                for (var t = 0; t < n; t++) {
                    var i = y.body[t];
                    if (i instanceof pn) {
                        var r = D || !Ee(i.definitions, function(e) {
                            return !e.value;
                        });
                        if (r) {
                            D = true;
                            if (e) return false;
                        }
                    } else if (i instanceof Je || i instanceof $e) {
                        continue;
                    } else if (e) {
                        return false;
                    } else {
                        e = i;
                    }
                }
                return T(e);
            }
            function z(e) {
                for (var n = y.argnames.length; --n >= 0; ) {
                    if (y.argnames[n].definition() === e) return n;
                }
            }
            function $() {
                if (D) return;
                if (f.option("inline") < 2 && y.argnames.length) return;
                if (!y.variables.all(function(e) {
                    return e.references.length - e.replaced < 2 && e.orig[0] instanceof zn;
                })) return;
                var i = false;
                var r;
                var o = [];
                var a = false;
                A.walk(new Kn(function(e) {
                    if (i) return true;
                    if (e instanceof En && _e[e.operator] || e instanceof An) {
                        o = null;
                        return;
                    }
                    if (e instanceof Ue) return i = true;
                    if (e instanceof jn) {
                        var n = e.definition();
                        if (y.variables.get(e.name) !== n) {
                            o = null;
                            return;
                        }
                        if (n.init instanceof Je) return i = true;
                        if (ge(e, this.parent())) return i = true;
                        var t = z(n);
                        if (!(r < t)) r = t;
                        if (!o) return;
                        if (a) {
                            o = null;
                        } else {
                            o.push(y.argnames[t]);
                        }
                        return;
                    }
                    if (e.has_side_effects(f)) a = true;
                }));
                if (i) return;
                var e = s.args.length;
                if (o && y.argnames.length >= e) {
                    e = y.argnames.length;
                    while (e-- > r && y.argnames[e] === o.pop()) ;
                    e++;
                }
                var n = a && f.find_parent(Ue);
                return e <= r || Ee(s.args.slice(r, e), a ? function(e) {
                    return e.is_constant_expression(n);
                } : function(e) {
                    return !e.has_side_effects(f);
                });
            }
            function M(e, n) {
                return e[n] || J[n] || F.var_names()[n];
            }
            function q(e, n, t) {
                for (var i = 0; i < y.argnames.length; i++) {
                    var r = y.argnames[i];
                    if (r.__unused) continue;
                    if (!t || M(e, r.name)) return false;
                    n[r.name] = true;
                    if (C) C.push(r.definition());
                }
                return true;
            }
            function j(e, n, t) {
                for (var i = 0; i < y.body.length; i++) {
                    var r = y.body[i];
                    if (r instanceof Je) {
                        if (!t || M(n, r.name.name)) return false;
                        continue;
                    }
                    if (!(r instanceof pn)) continue;
                    if (!t) return false;
                    for (var o = r.definitions.length; --o >= 0; ) {
                        var a = r.definitions[o].name;
                        if (M(e, a.name)) return false;
                        if (C) C.push(a.definition());
                    }
                }
                return true;
            }
            function H() {
                var e = Object.create(null);
                var n;
                F = f.self();
                do {
                    n = F;
                    F = f.parent(++B);
                    if (F instanceof un) {
                        e[F.argname.name] = true;
                    } else if (F instanceof je) {
                        C = [];
                    } else if (F instanceof Pe) {
                        if (F.init === n) continue;
                        C = [];
                    } else if (F instanceof Re) {
                        if (F.init === n) continue;
                        if (F.object === n) continue;
                        C = [];
                    } else if (F instanceof jn) {
                        if (F.fixed_value() instanceof Ue) return false;
                    }
                } while (!(F instanceof Ue));
                var t = (!(F instanceof Ye) || f.toplevel.vars) && (o !== y || y.parent_scope === f.find_parent(Ue));
                var i = f.option("inline");
                var r = Object.create(e);
                if (!q(e, r, i >= 2 && t)) return false;
                if (!j(e, r, i >= 3 && t)) return false;
                return !C || C.length == 0 || !ne(y, C);
            }
            function N(e, n, t, i) {
                var r = t.definition();
                F.variables.set(t.name, r);
                F.enclosed.push(r);
                if (!F.var_names()[t.name]) {
                    F.var_names()[t.name] = true;
                    e.push(pe(hn, t, {
                        name: t,
                        value: null
                    }));
                }
                var o = pe(jn, t, t);
                r.references.push(o);
                if (i) n.push(pe(kn, s, {
                    operator: "=",
                    left: o,
                    right: i
                }));
            }
            function P(e, n) {
                var t = y.argnames.length;
                for (var i = s.args.length; --i >= t; ) {
                    n.push(s.args[i]);
                }
                for (i = t; --i >= 0; ) {
                    var r = y.argnames[i];
                    var o = s.args[i];
                    if (r.__unused || F.var_names()[r.name]) {
                        if (o) n.push(o);
                    } else {
                        var a = pe(On, r, r);
                        r.definition().orig.push(a);
                        if (!o && C) o = pe(Ln, s);
                        N(e, n, a, o);
                    }
                }
                e.reverse();
                n.reverse();
            }
            function R(e, n) {
                var t = n.length;
                for (var i = 0; i < y.body.length; i++) {
                    var r = y.body[i];
                    if (!(r instanceof pn)) continue;
                    for (var o = 0; o < r.definitions.length; o++) {
                        var a = r.definitions[o];
                        var s = a.name;
                        var f = s.definition().redefined();
                        if (f) {
                            s = s.clone();
                            s.thedef = f;
                        }
                        N(e, n, s, a.value);
                        if (C && Ee(y.argnames, function(e) {
                            return e.name != s.name;
                        })) {
                            var u = y.variables.get(s.name);
                            var c = pe(jn, s, s);
                            u.references.push(c);
                            n.splice(t++, 0, pe(kn, a, {
                                operator: "=",
                                left: c,
                                right: pe(Ln, s)
                            }));
                        }
                    }
                }
            }
            function I() {
                var e = [];
                var n = [];
                P(e, n);
                R(e, n);
                n.push(A);
                var t = y.body.filter(function(e) {
                    if (e instanceof Je) {
                        var n = e.name.definition();
                        F.functions.set(n.name, n);
                        F.variables.set(n.name, n);
                        F.enclosed.push(n);
                        F.var_names()[n.name] = true;
                        return true;
                    }
                });
                t.unshift(F.body.indexOf(f.parent(B - 1)) + 1, 0);
                if (e.length) t.push(pe(pn, y, {
                    definitions: e
                }));
                [].splice.apply(F.body, t);
                y.enclosed.forEach(function(e) {
                    if (F.var_names()[e.name]) return;
                    F.enclosed.push(e);
                    F.var_names()[e.name] = true;
                });
                return n;
            }
        });
        e(vn, function(e, n) {
            if (n.option("sequences")) {
                var t = Q(e, n);
                if (t !== e) return t.optimize(n);
            }
            if (n.option("unsafe")) {
                var i = e.expression;
                if (W(i)) {
                    switch (i.name) {
                      case "Object":
                      case "RegExp":
                      case "Function":
                      case "Error":
                      case "Array":
                        return pe(dn, e, e).transform(n);
                    }
                }
            }
            return e;
        });
        function b(t, i, e, n) {
            if (!(n instanceof En)) return;
            if (!_e[n.operator]) return;
            if (!(n.right instanceof kn)) return;
            if (n.right.operator != "=") return;
            if (!(n.right.left instanceof jn)) return;
            if (n.right.left.definition() !== i) return;
            if (e.has_side_effects(t)) return;
            if (!r(n.left)) return;
            if (!r(n.right.right)) return;
            i.replaced++;
            return n.operator == "&&" ? pe(An, n, {
                condition: n.left,
                consequent: n.right.right,
                alternative: e
            }) : pe(An, n, {
                condition: n.left,
                consequent: e,
                alternative: n.right.right
            });
            function r(e) {
                if (e.has_side_effects(t)) return;
                var n = false;
                e.walk(new Kn(function(e) {
                    if (n) return true;
                    if (e instanceof jn && e.definition() === i) return n = true;
                }));
                return !n;
            }
        }
        e(_n, function(e, o) {
            var r = n();
            var a = r.length - 1;
            i();
            t();
            if (a == 0) {
                e = he(o, o.parent(), o.self(), r[0]);
                if (!(e instanceof _n)) e = e.optimize(o);
                return e;
            }
            e.expressions = r;
            return e;
            function n() {
                if (!o.option("side_effects")) return e.expressions;
                var t = [];
                var i = ke(o);
                var r = e.expressions.length - 1;
                e.expressions.forEach(function(e, n) {
                    if (n < r) e = e.drop_side_effect_free(o, i);
                    if (e) {
                        _(t, e);
                        i = false;
                    }
                });
                return t;
            }
            function t() {
                if (!o.option("side_effects")) return;
                while (a > 0 && B(r[a], o)) a--;
                if (a < r.length - 1) {
                    r[a] = pe(wn, e, {
                        operator: "void",
                        expression: r[a]
                    });
                    r.length = a + 1;
                }
            }
            function i() {
                if (!o.option("conditionals")) return;
                for (var e = 1; e < a; e++) {
                    var n = r[e - 1];
                    if (!(n instanceof kn)) continue;
                    if (n.operator != "=") continue;
                    if (!(n.left instanceof jn)) continue;
                    var t = n.left.definition();
                    var i = b(o, t, n.right, r[e]);
                    if (!i) continue;
                    n.right = i;
                    r.splice(e, 1);
                    a--;
                }
            }
        });
        e(xn, function(e, n) {
            if (n.option("sequences")) {
                var t = Q(e, n);
                if (t !== e) return t.optimize(n);
            }
            return e;
        });
        var O = se("+ -");
        var z = se("* / %");
        e(wn, function(e, n) {
            var t = e.expression;
            if (n.option("evaluate") && e.operator == "delete" && !(t instanceof jn || t instanceof mn || r(t))) {
                if (t instanceof _n) {
                    t = t.expressions.slice();
                    t.push(pe(Xn, e));
                    return U(e, t).optimize(n);
                }
                return U(e, [ t, pe(Xn, e) ]).optimize(n);
            }
            if (n.option("sequences")) {
                var i = Q(e, n);
                if (i !== e) return i.optimize(n);
            }
            if (n.option("side_effects") && e.operator == "void") {
                t = t.drop_side_effect_free(n);
                if (t) {
                    e.expression = t;
                    return e;
                } else {
                    return pe(Ln, e).optimize(n);
                }
            }
            if (n.option("booleans")) {
                if (e.operator == "!" && t.is_truthy()) {
                    return U(e, [ t, pe(Gn, e) ]).optimize(n);
                } else if (n.in_boolean_context()) switch (e.operator) {
                  case "!":
                    if (t instanceof wn && t.operator == "!") {
                        return t.expression;
                    }
                    if (t instanceof En) {
                        e = G(n, e, t.negate(n, ke(n)));
                    }
                    break;

                  case "typeof":
                    De.warn("Boolean expression always true [{file}:{line},{col}]", e.start);
                    return (t instanceof jn ? pe(Xn, e) : U(e, [ t, pe(Xn, e) ])).optimize(n);
                }
            }
            if (e.operator == "-" && t instanceof Wn) t = t.transform(n);
            if (n.option("evaluate") && t instanceof En && O[e.operator] && z[t.operator] && (t.left.is_constant() || !t.right.has_side_effects(n))) {
                return pe(En, e, {
                    operator: t.operator,
                    left: pe(wn, t.left, {
                        operator: e.operator,
                        expression: t.left
                    }),
                    right: t.right
                });
            }
            return e.operator == "-" && (t instanceof Rn || t instanceof Wn) ? e : X(n, e);
        });
        En.DEFMETHOD("lift_sequences", function(e) {
            if (this.left instanceof mn) {
                if (!(this.left.expression instanceof _n)) return this;
                var n = this.left.expression.expressions.slice();
                var t = this.clone();
                t.left = t.left.clone();
                t.left.expression = n.pop();
                n.push(t);
                return U(this, n);
            }
            if (this.left instanceof _n) {
                var n = this.left.expressions.slice();
                var t = this.clone();
                t.left = n.pop();
                n.push(t);
                return U(this, n);
            }
            if (this.right instanceof _n) {
                if (this.left.has_side_effects(e)) return this;
                var i = this.operator == "=" && this.left instanceof jn;
                var n = this.right.expressions;
                var r = n.length - 1;
                for (var o = 0; o < r; o++) {
                    if (!i && n[o].has_side_effects(e)) break;
                }
                if (o == r) {
                    n = n.slice();
                    var t = this.clone();
                    t.right = n.pop();
                    n.push(t);
                    return U(this, n);
                }
                if (o > 0) {
                    var t = this.clone();
                    t.right = U(this.right, n.slice(o));
                    n = n.slice(0, o);
                    n.push(t);
                    return U(this, n);
                }
            }
            return this;
        });
        var $ = se("indexOf lastIndexOf");
        var M = se("== === != !== * & | ^");
        function q(e) {
            return e instanceof Dn || e instanceof Le || e instanceof Fn;
        }
        e(En, function(t, a) {
            function i() {
                return t.left.is_constant() || t.right.is_constant() || !t.left.has_side_effects(a) && !t.right.has_side_effects(a);
            }
            function e(e) {
                if (i()) {
                    if (e) t.operator = e;
                    var n = t.left;
                    t.left = t.right;
                    t.right = n;
                }
            }
            function n() {
                var e = t.right;
                t.left = pe(En, t, {
                    operator: t.operator,
                    left: t.left,
                    right: e.left,
                    start: t.left.start,
                    end: e.left.end
                });
                t.right = e.right;
                t.left = t.left.transform(a);
            }
            if (M[t.operator] && t.right.is_constant() && !t.left.is_constant() && !(t.left instanceof En && it[t.left.operator] >= it[t.operator])) {
                e();
            }
            if (a.option("sequences")) {
                var r = t.lift_sequences(a);
                if (r !== t) return r.optimize(a);
            }
            if (a.option("assignments") && _e[t.operator]) {
                var o = t.right;
                if (t.left instanceof jn && o instanceof kn && o.operator == "=" && t.left.equivalent_to(o.left)) {
                    t.right = o.right;
                    o.right = t;
                    return o;
                }
            }
            if (a.option("comparisons")) switch (t.operator) {
              case "===":
              case "!==":
                if (B(t.left, a) && t.right.is_defined(a)) {
                    De.warn("Expression always defined [{file}:{line},{col}]", t.start);
                    return U(t, [ t.right, pe(t.operator == "===" ? Gn : Xn, t) ]).optimize(a);
                }
                var s = true;
                if (t.left.is_string(a) && t.right.is_string(a) || t.left.is_number(a) && t.right.is_number(a) || t.left.is_boolean(a) && t.right.is_boolean(a) || E(t.left) && t.left.equivalent_to(t.right)) {
                    t.operator = t.operator.slice(0, 2);
                }

              case "==":
              case "!=":
                if (!s && B(t.left, a)) {
                    t.left = pe(Un, t.left);
                } else if (a.option("typeofs") && t.left instanceof Pn && t.left.value == "undefined" && t.right instanceof wn && t.right.operator == "typeof") {
                    var f = t.right.expression;
                    if (f instanceof jn ? f.is_declared(a) : !(f instanceof mn && a.option("ie8"))) {
                        t.right = f;
                        t.left = pe(Ln, t.left).optimize(a);
                        if (t.operator.length == 2) t.operator += "=";
                    }
                } else if (t.left instanceof jn && t.right instanceof jn && t.left.definition() === t.right.definition() && q(t.left.fixed_value())) {
                    return pe(t.operator[0] == "=" ? Xn : Gn, t);
                }
                break;

              case "&&":
              case "||":
                var u = t.left;
                if (u.operator == t.operator) {
                    u = u.right;
                }
                if (u instanceof En && u.operator == (t.operator == "&&" ? "!==" : "===") && t.right instanceof En && u.operator == t.right.operator && (B(u.left, a) && t.right.left instanceof Un || u.left instanceof Un && B(t.right.left, a)) && !u.right.has_side_effects(a) && u.right.equivalent_to(t.right.right)) {
                    var c = pe(En, t, {
                        operator: u.operator.slice(0, -1),
                        left: pe(Un, t),
                        right: u.right
                    });
                    if (u !== t.left) {
                        c = pe(En, t, {
                            operator: t.operator,
                            left: t.left.left,
                            right: c
                        });
                    }
                    return c;
                }
                break;
            }
            var l = a.option("booleans") && a.in_boolean_context();
            if (l) switch (t.operator) {
              case "+":
                var p = t.left.evaluate(a);
                var h = t.right.evaluate(a);
                if (p && typeof p == "string") {
                    De.warn("+ in boolean context always true [{file}:{line},{col}]", t.start);
                    return U(t, [ t.right, pe(Xn, t) ]).optimize(a);
                }
                if (h && typeof h == "string") {
                    De.warn("+ in boolean context always true [{file}:{line},{col}]", t.start);
                    return U(t, [ t.left, pe(Xn, t) ]).optimize(a);
                }
                break;

              case "==":
                if (t.left instanceof Pn && t.left.value == "" && t.right.is_string(a)) {
                    return pe(wn, t, {
                        operator: "!",
                        expression: t.right
                    }).optimize(a);
                }
                break;

              case "!=":
                if (t.left instanceof Pn && t.left.value == "" && t.right.is_string(a)) {
                    return t.right.optimize(a);
                }
                break;
            }
            var d = a.parent();
            if (a.option("comparisons") && t.is_boolean(a)) {
                if (!(d instanceof En) || d instanceof kn) {
                    var v = pe(wn, t, {
                        operator: "!",
                        expression: t.negate(a, ke(a))
                    });
                    t = G(a, t, v);
                }
                switch (t.operator) {
                  case ">":
                    e("<");
                    break;

                  case ">=":
                    e("<=");
                    break;
                }
            }
            if (a.option("conditionals") && _e[t.operator] && t.right instanceof En && t.operator == t.right.operator) {
                n();
            }
            if (a.option("strings") && t.operator == "+") {
                if (t.right instanceof Pn && t.right.value == "" && t.left.is_string(a)) {
                    return t.left.optimize(a);
                }
                if (t.left instanceof Pn && t.left.value == "" && t.right.is_string(a)) {
                    return t.right.optimize(a);
                }
                if (t.left instanceof En && t.left.operator == "+" && t.left.left instanceof Pn && t.left.left.value == "" && t.right.is_string(a)) {
                    t.left = t.left.right;
                    return t.optimize(a);
                }
                if (t.right instanceof En && t.operator == t.right.operator && (t.left.is_string(a) && t.right.is_string(a) || t.right.left.is_string(a) && (t.left.is_constant() || !t.right.right.has_side_effects(a)))) {
                    n();
                }
            }
            if (a.option("evaluate")) {
                var _ = true;
                switch (t.operator) {
                  case "&&":
                    var p = D(t.left);
                    if (!p) {
                        De.warn("Condition left of && always false [{file}:{line},{col}]", t.start);
                        return he(a, d, a.self(), t.left).optimize(a);
                    } else if (!(p instanceof De)) {
                        De.warn("Condition left of && always true [{file}:{line},{col}]", t.start);
                        return U(t, [ t.left, t.right ]).optimize(a);
                    }
                    var h = t.right.evaluate(a);
                    if (!h) {
                        if (l) {
                            De.warn("Boolean && always false [{file}:{line},{col}]", t.start);
                            return U(t, [ t.left, pe(Gn, t) ]).optimize(a);
                        } else t.falsy = true;
                    } else if (!(h instanceof De)) {
                        if (l || d.operator == "&&" && d.left === a.self()) {
                            De.warn("Dropping side-effect-free && [{file}:{line},{col}]", t.start);
                            return t.left.optimize(a);
                        }
                    }
                    if (t.left.operator == "||") {
                        var m = t.left.right.evaluate(a, true);
                        if (!m) return pe(An, t, {
                            condition: t.left.left,
                            consequent: t.right,
                            alternative: t.left.right
                        }).optimize(a);
                    }
                    break;

                  case "||":
                    var p = D(t.left);
                    if (!p) {
                        De.warn("Condition left of || always false [{file}:{line},{col}]", t.start);
                        return U(t, [ t.left, t.right ]).optimize(a);
                    } else if (!(p instanceof De)) {
                        De.warn("Condition left of || always true [{file}:{line},{col}]", t.start);
                        return he(a, d, a.self(), t.left).optimize(a);
                    }
                    var h = t.right.evaluate(a);
                    if (!h) {
                        if (l || d.operator == "||" && d.left === a.self()) {
                            De.warn("Dropping side-effect-free || [{file}:{line},{col}]", t.start);
                            return t.left.optimize(a);
                        }
                    } else if (!(h instanceof De)) {
                        if (l) {
                            De.warn("Boolean || always true [{file}:{line},{col}]", t.start);
                            return U(t, [ t.left, pe(Xn, t) ]).optimize(a);
                        } else t.truthy = true;
                    }
                    if (t.left.operator == "&&") {
                        var m = t.left.right.is_truthy() || t.left.right.evaluate(a, true);
                        if (m && !(m instanceof De)) return pe(An, t, {
                            condition: t.left.left,
                            consequent: t.left.right,
                            alternative: t.right
                        }).optimize(a);
                    }
                    break;

                  case "+":
                    if (t.left instanceof Nn && t.right instanceof En && t.right.operator == "+" && t.right.left instanceof Nn && t.right.is_string(a)) {
                        t = pe(En, t, {
                            operator: "+",
                            left: pe(Pn, t.left, {
                                value: "" + t.left.value + t.right.left.value,
                                start: t.left.start,
                                end: t.right.left.end
                            }),
                            right: t.right.right
                        });
                    }
                    if (t.right instanceof Nn && t.left instanceof En && t.left.operator == "+" && t.left.right instanceof Nn && t.left.is_string(a)) {
                        t = pe(En, t, {
                            operator: "+",
                            left: t.left.left,
                            right: pe(Pn, t.right, {
                                value: "" + t.left.right.value + t.right.value,
                                start: t.left.right.start,
                                end: t.right.end
                            })
                        });
                    }
                    if (t.left instanceof En && t.left.operator == "+" && t.left.is_string(a) && t.left.right instanceof Nn && t.right instanceof En && t.right.operator == "+" && t.right.left instanceof Nn && t.right.is_string(a)) {
                        t = pe(En, t, {
                            operator: "+",
                            left: pe(En, t.left, {
                                operator: "+",
                                left: t.left.left,
                                right: pe(Pn, t.left.right, {
                                    value: "" + t.left.right.value + t.right.left.value,
                                    start: t.left.right.start,
                                    end: t.right.left.end
                                })
                            }),
                            right: t.right.right
                        });
                    }
                    if (t.right instanceof wn && t.right.operator == "-" && t.left.is_number(a)) {
                        t = pe(En, t, {
                            operator: "-",
                            left: t.left,
                            right: t.right.expression
                        });
                        break;
                    }
                    if (t.left instanceof wn && t.left.operator == "-" && i() && t.right.is_number(a)) {
                        t = pe(En, t, {
                            operator: "-",
                            left: t.right,
                            right: t.left.expression
                        });
                        break;
                    }
                    if (a.option("unsafe_math") && t.left instanceof En && it[t.left.operator] == it[t.operator] && t.right.is_constant() && (t.right.is_boolean(a) || t.right.is_number(a)) && t.left.is_number(a) && !t.left.right.is_constant() && (t.left.left.is_boolean(a) || t.left.left.is_number(a))) {
                        t = pe(En, t, {
                            operator: t.left.operator,
                            left: pe(En, t, {
                                operator: t.operator,
                                left: t.right,
                                right: t.left.left
                            }),
                            right: t.left.right
                        });
                        break;
                    }

                  case "-":
                    if (t.right instanceof wn && t.right.operator == "-" && t.left.is_number(a) && t.right.expression.is_number(a)) {
                        t = pe(En, t, {
                            operator: "+",
                            left: t.left,
                            right: t.right.expression
                        });
                        break;
                    }

                  case "*":
                  case "/":
                    _ = a.option("unsafe_math");
                    if (t.operator != "+") {
                        if (t.left instanceof wn && t.left.operator == "+") {
                            t.left = t.left.expression;
                        }
                        if (t.right instanceof wn && t.right.operator == "+") {
                            t.right = t.right.expression;
                        }
                    }

                  case "&":
                  case "|":
                  case "^":
                    if (t.operator != "-" && t.operator != "/" && (t.left.is_boolean(a) || t.left.is_number(a)) && (t.right.is_boolean(a) || t.right.is_number(a)) && i() && !(t.left instanceof En && t.left.operator != t.operator && it[t.left.operator] >= it[t.operator])) {
                        var g = pe(En, t, {
                            operator: t.operator,
                            left: t.right,
                            right: t.left
                        });
                        if (t.right instanceof Nn && !(t.left instanceof Nn)) {
                            t = G(a, g, t);
                        } else {
                            t = G(a, t, g);
                        }
                    }
                    if (!_ || !t.is_number(a)) break;
                    if (t.right instanceof En && t.right.operator != "%" && it[t.right.operator] == it[t.operator] && t.right.is_number(a) && (t.operator != "+" || t.right.left.is_boolean(a) || t.right.left.is_number(a)) && (t.operator != "-" || !t.left.is_negative_zero()) && (t.right.left.is_constant_expression() || !t.right.right.has_side_effects(a))) {
                        t = pe(En, t, {
                            operator: A(t.operator, t.right.operator),
                            left: pe(En, t.left, {
                                operator: t.operator,
                                left: t.left,
                                right: t.right.left,
                                start: t.left.start,
                                end: t.right.left.end
                            }),
                            right: t.right.right
                        });
                        if (t.operator == "+" && !t.right.is_boolean(a) && !t.right.is_number(a)) {
                            t.right = pe(wn, t.right, {
                                operator: "+",
                                expression: t.right
                            });
                        }
                    }
                    if (t.right instanceof Nn && t.left instanceof En && t.left.operator != "%" && it[t.left.operator] == it[t.operator] && t.left.is_number(a)) {
                        if (t.left.left instanceof Nn) {
                            var u = k(t.left, t.operator, t.left.left, t.right, t.left.left.start, t.right.end);
                            t = k(t, t.left.operator, u, t.left.right);
                        } else if (t.left.right instanceof Nn) {
                            var b = k(t.left, A(t.left.operator, t.operator), t.left.right, t.right, t.left.right.start, t.right.end);
                            if (t.left.operator != "-" || !t.right.value || b.evaluate(a) || !t.left.left.is_negative_zero()) {
                                t = k(t, t.left.operator, t.left.left, b);
                            }
                        }
                    }
                    break;
                }
                if (t.left instanceof Rn && !t.right.is_constant()) switch (t.operator) {
                  case "+":
                    if (t.left.value == 0) {
                        if (t.right.is_boolean(a)) return pe(wn, t, {
                            operator: "+",
                            expression: t.right
                        }).optimize(a);
                        if (t.right.is_number(a) && !t.right.is_negative_zero()) return t.right;
                    }
                    break;

                  case "*":
                    if (t.left.value == 1) {
                        return t.right.is_number(a) ? t.right : pe(wn, t, {
                            operator: "+",
                            expression: t.right
                        }).optimize(a);
                    }
                    break;
                }
                if (t.right instanceof Rn && !t.left.is_constant()) switch (t.operator) {
                  case "+":
                    if (t.right.value == 0) {
                        if (t.left.is_boolean(a)) return pe(wn, t, {
                            operator: "+",
                            expression: t.left
                        }).optimize(a);
                        if (t.left.is_number(a) && !t.left.is_negative_zero()) return t.left;
                    }
                    break;

                  case "-":
                    if (t.right.value == 0) {
                        return t.left.is_number(a) ? t.left : pe(wn, t, {
                            operator: "+",
                            expression: t.left
                        }).optimize(a);
                    }
                    break;

                  case "/":
                    if (t.right.value == 1) {
                        return t.left.is_number(a) ? t.left : pe(wn, t, {
                            operator: "+",
                            expression: t.left
                        }).optimize(a);
                    }
                    break;
                }
            }
            if (a.option("typeofs")) switch (t.operator) {
              case "&&":
                T(t.left, t.right, null);
                break;

              case "||":
                T(t.left, null, t.right);
                break;
            }
            if (a.option("unsafe")) {
                var y = F(t.right);
                if (l && y && (t.operator == "==" || t.operator == "!=") && t.left instanceof Rn && t.left.value == 0) {
                    return (t.operator == "==" ? pe(wn, t, {
                        operator: "!",
                        expression: t.right
                    }) : t.right).optimize(a);
                }
                var w = F(t.left);
                if (a.option("comparisons") && C()) {
                    var x = pe(wn, t, {
                        operator: "!",
                        expression: pe(wn, t, {
                            operator: "~",
                            expression: w ? t.left : t.right
                        })
                    });
                    switch (t.operator) {
                      case "<":
                        if (w) break;

                      case "<=":
                      case "!=":
                        x = pe(wn, t, {
                            operator: "!",
                            expression: x
                        });
                        break;
                    }
                    return x.optimize(a);
                }
            }
            return X(a, t);
            function E(e) {
                if (e instanceof gn) return E(e.expression);
                if (e instanceof bn) return E(e.expression) && E(e.property);
                if (e instanceof Sn) return true;
                return !e.has_side_effects(a);
            }
            function A(e, n) {
                switch (e) {
                  case "-":
                    return n == "+" ? "-" : "+";

                  case "/":
                    return n == "*" ? "/" : "*";

                  default:
                    return n;
                }
            }
            function k(e, n, t, i, r, o) {
                if (n == "+") {
                    if (!t.is_boolean(a) && !t.is_number(a)) {
                        t = pe(wn, t, {
                            operator: "+",
                            expression: t
                        });
                    }
                    if (!i.is_boolean(a) && !i.is_number(a)) {
                        i = pe(wn, i, {
                            operator: "+",
                            expression: i
                        });
                    }
                }
                return pe(En, e, {
                    operator: n,
                    left: t,
                    right: i,
                    start: r,
                    end: o
                });
            }
            function D(e) {
                if (e.truthy) return true;
                if (e.falsy) return false;
                if (e.is_truthy()) return true;
                return e.evaluate(a, true);
            }
            function F(e) {
                return e instanceof dn && e.expression instanceof gn && $[e.expression.property];
            }
            function C() {
                switch (t.operator) {
                  case "<=":
                    return y && t.left instanceof Rn && t.left.value == 0;

                  case "<":
                    if (w && t.right instanceof Rn && t.right.value == 0) return true;

                  case "==":
                  case "!=":
                    if (!y) return false;
                    return t.left instanceof Rn && t.left.value == -1 || t.left instanceof wn && t.left.operator == "-" && t.left.expression instanceof Rn && t.left.expression.value == 1;
                }
            }
        });
        function ee(e, n) {
            var t;
            for (var i = 0; t = e.parent(i); i++) {
                if (t instanceof Le) {
                    var r = t.name;
                    if (r && r.definition() === n) break;
                }
            }
            return t;
        }
        e(jn, function(e, n) {
            if (!n.option("ie8") && W(e) && !(e.scope.uses_with && n.find_parent(Ie))) {
                switch (e.name) {
                  case "undefined":
                    return pe(Ln, e).optimize(n);

                  case "NaN":
                    return pe(Yn, e).optimize(n);

                  case "Infinity":
                    return pe(Wn, e).optimize(n);
                }
            }
            var t = n.parent();
            if (n.option("reduce_vars") && ge(n.self(), t) !== n.self()) {
                var i = e.definition();
                var r = e.fixed_value();
                var o = i.single_use && !(t instanceof dn && t.is_expr_pure(n));
                if (o) {
                    if (r instanceof Le) {
                        if ((i.scope !== e.scope || i.in_loop) && (!n.option("reduce_funcs") || i.escaped.depth == 1 || r.inlined)) {
                            o = false;
                        } else if (ee(n, i)) {
                            o = false;
                        } else if (i.scope !== e.scope || i.orig[0] instanceof zn) {
                            o = r.is_constant_expression(e.scope);
                            if (o == "f") {
                                var a = e.scope;
                                do {
                                    if (a instanceof Je || a instanceof We) {
                                        a.inlined = true;
                                    }
                                } while (a = a.parent_scope);
                            }
                        } else if (n.option("ie8") && r.name && i !== r.name.definition()) {
                            o = false;
                        }
                        if (o) r.parent_scope = e.scope;
                    } else if (!r || !r.is_constant_expression()) {
                        o = false;
                    }
                }
                if (o) {
                    i.single_use = false;
                    r._squeezed = true;
                    r.single_use = true;
                    if (r instanceof Je) {
                        r = pe(We, r, r);
                        r.name = pe(Mn, r.name, r.name);
                    }
                    if (r instanceof Le) {
                        var a = e.scope;
                        r.enclosed.forEach(function(e) {
                            if (r.variables.has(e.name)) return;
                            if (a.var_names()[e.name]) return;
                            a.enclosed.push(e);
                            a.var_names()[e.name] = true;
                        });
                    }
                    var s;
                    if (i.recursive_refs > 0) {
                        s = r.clone(true);
                        var f = s.name.definition();
                        var u = s.variables.get(s.name.name);
                        var c = u && u.orig[0];
                        if (!(c instanceof Mn)) {
                            c = pe(Mn, s.name, s.name);
                            c.scope = s;
                            s.name = c;
                            u = s.def_function(c);
                            u.recursive_refs = i.recursive_refs;
                        }
                        s.walk(new Kn(function(e) {
                            if (!(e instanceof jn)) return;
                            var n = e.definition();
                            if (n === f) {
                                e.thedef = u;
                                u.references.push(e);
                            } else {
                                n.single_use = false;
                                var t = e.fixed_value();
                                if (!(t instanceof Le)) return;
                                if (!t.name) return;
                                if (t.name.definition() !== n) return;
                                if (n.scope !== t.name.scope) return;
                                if (r.variables.get(t.name.name) !== n) return;
                                t.name = t.name.clone();
                                var i = s.variables.get(t.name.name) || s.def_function(t.name);
                                e.thedef = i;
                                i.references.push(e);
                            }
                        }));
                    } else {
                        s = r.optimize(n);
                        if (s === r) s = s.transform(new at(function(e, n) {
                            if (e instanceof Ue) return e;
                            e = e.clone();
                            n(e, this);
                            return e;
                        }));
                    }
                    i.replaced++;
                    return s;
                }
                if (r && i.should_replace === undefined) {
                    var l;
                    if (r instanceof Hn) {
                        if (!(i.orig[0] instanceof zn) && g(i)) {
                            l = r;
                        }
                    } else {
                        var p = r.evaluate(n, true);
                        if (p !== r && typeof p != "function" && (typeof p != "object" || p instanceof RegExp && n.option("unsafe_regexp") && !i.cross_loop && g(i))) {
                            l = E(p, r);
                        }
                    }
                    if (l) {
                        var h = l.optimize(n).print_to_string().length;
                        var d;
                        if (b(r)) {
                            d = function() {
                                var e = l.optimize(n);
                                return e === l ? e.clone(true) : e;
                            };
                        } else {
                            h = Math.min(h, r.print_to_string().length);
                            d = function() {
                                var e = k(l.optimize(n), r);
                                return e === l || e === r ? e.clone(true) : e;
                            };
                        }
                        var v = i.name.length;
                        if (n.option("unused") && !n.exposed(i)) {
                            var _ = i.references.length - i.replaced;
                            v += (v + 2 + h) / (_ - i.assignments);
                        }
                        var m = h - Math.floor(v);
                        i.should_replace = m < n.eval_threshold ? d : false;
                    } else {
                        i.should_replace = false;
                    }
                }
                if (i.should_replace) {
                    var s = i.should_replace();
                    i.replaced++;
                    return s;
                }
            }
            return e;
            function g(e) {
                var n = e.scope.resolve();
                return Ee(e.references, function(e) {
                    return n === e.scope.resolve();
                });
            }
            function b(e) {
                var n;
                e.walk(new Kn(function(e) {
                    if (e instanceof jn) n = true;
                    if (n) return true;
                }));
                return n;
            }
        });
        function j(e, n) {
            return e instanceof jn || e.TYPE === n.TYPE;
        }
        e(Ln, function(e, n) {
            if (n.option("unsafe_undefined")) {
                var t = o(n, "undefined");
                if (t) {
                    var i = pe(jn, e, {
                        name: "undefined",
                        scope: t.scope,
                        thedef: t
                    });
                    i.is_undefined = true;
                    return i;
                }
            }
            var r = ge(n.self(), n.parent());
            if (r && j(r, e)) return e;
            return pe(wn, e, {
                operator: "void",
                expression: pe(Rn, e, {
                    value: 0
                })
            });
        });
        e(Wn, function(e, n) {
            var t = ge(n.self(), n.parent());
            if (t && j(t, e)) return e;
            if (n.option("keep_infinity") && !(t && !j(t, e)) && !o(n, "Infinity")) return e;
            return pe(En, e, {
                operator: "/",
                left: pe(Rn, e, {
                    value: 1
                }),
                right: pe(Rn, e, {
                    value: 0
                })
            });
        });
        e(Yn, function(e, n) {
            var t = ge(n.self(), n.parent());
            if (t && !j(t, e) || o(n, "NaN")) {
                return pe(En, e, {
                    operator: "/",
                    left: pe(Rn, e, {
                        value: 0
                    }),
                    right: pe(Rn, e, {
                        value: 0
                    })
                });
            }
            return e;
        });
        function ne(t, n) {
            var i = false;
            var r = new Kn(function(e) {
                if (i) return true;
                if (e instanceof jn && be(e.definition(), n)) {
                    return i = true;
                }
            });
            var o = new Kn(function(e) {
                if (i) return true;
                if (e instanceof Ue && e !== t) {
                    var n = o.parent();
                    if (n instanceof dn && n.expression === e) return;
                    e.walk(r);
                    return true;
                }
            });
            t.walk(o);
            return i;
        }
        var H = se("+ - * / % >> << >>> | ^ &");
        var N = se("* | ^ &");
        e(kn, function(o, a) {
            if (a.option("dead_code")) {
                if (o.left instanceof mn) {
                    if (o.operator == "=") {
                        if (o.left.equivalent_to(o.right) && (o.left instanceof gn || !o.left.property.has_side_effects(a))) {
                            return o.right;
                        }
                        var e = o.left.expression;
                        if (e instanceof Le || !a.has_directive("use strict") && e instanceof Nn && !e.may_throw_on_access(a)) {
                            return o.left instanceof gn ? o.right : U(o, [ o.left.property, o.right ]).optimize(a);
                        }
                    }
                } else if (o.left instanceof jn) {
                    if (o.operator == "=" && o.left.equivalent_to(o.right)) return o.right;
                    if (o.left.is_immutable()) return p();
                    var n = o.left.definition();
                    var s = n.scope.resolve();
                    var t = s === a.find_parent(Le);
                    var i = 0, r, f = o;
                    do {
                        r = f;
                        f = a.parent(i++);
                        if (f instanceof kn) {
                            if (f.left instanceof mn) break;
                            if (!(f.left instanceof jn)) continue;
                            if (f.left.definition() !== n) continue;
                            if (l(i, f)) break;
                            n.fixed = false;
                            return p();
                        } else if (f instanceof Xe) {
                            if (!t) break;
                            if (l(i, f)) break;
                            if (ne(s, [ n ])) break;
                            n.fixed = false;
                            return p();
                        } else if (f instanceof hn) {
                            if (f.name.definition() !== n) continue;
                            if (l(i, f)) break;
                            n.fixed = false;
                            return p();
                        }
                    } while (f instanceof En && f.right === r || f instanceof _n && f.tail_node() === r || f instanceof wn);
                }
            }
            if (a.option("sequences")) {
                var u = o.lift_sequences(a);
                if (u !== o) return u.optimize(a);
            }
            if (!a.option("assignments")) return o;
            if (o.operator == "=" && o.left instanceof jn && o.right instanceof En) {
                if (o.right.left instanceof jn && o.right.left.name == o.left.name && H[o.right.operator]) {
                    o.operator = o.right.operator + "=";
                    o.right = o.right.right;
                } else if (o.right.right instanceof jn && o.right.right.name == o.left.name && N[o.right.operator] && !o.right.left.has_side_effects(a)) {
                    o.operator = o.right.operator + "=";
                    o.right = o.right.left;
                }
            }
            if ((o.operator == "-=" || o.operator == "+=" && (o.left.is_boolean(a) || o.left.is_number(a))) && o.right instanceof Rn && o.right.value == 1) {
                var c = o.operator.slice(0, -1);
                return pe(wn, o, {
                    operator: c + c,
                    expression: o.left
                });
            }
            return o;
            function l(e, n) {
                var t = o.right;
                o.right = pe(Un, t);
                var i = n.may_throw(a);
                o.right = t;
                var r;
                while (r = a.parent(e++)) {
                    if (r === s) return false;
                    if (r instanceof fn) {
                        if (r.bfinally) return true;
                        if (i && r.bcatch) return true;
                    }
                }
            }
            function p() {
                return (o.operator != "=" ? pe(En, o, {
                    operator: o.operator.slice(0, -1),
                    left: o.left,
                    right: o.right
                }) : he(a, a.parent(), o, o.right)).optimize(a);
            }
        });
        e(An, function(e, n) {
            if (!n.option("conditionals")) return e;
            if (e.condition instanceof _n) {
                var t = e.condition.expressions.slice();
                e.condition = t.pop();
                t.push(e);
                return U(e, t);
            }
            var i = e.condition.is_truthy() || e.condition.evaluate(n, true);
            if (!i) {
                De.warn("Condition always false [{file}:{line},{col}]", e.start);
                return U(e, [ e.condition, e.alternative ]).optimize(n);
            } else if (!(i instanceof De)) {
                De.warn("Condition always true [{file}:{line},{col}]", e.start);
                return U(e, [ e.condition, e.consequent ]).optimize(n);
            }
            var r = i.negate(n, ke(n));
            if (G(n, i, r) === r) {
                e = pe(An, e, {
                    condition: r,
                    consequent: e.alternative,
                    alternative: e.consequent
                });
                r = i;
                i = e.condition;
            }
            var o = e.consequent;
            var a = e.alternative;
            if (i instanceof jn && o instanceof jn && i.definition() === o.definition()) {
                return pe(En, e, {
                    operator: "||",
                    left: i,
                    right: a
                });
            }
            var s = o.tail_node();
            if (s instanceof kn) {
                var f = s.operator == "=";
                var u = f ? a.tail_node() : a;
                if ((f || o === s) && u instanceof kn && s.operator == u.operator && s.left.equivalent_to(u.left) && (f && s.left instanceof jn || !i.has_side_effects(n) && m(o) && m(a))) {
                    return pe(kn, e, {
                        operator: s.operator,
                        left: s.left,
                        right: pe(An, e, {
                            condition: i,
                            consequent: g(o),
                            alternative: g(a)
                        })
                    });
                }
            }
            if (o.equivalent_to(a)) return U(e, [ i, o ]).optimize(n);
            if (o instanceof dn && a.TYPE === o.TYPE && o.args.length == a.args.length) {
                var c = _();
                if (c == -1 && !(o.expression instanceof mn) && !(a.expression instanceof mn)) {
                    var l = o.clone();
                    l.expression = pe(An, e, {
                        condition: i,
                        consequent: o.expression,
                        alternative: a.expression
                    });
                    return l;
                }
                if (c >= 0 && o.expression.equivalent_to(a.expression) && !i.has_side_effects(n) && !o.expression.has_side_effects(n)) {
                    var l = o.clone();
                    l.args[c] = pe(An, e, {
                        condition: i,
                        consequent: o.args[c],
                        alternative: a.args[c]
                    });
                    return l;
                }
            }
            if (o instanceof An && o.alternative.equivalent_to(a)) {
                return pe(An, e, {
                    condition: pe(En, e, {
                        left: i,
                        operator: "&&",
                        right: o.condition
                    }),
                    consequent: o.consequent,
                    alternative: a
                });
            }
            if (o instanceof An && o.consequent.equivalent_to(a)) {
                return pe(An, e, {
                    condition: pe(En, e, {
                        left: r,
                        operator: "||",
                        right: o.condition
                    }),
                    consequent: a,
                    alternative: o.alternative
                });
            }
            if (a instanceof An && o.equivalent_to(a.consequent)) {
                return pe(An, e, {
                    condition: pe(En, e, {
                        left: i,
                        operator: "||",
                        right: a.condition
                    }),
                    consequent: o,
                    alternative: a.alternative
                });
            }
            if (a instanceof An && o.equivalent_to(a.alternative)) {
                return pe(An, e, {
                    condition: pe(En, e, {
                        left: r,
                        operator: "&&",
                        right: a.condition
                    }),
                    consequent: a.consequent,
                    alternative: o
                });
            }
            if ((o instanceof _n || a instanceof _n) && o.tail_node().equivalent_to(a.tail_node())) {
                return U(e, [ pe(An, e, {
                    condition: i,
                    consequent: b(o),
                    alternative: b(a)
                }), o.tail_node() ]).optimize(n);
            }
            if (o instanceof En && o.operator == "&&" && o.right.equivalent_to(a)) {
                return pe(En, e, {
                    operator: "&&",
                    left: pe(En, e, {
                        operator: "||",
                        left: r,
                        right: o.left
                    }),
                    right: a
                }).optimize(n);
            }
            if (o instanceof En && o.operator == "||" && o.right.equivalent_to(a)) {
                return pe(En, e, {
                    operator: "||",
                    left: pe(En, e, {
                        operator: "&&",
                        left: i,
                        right: o.left
                    }),
                    right: a
                }).optimize(n);
            }
            if (a instanceof En && a.operator == "&&" && a.right.equivalent_to(o)) {
                return pe(En, e, {
                    operator: "&&",
                    left: pe(En, e, {
                        operator: "||",
                        left: i,
                        right: a.left
                    }),
                    right: o
                }).optimize(n);
            }
            if (a instanceof En && a.operator == "||" && a.right.equivalent_to(o)) {
                return pe(En, e, {
                    operator: "||",
                    left: pe(En, e, {
                        operator: "&&",
                        left: r,
                        right: a.left
                    }),
                    right: o
                }).optimize(n);
            }
            var p = n.option("booleans") && n.in_boolean_context();
            if (d(o)) {
                if (v(a)) {
                    return h(i);
                }
                return pe(En, e, {
                    operator: "||",
                    left: h(i),
                    right: a
                });
            }
            if (v(o)) {
                if (d(a)) {
                    return h(i.negate(n));
                }
                return pe(En, e, {
                    operator: "&&",
                    left: h(i.negate(n)),
                    right: a
                });
            }
            if (d(a)) {
                return pe(En, e, {
                    operator: "||",
                    left: h(i.negate(n)),
                    right: o
                });
            }
            if (v(a)) {
                return pe(En, e, {
                    operator: "&&",
                    left: h(i),
                    right: o
                });
            }
            if (n.option("typeofs")) T(i, o, a);
            return e;
            function h(e) {
                if (e.is_boolean(n)) return e;
                return pe(wn, e, {
                    operator: "!",
                    expression: e.negate(n)
                });
            }
            function d(e) {
                return e instanceof Xn || p && e instanceof Nn && e.value || e instanceof wn && e.operator == "!" && e.expression instanceof Nn && !e.expression.value;
            }
            function v(e) {
                return e instanceof Gn || p && (e instanceof Nn && !e.value || e instanceof wn && e.operator == "void" && !e.expression.has_side_effects(n)) || e instanceof wn && e.operator == "!" && e.expression instanceof Nn && e.expression.value;
            }
            function _() {
                var e = o.args;
                var n = a.args;
                for (var t = 0, i = e.length; t < i; t++) {
                    if (!e[t].equivalent_to(n[t])) {
                        for (var r = t + 1; r < i; r++) {
                            if (!e[r].equivalent_to(n[r])) return -2;
                        }
                        return t;
                    }
                }
                return -1;
            }
            function m(e) {
                return e === e.tail_node() || Ee(e.expressions.slice(0, -1), function(e) {
                    return !e.has_side_effects(n);
                });
            }
            function g(e) {
                if (!(e instanceof _n)) return e.right;
                var n = e.expressions.slice();
                n.push(n.pop().right);
                return U(e, n);
            }
            function b(e) {
                if (!(e instanceof _n)) return pe(Rn, e, {
                    value: 0
                });
                return U(e, e.expressions.slice(0, -1));
            }
        });
        e(Jn, function(e, n) {
            if (!n.option("booleans")) return e;
            if (n.in_boolean_context()) return pe(Rn, e, {
                value: +e.value
            });
            var t = n.parent();
            if (t instanceof En && (t.operator == "==" || t.operator == "!=")) {
                De.warn("Non-strict equality against boolean: {operator} {value} [{file}:{line},{col}]", {
                    operator: t.operator,
                    value: e.value,
                    file: t.start.file,
                    line: t.start.line,
                    col: t.start.col
                });
                return pe(Rn, e, {
                    value: +e.value
                });
            }
            return pe(wn, e, {
                operator: "!",
                expression: pe(Rn, e, {
                    value: 1 - e.value
                })
            });
        });
        function P(e, n) {
            if (e instanceof jn) {
                e = e.fixed_value();
            }
            if (!e) return false;
            if (!(e instanceof Le)) return true;
            var t = n.parent();
            if (t.TYPE != "Call") return true;
            if (t.expression !== n.self()) return true;
            return !e.contains_this();
        }
        e(bn, function(e, t) {
            var n = e.expression;
            var i = e.property;
            if (t.option("properties")) {
                var r = i.evaluate(t);
                if (r !== i) {
                    if (typeof r == "string") {
                        if (r == "undefined") {
                            r = undefined;
                        } else {
                            var o = parseFloat(r);
                            if (o.toString() == r) {
                                r = o;
                            }
                        }
                    }
                    i = e.property = k(i, E(r, i).transform(t));
                    var a = "" + r;
                    if (Qn(a) && a.length <= i.print_to_string().length + 1) {
                        return pe(gn, e, {
                            expression: n,
                            property: a
                        }).optimize(t);
                    }
                }
            }
            var s = t.parent();
            var f, u, c;
            if (t.option("arguments") && n instanceof jn && ce(f = n.definition()) && i instanceof Rn && (u = n.scope) === x()) {
                var l = i.value;
                if (s instanceof wn && s.operator == "delete") {
                    if (!f.deleted) f.deleted = [];
                    f.deleted[l] = true;
                }
                var p = u.argnames[l];
                if (f.deleted && f.deleted[l]) {
                    p = null;
                } else if (p && t.has_directive("use strict")) {
                    var h = p.definition();
                    if (!t.option("reduce_vars") || f.reassigned || h.assignments || h.orig.length > 1) {
                        p = null;
                    }
                } else if (!p && l < u.argnames.length + 5 && t.drop_fargs(u, c)) {
                    while (l >= u.argnames.length) {
                        p = pe(zn, u, {
                            name: u.make_var_name("argument_" + u.argnames.length),
                            scope: u
                        });
                        u.argnames.push(p);
                        u.enclosed.push(u.def_variable(p));
                    }
                }
                if (p && te(function(e) {
                    return e.name === p.name;
                }, u.argnames) === p) {
                    f.reassigned = false;
                    var d = pe(jn, e, p);
                    d.reference({});
                    delete p.__unused;
                    return d;
                }
            }
            if (ge(t.self(), s)) return e;
            if (t.option("sequences") && t.parent().TYPE != "Call") {
                var v = Q(e, t);
                if (v !== e) return v.optimize(t);
            }
            if (r !== i) {
                var _ = e.flatten_object(a, t);
                if (_) {
                    n = e.expression = _.expression;
                    i = e.property = _.property;
                }
            }
            if (t.option("properties") && t.option("side_effects") && i instanceof Rn && n instanceof Dn) {
                var l = i.value;
                var m = n.elements;
                var g = m[l];
                if (P(g, t)) {
                    var b = true;
                    var y = [];
                    for (var w = m.length; --w > l; ) {
                        var o = m[w].drop_side_effect_free(t);
                        if (o) {
                            y.unshift(o);
                            if (b && o.has_side_effects(t)) b = false;
                        }
                    }
                    g = g instanceof Vn ? pe(Ln, g) : g;
                    if (!b) y.unshift(g);
                    while (--w >= 0) {
                        var o = m[w].drop_side_effect_free(t);
                        if (o) y.unshift(o); else l--;
                    }
                    if (b) {
                        y.push(g);
                        return U(e, y).optimize(t);
                    } else return pe(bn, e, {
                        expression: pe(Dn, n, {
                            elements: y
                        }),
                        property: pe(Rn, i, {
                            value: l
                        })
                    });
                }
            }
            return X(t, e);
            function x() {
                var e = 0, n;
                while (n = t.parent(e++)) {
                    if (n instanceof Le) {
                        c = t.parent(e);
                        return n;
                    }
                }
            }
        });
        Ue.DEFMETHOD("contains_this", function() {
            var n;
            var t = this;
            t.walk(new Kn(function(e) {
                if (n) return true;
                if (e instanceof Hn) return n = true;
                if (e !== t && e instanceof Ue) return true;
            }));
            return n;
        });
        mn.DEFMETHOD("flatten_object", function(e, n) {
            if (!n.option("properties")) return;
            var t = this.expression;
            if (t instanceof Fn) {
                var i = t.properties;
                for (var r = i.length; --r >= 0; ) {
                    var o = i[r];
                    if ("" + o.key == e) {
                        if (!Ee(i, function(e) {
                            return e instanceof Bn;
                        })) break;
                        if (!P(o.value, n)) break;
                        return pe(bn, this, {
                            expression: pe(Dn, t, {
                                elements: i.map(function(e) {
                                    return e.value;
                                })
                            }),
                            property: pe(Rn, this, {
                                value: r
                            })
                        });
                    }
                }
            }
        });
        e(gn, function(e, n) {
            if (e.property == "arguments" || e.property == "caller") {
                De.warn("Function.prototype.{prop} not supported [{file}:{line},{col}]", {
                    prop: e.property,
                    file: e.start.file,
                    line: e.start.line,
                    col: e.start.col
                });
            }
            if (ge(n.self(), n.parent())) return e;
            if (n.option("sequences") && n.parent().TYPE != "Call") {
                var t = Q(e, n);
                if (t !== e) return t.optimize(n);
            }
            if (n.option("unsafe_proto") && e.expression instanceof gn && e.expression.property == "prototype") {
                var i = e.expression.expression;
                if (W(i)) switch (i.name) {
                  case "Array":
                    e.expression = pe(Dn, e.expression, {
                        elements: []
                    });
                    break;

                  case "Function":
                    e.expression = pe(We, e.expression, {
                        argnames: [],
                        body: []
                    });
                    break;

                  case "Number":
                    e.expression = pe(Rn, e.expression, {
                        value: 0
                    });
                    break;

                  case "Object":
                    e.expression = pe(Fn, e.expression, {
                        properties: []
                    });
                    break;

                  case "RegExp":
                    e.expression = pe(In, e.expression, {
                        value: /t/
                    });
                    break;

                  case "String":
                    e.expression = pe(Pn, e.expression, {
                        value: ""
                    });
                    break;
                }
            }
            var r = e.flatten_object(e.property, n);
            if (r) return r.optimize(n);
            return X(n, e);
        });
        e(Fn, function(t, n) {
            if (!n.option("objects") || n.has_directive("use strict")) return t;
            var i = new Ae();
            var r = [];
            t.properties.forEach(function(e) {
                if (typeof e.key != "string") {
                    o();
                    r.push(e);
                    return;
                }
                if (e.value.has_side_effects(n)) {
                    o();
                }
                i.add(e.key, e.value);
            });
            o();
            if (t.properties.length != r.length) {
                return pe(Fn, t, {
                    properties: r
                });
            }
            return t;
            function o() {
                i.each(function(e, n) {
                    r.push(pe(Bn, t, {
                        key: n,
                        value: U(t, e)
                    }));
                });
                i = new Ae();
            }
        });
        e(Ke, function(e, n) {
            if (e.value && B(e.value, n)) {
                e.value = null;
            }
            return e;
        });
    })(function(e, i) {
        e.DEFMETHOD("optimize", function(e) {
            var n = this;
            if (n._optimized) return n;
            if (e.has_directive("use asm")) return n;
            var t = i(n, e);
            t._optimized = true;
            return t;
        });
    });
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    var A = e("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/");
    var k = A.reduce(function(e, n, t) {
        e[n] = t;
        return e;
    }, Object.create(null));
    function D(e, n) {
        var t = 0;
        var i = 0;
        for (var r = 0, o = 0; r < n.length; r++) {
            var a = k[n[r]];
            t += (a & 31) << i;
            if (a & 32) {
                i += 5;
            } else {
                e[o++] += t & 1 ? 2147483648 | -(t >> 1) : t >> 1;
                t = i = 0;
            }
        }
        return o;
    }
    function F(e) {
        var n = "";
        e = Math.abs(e) << 1 | e >>> 31;
        do {
            var t = e & 31;
            if (e >>>= 5) t |= 32;
            n += A[t];
        } while (e);
        return n;
    }
    function C() {
        var n = Object.create(null);
        var t = [];
        t.index = function(e) {
            if (!fe(n, e)) {
                n[e] = t.length;
                t.push(e);
            }
            return n[e];
        };
        return t;
    }
    function B(l) {
        var f = C();
        var o = l.includeSources && Object.create(null);
        var u = C();
        var c = "";
        if (l.orig) Object.keys(l.orig).forEach(function(e) {
            var n = l.orig[e];
            var t = [ 0, 0, 1, 0, 0 ];
            l.orig[e] = {
                names: n.names,
                mappings: n.mappings.split(/;/).map(function(e) {
                    t[0] = 0;
                    return e.split(/,/).map(function(e) {
                        return t.slice(0, D(t, e));
                    });
                }),
                sources: n.sources
            };
            if (!o || !n.sourcesContent) return;
            for (var i = 0; i < n.sources.length; i++) {
                var r = n.sourcesContent[i];
                if (r) o[n.sources[i]] = r;
            }
        });
        var p;
        var h = 1;
        var d = 0;
        var v = 0;
        var _ = 1;
        var m = 0;
        var g = 0;
        return {
            add: l.orig ? function(e, n, t, i, r, o) {
                var a = l.orig[e];
                if (a) {
                    var s = a.mappings[i - 1];
                    if (!s) return;
                    var f;
                    for (var u = 0; u < s.length; u++) {
                        var c = s[u][0];
                        if (r >= c) f = s[u];
                        if (r <= c) break;
                    }
                    if (!f || f.length < 4) {
                        e = null;
                    } else {
                        e = a.sources[f[1]];
                        i = f[2];
                        r = f[3];
                        if (f.length > 4) o = a.names[f[4]];
                    }
                }
                b(e, n, t, i, r, o);
            } : b,
            setSourceContent: o ? function(e, n) {
                o[e] = n;
            } : re,
            toString: function() {
                return JSON.stringify({
                    version: 3,
                    file: l.filename || undefined,
                    sourceRoot: l.root || undefined,
                    sources: f,
                    sourcesContent: o ? f.map(function(e) {
                        return o[e] || null;
                    }) : undefined,
                    names: u,
                    mappings: c
                });
            }
        };
        function b(e, n, t, i, r, o) {
            if (p == null && e == null) return;
            p = e;
            if (h < n) {
                d = 0;
                do {
                    c += ";";
                } while (++h < n);
            } else if (c) {
                c += ",";
            }
            c += F(t - d);
            d = t;
            if (e == null) return;
            var a = f.index(e);
            c += F(a - v);
            v = a;
            c += F(i - _);
            _ = i;
            c += F(r - m);
            m = r;
            if (l.names && o != null) {
                var s = u.index(o);
                c += F(s - g);
                g = s;
            }
        }
    }
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    (function() {
        function n(e) {
            var n = true;
            for (var t = 0; t < e.length; t++) {
                if (n && e[t] instanceof Fe && e[t].body instanceof Pn) {
                    e[t] = new Be({
                        start: e[t].start,
                        end: e[t].end,
                        value: e[t].body.value
                    });
                } else if (n && !(e[t] instanceof Fe && e[t].body instanceof Pn)) {
                    n = false;
                }
            }
            return e;
        }
        var i = {
            Program: function(e) {
                return new Ye({
                    start: s(e),
                    end: f(e),
                    body: n(e.body.map(u))
                });
            },
            FunctionDeclaration: function(e) {
                return new Je({
                    start: s(e),
                    end: f(e),
                    name: u(e.id),
                    argnames: e.params.map(u),
                    body: n(u(e.body).body)
                });
            },
            FunctionExpression: function(e) {
                return new We({
                    start: s(e),
                    end: f(e),
                    name: u(e.id),
                    argnames: e.params.map(u),
                    body: n(u(e.body).body)
                });
            },
            ExpressionStatement: function(e) {
                return new Se({
                    start: s(e),
                    end: f(e),
                    body: u(e.expression)
                });
            },
            TryStatement: function(e) {
                var n = e.handlers || [ e.handler ];
                if (n.length > 1 || e.guardedHandlers && e.guardedHandlers.length) {
                    throw new Error("Multiple catch clauses are not supported.");
                }
                return new fn({
                    start: s(e),
                    end: f(e),
                    body: u(e.block).body,
                    bcatch: u(n[0]),
                    bfinally: e.finalizer ? new cn(u(e.finalizer)) : null
                });
            },
            Property: function(e) {
                var n = e.key;
                var t = {
                    start: s(n),
                    end: f(e.value),
                    key: "" + n[n.type == "Identifier" ? "name" : "value"],
                    value: u(e.value)
                };
                if (e.kind == "init") return new Bn(t);
                t.key = new le({
                    name: t.key
                });
                t.value = new Ve(t.value);
                if (e.kind == "get") return new ce(t);
                if (e.kind == "set") return new ue(t);
            },
            ArrayExpression: function(e) {
                return new Dn({
                    start: s(e),
                    end: f(e),
                    elements: e.elements.map(function(e) {
                        return e === null ? new Vn() : u(e);
                    })
                });
            },
            ObjectExpression: function(e) {
                return new Fn({
                    start: s(e),
                    end: f(e),
                    properties: e.properties.map(function(e) {
                        e.type = "Property";
                        return u(e);
                    })
                });
            },
            SequenceExpression: function(e) {
                return new _n({
                    start: s(e),
                    end: f(e),
                    expressions: e.expressions.map(u)
                });
            },
            MemberExpression: function(e) {
                return new (e.computed ? bn : gn)({
                    start: s(e),
                    end: f(e),
                    property: e.computed ? u(e.property) : e.property.name,
                    expression: u(e.object)
                });
            },
            SwitchCase: function(e) {
                return new (e.test ? sn : an)({
                    start: s(e),
                    end: f(e),
                    expression: u(e.test),
                    body: e.consequent.map(u)
                });
            },
            VariableDeclaration: function(e) {
                return new pn({
                    start: s(e),
                    end: f(e),
                    definitions: e.declarations.map(u)
                });
            },
            Literal: function(e) {
                var n = e.value, t = {
                    start: s(e),
                    end: f(e)
                };
                if (n === null) return new Un(t);
                var i = e.regex;
                if (i && i.pattern) {
                    t.value = new RegExp(i.pattern, i.flags);
                    t.value.raw_source = i.pattern;
                    return new In(t);
                } else if (i) {
                    t.value = e.regex && e.raw ? e.raw : n;
                    return new In(t);
                }
                switch (typeof n) {
                  case "string":
                    t.value = n;
                    return new Pn(t);

                  case "number":
                    t.value = n;
                    return new Rn(t);

                  case "boolean":
                    return new (n ? Xn : Gn)(t);
                }
            },
            Identifier: function(e) {
                var n = o[o.length - 2];
                return new (n.type == "LabeledStatement" ? pe : n.type == "VariableDeclarator" && n.id === e ? On : n.type == "FunctionExpression" ? n.id === e ? Mn : zn : n.type == "FunctionDeclaration" ? n.id === e ? $n : zn : n.type == "CatchClause" ? qn : n.type == "BreakStatement" || n.type == "ContinueStatement" ? he : jn)({
                    start: s(e),
                    end: f(e),
                    name: e.name
                });
            },
            ThisExpression: function(e) {
                return new Hn({
                    start: s(e),
                    end: f(e),
                    name: "this"
                });
            }
        };
        i.UpdateExpression = i.UnaryExpression = function e(n) {
            var t = "prefix" in n ? n.prefix : n.type == "UnaryExpression" ? true : false;
            return new (t ? wn : xn)({
                start: s(n),
                end: f(n),
                operator: n.operator,
                expression: u(n.argument)
            });
        };
        e("EmptyStatement", $e);
        e("BlockStatement", ze, "body@body");
        e("IfStatement", tn, "test>condition, consequent>body, alternate>alternative");
        e("LabeledStatement", Me, "label>label, body>body");
        e("BreakStatement", en, "label>label");
        e("ContinueStatement", nn, "label>label");
        e("WithStatement", Ie, "object>expression, body>body");
        e("SwitchStatement", rn, "discriminant>expression, cases@body");
        e("ReturnStatement", Ke, "argument>value");
        e("ThrowStatement", Qe, "argument>value");
        e("WhileStatement", Ne, "test>condition, body>body");
        e("DoWhileStatement", He, "test>condition, body>body");
        e("ForStatement", Pe, "init>init, test>condition, update>step, body>body");
        e("ForInStatement", Re, "left>init, right>object, body>body");
        e("DebuggerStatement", Ce);
        e("VariableDeclarator", hn, "id>name, init>value");
        e("CatchClause", un, "param>argname, body%body");
        e("BinaryExpression", En, "operator=operator, left>left, right>right");
        e("LogicalExpression", En, "operator=operator, left>left, right>right");
        e("AssignmentExpression", kn, "operator=operator, left>left, right>right");
        e("ConditionalExpression", An, "test>condition, consequent>consequent, alternate>alternative");
        e("NewExpression", vn, "callee>expression, arguments@args");
        e("CallExpression", dn, "callee>expression, arguments@args");
        c(Ye, function e(n) {
            return h("Program", n);
        });
        c(Je, function e(n) {
            return {
                type: "FunctionDeclaration",
                id: l(n.name),
                params: n.argnames.map(l),
                body: h("BlockStatement", n)
            };
        });
        c(We, function e(n) {
            return {
                type: "FunctionExpression",
                id: l(n.name),
                params: n.argnames.map(l),
                body: h("BlockStatement", n)
            };
        });
        c(Be, function e(n) {
            return {
                type: "ExpressionStatement",
                expression: {
                    type: "Literal",
                    value: n.value
                }
            };
        });
        c(Se, function e(n) {
            return {
                type: "ExpressionStatement",
                expression: l(n.body)
            };
        });
        c(on, function e(n) {
            return {
                type: "SwitchCase",
                test: l(n.expression),
                consequent: n.body.map(l)
            };
        });
        c(fn, function e(n) {
            return {
                type: "TryStatement",
                block: p(n),
                handler: l(n.bcatch),
                guardedHandlers: [],
                finalizer: l(n.bfinally)
            };
        });
        c(un, function e(n) {
            return {
                type: "CatchClause",
                param: l(n.argname),
                guard: null,
                body: p(n)
            };
        });
        c(ln, function e(n) {
            return {
                type: "VariableDeclaration",
                kind: "var",
                declarations: n.definitions.map(l)
            };
        });
        c(_n, function e(n) {
            return {
                type: "SequenceExpression",
                expressions: n.expressions.map(l)
            };
        });
        c(mn, function e(n) {
            var t = n instanceof bn;
            return {
                type: "MemberExpression",
                object: l(n.expression),
                computed: t,
                property: t ? l(n.property) : {
                    type: "Identifier",
                    name: n.property
                }
            };
        });
        c(yn, function e(n) {
            return {
                type: n.operator == "++" || n.operator == "--" ? "UpdateExpression" : "UnaryExpression",
                operator: n.operator,
                prefix: n instanceof wn,
                argument: l(n.expression)
            };
        });
        c(En, function e(n) {
            return {
                type: n.operator == "&&" || n.operator == "||" ? "LogicalExpression" : "BinaryExpression",
                left: l(n.left),
                operator: n.operator,
                right: l(n.right)
            };
        });
        c(Dn, function e(n) {
            return {
                type: "ArrayExpression",
                elements: n.elements.map(l)
            };
        });
        c(Fn, function e(n) {
            return {
                type: "ObjectExpression",
                properties: n.properties.map(l)
            };
        });
        c(Cn, function e(n) {
            var t = {
                type: "Literal",
                value: n.key instanceof le ? n.key.name : n.key
            };
            var i;
            if (n instanceof Bn) {
                i = "init";
            } else if (n instanceof ce) {
                i = "get";
            } else if (n instanceof ue) {
                i = "set";
            }
            return {
                type: "Property",
                kind: i,
                key: t,
                value: l(n.value)
            };
        });
        c(Sn, function e(n) {
            var t = n.definition();
            return {
                type: "Identifier",
                name: t && t.mangled_name || n.name
            };
        });
        c(Hn, function e() {
            return {
                type: "ThisExpression"
            };
        });
        c(In, function e(n) {
            var t = n.value.toString().match(/[gimuy]*$/)[0];
            var i = "/" + n.value.raw_source + "/" + t;
            return {
                type: "Literal",
                value: i,
                raw: i,
                regex: {
                    pattern: n.value.raw_source,
                    flags: t
                }
            };
        });
        c(Nn, function e(n) {
            var t = n.value;
            if (typeof t === "number" && (t < 0 || t === 0 && 1 / t < 0)) {
                return {
                    type: "UnaryExpression",
                    operator: "-",
                    prefix: true,
                    argument: {
                        type: "Literal",
                        value: -t,
                        raw: n.start.raw
                    }
                };
            }
            return {
                type: "Literal",
                value: t,
                raw: n.start.raw
            };
        });
        c(m, function e(n) {
            return {
                type: "Identifier",
                name: String(n.value)
            };
        });
        Jn.DEFMETHOD("to_mozilla_ast", Nn.prototype.to_mozilla_ast);
        Un.DEFMETHOD("to_mozilla_ast", Nn.prototype.to_mozilla_ast);
        Vn.DEFMETHOD("to_mozilla_ast", function e() {
            return null;
        });
        Oe.DEFMETHOD("to_mozilla_ast", ze.prototype.to_mozilla_ast);
        Le.DEFMETHOD("to_mozilla_ast", We.prototype.to_mozilla_ast);
        function r(e) {
            if (e.type == "Literal") {
                return e.raw != null ? e.raw : e.value + "";
            }
        }
        function s(e) {
            var n = e.loc, t = n && n.start;
            var i = e.range;
            return new Z({
                file: n && n.source,
                line: t && t.line,
                col: t && t.column,
                pos: i ? i[0] : e.start,
                endline: t && t.line,
                endcol: t && t.column,
                endpos: i ? i[0] : e.start,
                raw: r(e)
            });
        }
        function f(e) {
            var n = e.loc, t = n && n.end;
            var i = e.range;
            return new Z({
                file: n && n.source,
                line: t && t.line,
                col: t && t.column,
                pos: i ? i[1] : e.end,
                endline: t && t.line,
                endcol: t && t.column,
                endpos: i ? i[1] : e.end,
                raw: r(e)
            });
        }
        function e(e, n, t) {
            var o = "function From_Moz_" + e + "(M){\n";
            o += "return new U2." + n.name + "({\n" + "start: my_start_token(M),\n" + "end: my_end_token(M)";
            var a = "function To_Moz_" + e + "(M){\n";
            a += "return {\n" + "type: " + JSON.stringify(e);
            if (t) t.split(/\s*,\s*/).forEach(function(e) {
                var n = /([a-z0-9$_]+)(=|@|>|%)([a-z0-9$_]+)/i.exec(e);
                if (!n) throw new Error("Can't understand property map: " + e);
                var t = n[1], i = n[2], r = n[3];
                o += ",\n" + r + ": ";
                a += ",\n" + t + ": ";
                switch (i) {
                  case "@":
                    o += "M." + t + ".map(from_moz)";
                    a += "M." + r + ".map(to_moz)";
                    break;

                  case ">":
                    o += "from_moz(M." + t + ")";
                    a += "to_moz(M." + r + ")";
                    break;

                  case "=":
                    o += "M." + t;
                    a += "M." + r;
                    break;

                  case "%":
                    o += "from_moz(M." + t + ").body";
                    a += "to_moz_block(M)";
                    break;

                  default:
                    throw new Error("Can't understand operator in propmap: " + e);
                }
            });
            o += "\n})\n}";
            a += "\n}\n}";
            o = new Function("U2", "my_start_token", "my_end_token", "from_moz", "return(" + o + ")")(d, s, f, u);
            a = new Function("to_moz", "to_moz_block", "to_moz_scope", "return(" + a + ")")(l, p, h);
            i[e] = o;
            c(n, a);
        }
        var o = null;
        function u(e) {
            o.push(e);
            var n = e != null ? i[e.type](e) : null;
            o.pop();
            return n;
        }
        De.from_mozilla_ast = function(e) {
            var n = o;
            o = [];
            var t = u(e);
            o = n;
            t.walk(new Kn(function(e) {
                if (e instanceof he) {
                    for (var n = 0, t; t = this.parent(n); n++) {
                        if (t instanceof Ue) break;
                        if (t instanceof Me && t.label.name == e.name) {
                            e.thedef = t.label;
                            break;
                        }
                    }
                    if (!e.thedef) {
                        var i = e.start;
                        _e("Undefined label " + e.name, i.file, i.line, i.col, i.pos);
                    }
                }
            }));
            return t;
        };
        function t(e, n, t) {
            var i = e.start;
            var r = e.end;
            if (i.pos != null && r.endpos != null) {
                n.range = [ i.pos, r.endpos ];
            }
            if (i.line) {
                n.loc = {
                    start: {
                        line: i.line,
                        column: i.col
                    },
                    end: r.endline ? {
                        line: r.endline,
                        column: r.endcol
                    } : null
                };
                if (i.file) {
                    n.loc.source = i.file;
                }
            }
            return n;
        }
        function c(e, n) {
            e.DEFMETHOD("to_mozilla_ast", function() {
                return t(this, n(this));
            });
        }
        function l(e) {
            return e != null ? e.to_mozilla_ast() : null;
        }
        function p(e) {
            return {
                type: "BlockStatement",
                body: e.body.map(l)
            };
        }
        function h(e, n) {
            var t = n.body.map(l);
            if (n.body[0] instanceof Se && n.body[0].body instanceof Pn) {
                t.unshift(l(new $e(n.body[0])));
            }
            return {
                type: e,
                body: t
            };
        }
    })();
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function S(n) {
        [ "null", "true", "false", "Infinity", "-Infinity", "undefined" ].forEach(t);
        [ Array, Boolean, Date, Error, Function, Math, Number, Object, RegExp, String ].forEach(function(e) {
            Object.getOwnPropertyNames(e).map(t);
            if (e.prototype) {
                Object.getOwnPropertyNames(e.prototype).map(t);
            }
        });
        function t(e) {
            v(n, e);
        }
    }
    function T(e, n) {
        e.walk(new Kn(function(e) {
            if (e instanceof Bn && e.quote) {
                t(e.key);
            } else if (e instanceof bn) {
                J(e.property, t);
            }
        }));
        function t(e) {
            v(n, e);
        }
    }
    function J(e, n) {
        e.walk(new Kn(function(e) {
            if (e instanceof _n) {
                J(e.tail_node(), n);
            } else if (e instanceof Pn) {
                n(e.value);
            } else if (e instanceof An) {
                J(e.consequent, n);
                J(e.alternative, n);
            }
            return true;
        }));
    }
    function G(e, n) {
        n = ie(n, {
            builtins: false,
            cache: null,
            debug: false,
            keep_quoted: false,
            only_cache: false,
            regex: null,
            reserved: null
        }, true);
        var t = n.reserved;
        if (!Array.isArray(t)) t = [];
        if (!n.builtins) S(t);
        var i = -1;
        var r;
        if (n.cache) {
            r = n.cache.props;
            r.each(function(e) {
                v(t, e);
            });
        } else {
            r = new Ae();
        }
        var o = n.regex;
        var a = n.debug !== false;
        var s;
        if (a) s = n.debug === true ? "" : n.debug;
        var f = [];
        var u = [];
        e.walk(new Kn(function(e) {
            if (e instanceof Bn) {
                p(e.key);
            } else if (e instanceof Cn) {
                p(e.key.name);
            } else if (e instanceof gn) {
                p(e.property);
            } else if (e instanceof bn) {
                J(e.property, p);
            } else if (e instanceof dn && e.expression.print_to_string() == "Object.defineProperty") {
                J(e.args[1], p);
            }
        }));
        return e.transform(new at(function(e) {
            if (e instanceof Bn) {
                e.key = h(e.key);
            } else if (e instanceof Cn) {
                e.key.name = h(e.key.name);
            } else if (e instanceof gn) {
                e.property = h(e.property);
            } else if (!n.keep_quoted && e instanceof bn) {
                e.property = d(e.property);
            } else if (e instanceof dn && e.expression.print_to_string() == "Object.defineProperty") {
                e.args[1] = d(e.args[1]);
            }
        }));
        function c(e) {
            if (u.indexOf(e) >= 0) return false;
            if (t.indexOf(e) >= 0) return false;
            if (n.only_cache) return r.has(e);
            if (/^-?[0-9]+(\.[0-9]+)?(e[+-][0-9]+)?$/.test(e)) return false;
            return true;
        }
        function l(e) {
            if (o && !o.test(e)) return false;
            if (t.indexOf(e) >= 0) return false;
            return r.has(e) || f.indexOf(e) >= 0;
        }
        function p(e) {
            if (c(e)) v(f, e);
            if (!l(e)) v(u, e);
        }
        function h(e) {
            if (!l(e)) {
                return e;
            }
            var n = r.get(e);
            if (!n) {
                if (a) {
                    var t = "_$" + e + "$" + s + "_";
                    if (c(t)) n = t;
                }
                if (!n) do {
                    n = E(++i);
                } while (!c(n));
                r.set(e, n);
            }
            return n;
        }
        function d(e) {
            return e.transform(new at(function(e) {
                if (e instanceof _n) {
                    var n = e.expressions.length - 1;
                    e.expressions[n] = d(e.expressions[n]);
                } else if (e instanceof Pn) {
                    e.value = h(e.value);
                } else if (e instanceof An) {
                    e.consequent = d(e.consequent);
                    e.alternative = d(e.alternative);
                }
                return e;
            }));
        }
    }
    "use strict";
    var X, K;
    if (typeof Buffer == "undefined") {
        X = atob;
        K = btoa;
    } else if (typeof Buffer.alloc == "undefined") {
        X = function(e) {
            return new Buffer(e, "base64").toString();
        };
        K = function(e) {
            return new Buffer(e).toString("base64");
        };
    } else {
        X = function(e) {
            return Buffer.from(e, "base64").toString();
        };
        K = function(e) {
            return Buffer.from(e).toString("base64");
        };
    }
    function ct(e, n) {
        var t = n.end.comments_after;
        for (var i = t.length; --i >= 0; ) {
            var r = t[i];
            if (r.type != "comment1") break;
            var o = /^# ([^\s=]+)=(\S+)\s*$/.exec(r.value);
            if (!o) break;
            if (o[1] == "sourceMappingURL") {
                o = /^data:application\/json(;.*?)?;base64,(\S+)$/.exec(o[2]);
                if (!o) break;
                return X(o[2]);
            }
        }
        De.warn("inline source map not found: " + e);
    }
    function lt(n) {
        try {
            return JSON.parse(n);
        } catch (e) {
            throw new Error("invalid input source map: " + n);
        }
    }
    function pt(n, t, e) {
        if (t[n]) {
            e.forEach(function(e) {
                if (t[e]) {
                    if (typeof t[e] != "object") t[e] = {};
                    if (!(n in t[e])) t[e][n] = t[n];
                }
            });
        }
    }
    function ht(e) {
        if (!e) return;
        if (!("props" in e)) {
            e.props = new Ae();
        } else if (!(e.props instanceof Ae)) {
            e.props = Ae.fromObject(e.props);
        }
    }
    function dt(e) {
        return {
            props: e.props.toObject()
        };
    }
    function vt(i, r) {
        try {
            r = ie(r, {
                compress: {},
                enclose: false,
                ie8: false,
                keep_fnames: false,
                mangle: {},
                nameCache: null,
                output: {},
                parse: {},
                rename: undefined,
                sourceMap: false,
                timings: false,
                toplevel: false,
                validate: false,
                warnings: false,
                wrap: false
            }, true);
            if (r.validate) De.enable_validation();
            var e = r.timings && {
                start: Date.now()
            };
            if (r.rename === undefined) {
                r.rename = r.compress && r.mangle;
            }
            pt("ie8", r, [ "compress", "mangle", "output" ]);
            pt("keep_fnames", r, [ "compress", "mangle" ]);
            pt("toplevel", r, [ "compress", "mangle" ]);
            var n;
            if (r.mangle) {
                r.mangle = ie(r.mangle, {
                    cache: r.nameCache && (r.nameCache.vars || {}),
                    eval: false,
                    ie8: false,
                    keep_fnames: false,
                    properties: false,
                    reserved: [],
                    toplevel: false
                }, true);
                if (r.mangle.properties) {
                    if (typeof r.mangle.properties != "object") {
                        r.mangle.properties = {};
                    }
                    if (r.mangle.properties.keep_quoted) {
                        n = r.mangle.properties.reserved;
                        if (!Array.isArray(n)) n = [];
                        r.mangle.properties.reserved = n;
                    }
                    if (r.nameCache && !("cache" in r.mangle.properties)) {
                        r.mangle.properties.cache = r.nameCache.props || {};
                    }
                }
                ht(r.mangle.cache);
                ht(r.mangle.properties.cache);
            }
            if (r.sourceMap) {
                r.sourceMap = ie(r.sourceMap, {
                    content: null,
                    filename: null,
                    includeSources: false,
                    names: true,
                    root: null,
                    url: null
                }, true);
            }
            var t = [];
            if (r.warnings) De.log_function(function(e) {
                t.push(e);
            }, r.warnings == "verbose");
            if (e) e.parse = Date.now();
            var o;
            if (i instanceof Ye) {
                o = i;
            } else {
                if (typeof i == "string") {
                    i = [ i ];
                }
                r.parse = r.parse || {};
                r.parse.toplevel = null;
                var a = r.sourceMap && r.sourceMap.content;
                if (typeof a == "string" && a != "inline") {
                    a = lt(a);
                }
                if (a) r.sourceMap.orig = Object.create(null);
                for (var s in i) if (fe(i, s)) {
                    r.parse.filename = s;
                    r.parse.toplevel = o = ot(i[s], r.parse);
                    if (a == "inline") {
                        var f = ct(s, o);
                        if (f) {
                            r.sourceMap.orig[s] = lt(f);
                        }
                    } else if (a) {
                        r.sourceMap.orig[s] = a;
                    }
                }
            }
            if (n) {
                T(o, n);
            }
            [ "enclose", "wrap" ].forEach(function(e) {
                var n = r[e];
                if (!n) return;
                var t = o.print_to_string().slice(0, -1);
                o = o[e](n);
                i[o.start.file] = o.print_to_string().replace(t, "");
            });
            if (e) e.rename = Date.now();
            if (r.rename) {
                o.figure_out_scope(r.mangle);
                o.expand_names(r.mangle);
            }
            if (e) e.compress = Date.now();
            if (r.compress) o = new ut(r.compress).compress(o);
            if (e) e.scope = Date.now();
            if (r.mangle) o.figure_out_scope(r.mangle);
            if (e) e.mangle = Date.now();
            if (r.mangle) {
                o.compute_char_frequency(r.mangle);
                o.mangle_names(r.mangle);
            }
            if (e) e.properties = Date.now();
            if (r.mangle && r.mangle.properties) {
                o = G(o, r.mangle.properties);
            }
            if (e) e.output = Date.now();
            var u = {};
            if (r.output.ast) {
                u.ast = o;
            }
            if (!fe(r.output, "code") || r.output.code) {
                if (r.sourceMap) {
                    r.output.source_map = B(r.sourceMap);
                    if (r.sourceMap.includeSources) {
                        if (i instanceof Ye) {
                            throw new Error("original source content unavailable");
                        } else for (var s in i) if (fe(i, s)) {
                            r.output.source_map.setSourceContent(s, i[s]);
                        }
                    }
                }
                delete r.output.ast;
                delete r.output.code;
                var c = ft(r.output);
                o.print(c);
                u.code = c.get();
                if (r.sourceMap) {
                    u.map = r.output.source_map.toString();
                    var l = r.sourceMap.url;
                    if (l) {
                        u.code = u.code.replace(/\n\/\/# sourceMappingURL=\S+\s*$/, "");
                        if (l == "inline") {
                            u.code += "\n//# sourceMappingURL=data:application/json;charset=utf-8;base64," + K(u.map);
                        } else {
                            u.code += "\n//# sourceMappingURL=" + l;
                        }
                    }
                }
            }
            if (r.nameCache && r.mangle) {
                if (r.mangle.cache) r.nameCache.vars = dt(r.mangle.cache);
                if (r.mangle.properties && r.mangle.properties.cache) {
                    r.nameCache.props = dt(r.mangle.properties.cache);
                }
            }
            if (e) {
                e.end = Date.now();
                u.timings = {
                    parse: .001 * (e.rename - e.parse),
                    rename: .001 * (e.compress - e.rename),
                    compress: .001 * (e.scope - e.compress),
                    scope: .001 * (e.mangle - e.scope),
                    mangle: .001 * (e.properties - e.mangle),
                    properties: .001 * (e.output - e.properties),
                    output: .001 * (e.end - e.output),
                    total: .001 * (e.end - e.start)
                };
            }
            if (t.length) {
                u.warnings = t;
            }
            return u;
        } catch (e) {
            return {
                error: e
            };
        } finally {
            De.disable_validation();
        }
    }
    d["Dictionary"] = Ae;
    d["List"] = we;
    d["minify"] = vt;
    d["parse"] = ot;
    d["push_uniq"] = v;
    d["TreeTransformer"] = at;
    d["TreeWalker"] = Kn;
})(typeof UglifyJS == "undefined" ? UglifyJS = {} : UglifyJS);
// @license-end
